/* book-view.c generated by valac 0.56.14, the Vala compiler
 * generated from book-view.vala, do not modify */

/*
 * Copyright (C) 2009-2015 Canonical Ltd.
 * Author: Robert Ancell <robert.ancell@canonical.com>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */
/* FIXME: When scrolling, copy existing render sideways?*/
/* FIXME: Only render pages that change and only the part that changed*/
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <float.h>
#include <math.h>
#include <string.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_BOOK_VIEW (book_view_get_type ())
#define BOOK_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOOK_VIEW, BookView))
#define BOOK_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOOK_VIEW, BookViewClass))
#define IS_BOOK_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOOK_VIEW))
#define IS_BOOK_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOOK_VIEW))
#define BOOK_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOOK_VIEW, BookViewClass))

typedef struct _BookView BookView;
typedef struct _BookViewClass BookViewClass;
typedef struct _BookViewPrivate BookViewPrivate;

#define TYPE_BOOK (book_get_type ())
#define BOOK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOOK, Book))
#define BOOK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOOK, BookClass))
#define IS_BOOK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOOK))
#define IS_BOOK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOOK))
#define BOOK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOOK, BookClass))

typedef struct _Book Book;
typedef struct _BookClass BookClass;

#define TYPE_PAGE (page_get_type ())
#define PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE, Page))
#define PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE, PageClass))
#define IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE))
#define IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE))
#define PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE, PageClass))

typedef struct _Page Page;
typedef struct _PageClass PageClass;

#define TYPE_PAGE_VIEW (page_view_get_type ())
#define PAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_VIEW, PageView))
#define PAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_VIEW, PageViewClass))
#define IS_PAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_VIEW))
#define IS_PAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_VIEW))
#define PAGE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_VIEW, PageViewClass))

typedef struct _PageView PageView;
typedef struct _PageViewClass PageViewClass;
enum  {
	BOOK_VIEW_0_PROPERTY,
	BOOK_VIEW_BOOK_PROPERTY,
	BOOK_VIEW_SELECTED_PAGE_PROPERTY,
	BOOK_VIEW_X_OFFSET_PROPERTY,
	BOOK_VIEW_NUM_PROPERTIES
};
static GParamSpec* book_view_properties[BOOK_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
enum  {
	BOOK_VIEW_PAGE_SELECTED_SIGNAL,
	BOOK_VIEW_SHOW_PAGE_SIGNAL,
	BOOK_VIEW_SHOW_MENU_SIGNAL,
	BOOK_VIEW_NUM_SIGNALS
};
static guint book_view_signals[BOOK_VIEW_NUM_SIGNALS] = {0};

struct _BookView {
	GtkBox parent_instance;
	BookViewPrivate * priv;
};

struct _BookViewClass {
	GtkBoxClass parent_class;
};

struct _BookViewPrivate {
	Book* _book;
	GHashTable* page_data;
	gboolean need_layout;
	gboolean laying_out;
	gboolean show_selected_page;
	PageView* selected_page_view;
	GtkWidget* drawing_area;
	GtkScrollbar* scroll;
	GtkAdjustment* adjustment;
	GdkCursorType cursor;
};

static gint BookView_private_offset;
static gpointer book_view_parent_class = NULL;

VALA_EXTERN GType book_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BookView, g_object_unref)
VALA_EXTERN GType book_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Book, g_object_unref)
VALA_EXTERN GType page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Page, g_object_unref)
VALA_EXTERN GType page_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PageView, g_object_unref)
VALA_EXTERN Book* book_view_get_book (BookView* self);
static void book_view_add_cb (BookView* self,
                       Book* book,
                       Page* page);
static void _book_view_add_cb_book_page_added (Book* _sender,
                                        Page* page,
                                        gpointer self);
static void book_view_remove_cb (BookView* self,
                          Book* book,
                          Page* page);
static void _book_view_remove_cb_book_page_removed (Book* _sender,
                                             Page* page,
                                             gpointer self);
static void book_view_reorder_cb (BookView* self,
                           Book* book);
static void _book_view_reorder_cb_book_reordered (Book* _sender,
                                           gpointer self);
static void book_view_clear_cb (BookView* self,
                         Book* book);
static void _book_view_clear_cb_book_cleared (Book* _sender,
                                       gpointer self);
static gboolean book_view_configure_cb (BookView* self,
                                 GtkWidget* widget,
                                 GdkEventConfigure* event);
static gboolean _book_view_configure_cb_gtk_widget_configure_event (GtkWidget* _sender,
                                                             GdkEventConfigure* event,
                                                             gpointer self);
static gboolean book_view_draw_cb (BookView* self,
                            GtkWidget* widget,
                            cairo_t* context);
static gboolean _book_view_draw_cb_gtk_widget_draw (GtkWidget* _sender,
                                             cairo_t* cr,
                                             gpointer self);
static gboolean book_view_motion_cb (BookView* self,
                              GtkWidget* widget,
                              GdkEventMotion* event);
static gboolean _book_view_motion_cb_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                              GdkEventMotion* event,
                                                              gpointer self);
static gboolean book_view_key_cb (BookView* self,
                           GtkWidget* widget,
                           GdkEventKey* event);
static gboolean _book_view_key_cb_gtk_widget_key_press_event (GtkWidget* _sender,
                                                       GdkEventKey* event,
                                                       gpointer self);
static gboolean book_view_button_cb (BookView* self,
                              GtkWidget* widget,
                              GdkEventButton* event);
static gboolean _book_view_button_cb_gtk_widget_button_press_event (GtkWidget* _sender,
                                                             GdkEventButton* event,
                                                             gpointer self);
static gboolean _book_view_button_cb_gtk_widget_button_release_event (GtkWidget* _sender,
                                                               GdkEventButton* event,
                                                               gpointer self);
static gboolean book_view_focus_cb (BookView* self,
                             GtkWidget* widget,
                             GdkEventFocus* event);
static gboolean _book_view_focus_cb_gtk_widget_focus_in_event (GtkWidget* _sender,
                                                        GdkEventFocus* event,
                                                        gpointer self);
static gboolean _book_view_focus_cb_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                         GdkEventFocus* event,
                                                         gpointer self);
static void book_view_scroll_cb (BookView* self,
                          GtkAdjustment* adjustment);
static void _book_view_scroll_cb_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                        gpointer self);
VALA_EXTERN BookView* book_view_new (Book* book);
VALA_EXTERN BookView* book_view_construct (GType object_type,
                               Book* book);
static void book_view_set_book (BookView* self,
                         Book* value);
VALA_EXTERN guint book_get_n_pages (Book* self);
VALA_EXTERN Page* book_get_page (Book* self,
                     gint page_number);
VALA_EXTERN void book_view_set_selected_page (BookView* self,
                                  Page* value);
static void _g_object_unref0_ (gpointer var);
static PageView* book_view_get_nth_page (BookView* self,
                                  gint n);
static PageView* book_view_get_next_page (BookView* self,
                                   PageView* page);
VALA_EXTERN Page* page_view_get_page (PageView* self);
static PageView* book_view_get_prev_page (BookView* self,
                                   PageView* page);
static void book_view_page_view_changed_cb (BookView* self,
                                     PageView* page);
VALA_EXTERN void book_view_redraw (BookView* self);
static void book_view_page_view_size_changed_cb (BookView* self,
                                          PageView* page);
VALA_EXTERN PageView* page_view_new (Page* page);
VALA_EXTERN PageView* page_view_construct (GType object_type,
                               Page* page);
static void _book_view_page_view_changed_cb_page_view_changed (PageView* _sender,
                                                        gpointer self);
static void _book_view_page_view_size_changed_cb_page_view_size_changed (PageView* _sender,
                                                                  gpointer self);
static void book_view_set_selected_page_view (BookView* self,
                                       PageView* page);
VALA_EXTERN void page_view_set_selected (PageView* self,
                             gboolean value);
static void book_view_show_page_view (BookView* self,
                               PageView* page);
VALA_EXTERN gint page_view_get_x_offset (PageView* self);
VALA_EXTERN gint page_view_get_width (PageView* self);
VALA_EXTERN gint book_view_get_x_offset (BookView* self);
VALA_EXTERN void book_view_set_x_offset (BookView* self,
                             gint value);
static void book_view_select_page_view (BookView* self,
                                 PageView* page);
VALA_EXTERN Page* book_view_get_selected_page (BookView* self);
static void book_view_layout_into (BookView* self,
                            gint width,
                            gint height,
                            gint* book_width,
                            gint* book_height);
VALA_EXTERN gint page_get_dpi (Page* self);
VALA_EXTERN gint page_get_width (Page* self);
VALA_EXTERN gint page_get_height (Page* self);
VALA_EXTERN void page_view_set_width (PageView* self,
                          gint value);
VALA_EXTERN void page_view_set_height (PageView* self,
                           gint value);
VALA_EXTERN gint page_view_get_height (PageView* self);
VALA_EXTERN void page_view_set_x_offset (PageView* self,
                             gint value);
VALA_EXTERN void page_view_set_y_offset (PageView* self,
                             gint value);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void book_view_layout (BookView* self);
VALA_EXTERN void page_view_render (PageView* self,
                       cairo_t* context,
                       GdkRGBA* ruler_color);
VALA_EXTERN gboolean page_view_get_selected (PageView* self);
VALA_EXTERN gint page_view_get_y_offset (PageView* self);
static PageView* book_view_get_page_at (BookView* self,
                                 gint x,
                                 gint y,
                                 gint* x_,
                                 gint* y_);
VALA_EXTERN void page_view_button_press (PageView* self,
                             gint x,
                             gint y);
VALA_EXTERN void page_view_button_release (PageView* self,
                               gint x,
                               gint y);
static void book_view_set_cursor (BookView* self,
                           GdkCursorType cursor);
VALA_EXTERN void page_view_motion (PageView* self,
                       gint x,
                       gint y);
VALA_EXTERN GdkCursorType page_view_get_cursor (PageView* self);
VALA_EXTERN void book_view_select_next_page (BookView* self);
VALA_EXTERN void book_view_select_prev_page (BookView* self);
static void book_view_finalize (GObject * obj);
static GType book_view_get_type_once (void);
static void _vala_book_view_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_book_view_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
book_view_get_instance_private (BookView* self)
{
	return G_STRUCT_MEMBER_P (self, BookView_private_offset);
}

static void
_book_view_add_cb_book_page_added (Book* _sender,
                                   Page* page,
                                   gpointer self)
{
#line 124 "../src/book-view.vala"
	book_view_add_cb ((BookView*) self, _sender, page);
#line 314 "book-view.c"
}

static void
_book_view_remove_cb_book_page_removed (Book* _sender,
                                        Page* page,
                                        gpointer self)
{
#line 125 "../src/book-view.vala"
	book_view_remove_cb ((BookView*) self, _sender, page);
#line 324 "book-view.c"
}

static void
_book_view_reorder_cb_book_reordered (Book* _sender,
                                      gpointer self)
{
#line 126 "../src/book-view.vala"
	book_view_reorder_cb ((BookView*) self, _sender);
#line 333 "book-view.c"
}

static void
_book_view_clear_cb_book_cleared (Book* _sender,
                                  gpointer self)
{
#line 127 "../src/book-view.vala"
	book_view_clear_cb ((BookView*) self, _sender);
#line 342 "book-view.c"
}

static gboolean
_book_view_configure_cb_gtk_widget_configure_event (GtkWidget* _sender,
                                                    GdkEventConfigure* event,
                                                    gpointer self)
{
	gboolean result;
	result = book_view_configure_cb ((BookView*) self, _sender, event);
#line 128 "../src/book-view.vala"
	return result;
#line 354 "book-view.c"
}

static gboolean
_book_view_draw_cb_gtk_widget_draw (GtkWidget* _sender,
                                    cairo_t* cr,
                                    gpointer self)
{
	gboolean result;
	result = book_view_draw_cb ((BookView*) self, _sender, cr);
#line 129 "../src/book-view.vala"
	return result;
#line 366 "book-view.c"
}

static gboolean
_book_view_motion_cb_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                     GdkEventMotion* event,
                                                     gpointer self)
{
	gboolean result;
	result = book_view_motion_cb ((BookView*) self, _sender, event);
#line 130 "../src/book-view.vala"
	return result;
#line 378 "book-view.c"
}

static gboolean
_book_view_key_cb_gtk_widget_key_press_event (GtkWidget* _sender,
                                              GdkEventKey* event,
                                              gpointer self)
{
	gboolean result;
	result = book_view_key_cb ((BookView*) self, _sender, event);
#line 131 "../src/book-view.vala"
	return result;
#line 390 "book-view.c"
}

static gboolean
_book_view_button_cb_gtk_widget_button_press_event (GtkWidget* _sender,
                                                    GdkEventButton* event,
                                                    gpointer self)
{
	gboolean result;
	result = book_view_button_cb ((BookView*) self, _sender, event);
#line 132 "../src/book-view.vala"
	return result;
#line 402 "book-view.c"
}

static gboolean
_book_view_button_cb_gtk_widget_button_release_event (GtkWidget* _sender,
                                                      GdkEventButton* event,
                                                      gpointer self)
{
	gboolean result;
	result = book_view_button_cb ((BookView*) self, _sender, event);
#line 133 "../src/book-view.vala"
	return result;
#line 414 "book-view.c"
}

static gboolean
_book_view_focus_cb_gtk_widget_focus_in_event (GtkWidget* _sender,
                                               GdkEventFocus* event,
                                               gpointer self)
{
	gboolean result;
	result = book_view_focus_cb ((BookView*) self, _sender, event);
#line 134 "../src/book-view.vala"
	return result;
#line 426 "book-view.c"
}

static gboolean
_book_view_focus_cb_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                GdkEventFocus* event,
                                                gpointer self)
{
	gboolean result;
	result = book_view_focus_cb ((BookView*) self, _sender, event);
#line 135 "../src/book-view.vala"
	return result;
#line 438 "book-view.c"
}

static void
_book_view_scroll_cb_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                   gpointer self)
{
#line 136 "../src/book-view.vala"
	book_view_scroll_cb ((BookView*) self, _sender);
#line 447 "book-view.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 95 "../src/book-view.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 455 "book-view.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 106 "../src/book-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 463 "book-view.c"
}

BookView*
book_view_construct (GType object_type,
                     Book* book)
{
	BookView * self = NULL;
	Page* _tmp6_;
	Page* _tmp7_;
	GHashFunc _tmp8_;
	GEqualFunc _tmp9_;
	GHashTable* _tmp10_;
	GtkDrawingArea* _tmp11_;
	GtkWidget* _tmp12_;
	GtkWidget* _tmp13_;
	GtkWidget* _tmp14_;
	GtkWidget* _tmp15_;
	GtkWidget* _tmp16_;
	GtkScrollbar* _tmp17_;
	GtkScrollbar* _tmp18_;
	GtkAdjustment* _tmp19_;
	GtkAdjustment* _tmp20_;
	GtkAdjustment* _tmp21_;
	GtkScrollbar* _tmp22_;
	GtkWidget* _tmp23_;
	GtkWidget* _tmp24_;
	GtkWidget* _tmp25_;
	GtkWidget* _tmp26_;
	GtkWidget* _tmp27_;
	GtkWidget* _tmp28_;
	GtkWidget* _tmp29_;
	GtkWidget* _tmp30_;
	GtkAdjustment* _tmp31_;
	GtkWidget* _tmp32_;
#line 74 "../src/book-view.vala"
	g_return_val_if_fail (book != NULL, NULL);
#line 76 "../src/book-view.vala"
	self = (BookView*) g_object_new (object_type, "orientation", GTK_ORIENTATION_VERTICAL, NULL);
#line 77 "../src/book-view.vala"
	book_view_set_book (self, book);
#line 504 "book-view.c"
	{
		gint i = 0;
#line 80 "../src/book-view.vala"
		i = 0;
#line 509 "book-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 80 "../src/book-view.vala"
			_tmp0_ = TRUE;
#line 80 "../src/book-view.vala"
			while (TRUE) {
#line 516 "book-view.c"
				guint _tmp2_;
				guint _tmp3_;
				Page* page = NULL;
				Page* _tmp4_;
				Page* _tmp5_;
#line 80 "../src/book-view.vala"
				if (!_tmp0_) {
#line 524 "book-view.c"
					gint _tmp1_;
#line 80 "../src/book-view.vala"
					_tmp1_ = i;
#line 80 "../src/book-view.vala"
					i = _tmp1_ + 1;
#line 530 "book-view.c"
				}
#line 80 "../src/book-view.vala"
				_tmp0_ = FALSE;
#line 80 "../src/book-view.vala"
				_tmp2_ = book_get_n_pages (book);
#line 80 "../src/book-view.vala"
				_tmp3_ = _tmp2_;
#line 80 "../src/book-view.vala"
				if (!(((guint) i) < _tmp3_)) {
#line 80 "../src/book-view.vala"
					break;
#line 542 "book-view.c"
				}
#line 82 "../src/book-view.vala"
				_tmp4_ = book_get_page (book, i);
#line 82 "../src/book-view.vala"
				page = _tmp4_;
#line 83 "../src/book-view.vala"
				_tmp5_ = page;
#line 83 "../src/book-view.vala"
				book_view_add_cb (self, book, _tmp5_);
#line 80 "../src/book-view.vala"
				_g_object_unref0 (page);
#line 554 "book-view.c"
			}
		}
	}
#line 86 "../src/book-view.vala"
	_tmp6_ = book_get_page (book, 0);
#line 86 "../src/book-view.vala"
	_tmp7_ = _tmp6_;
#line 86 "../src/book-view.vala"
	book_view_set_selected_page (self, _tmp7_);
#line 86 "../src/book-view.vala"
	_g_object_unref0 (_tmp7_);
#line 89 "../src/book-view.vala"
	g_signal_connect_object (book, "page-added", (GCallback) _book_view_add_cb_book_page_added, self, 0);
#line 90 "../src/book-view.vala"
	g_signal_connect_object (book, "page-removed", (GCallback) _book_view_remove_cb_book_page_removed, self, 0);
#line 91 "../src/book-view.vala"
	g_signal_connect_object (book, "reordered", (GCallback) _book_view_reorder_cb_book_reordered, self, 0);
#line 92 "../src/book-view.vala"
	g_signal_connect_object (book, "cleared", (GCallback) _book_view_clear_cb_book_cleared, self, 0);
#line 94 "../src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 95 "../src/book-view.vala"
	_tmp8_ = g_direct_hash;
#line 95 "../src/book-view.vala"
	_tmp9_ = g_direct_equal;
#line 95 "../src/book-view.vala"
	_tmp10_ = g_hash_table_new_full (_tmp8_, _tmp9_, _g_object_unref0_, _g_object_unref0_);
#line 95 "../src/book-view.vala"
	_g_hash_table_unref0 (self->priv->page_data);
#line 95 "../src/book-view.vala"
	self->priv->page_data = _tmp10_;
#line 96 "../src/book-view.vala"
	self->priv->cursor = GDK_ARROW;
#line 98 "../src/book-view.vala"
	_tmp11_ = (GtkDrawingArea*) gtk_drawing_area_new ();
#line 98 "../src/book-view.vala"
	g_object_ref_sink (_tmp11_);
#line 98 "../src/book-view.vala"
	_g_object_unref0 (self->priv->drawing_area);
#line 98 "../src/book-view.vala"
	self->priv->drawing_area = (GtkWidget*) _tmp11_;
#line 99 "../src/book-view.vala"
	_tmp12_ = self->priv->drawing_area;
#line 99 "../src/book-view.vala"
	gtk_widget_set_size_request (_tmp12_, 200, 100);
#line 100 "../src/book-view.vala"
	_tmp13_ = self->priv->drawing_area;
#line 100 "../src/book-view.vala"
	gtk_widget_set_can_focus (_tmp13_, TRUE);
#line 101 "../src/book-view.vala"
	_tmp14_ = self->priv->drawing_area;
#line 101 "../src/book-view.vala"
	gtk_widget_set_events (_tmp14_, ((((GDK_POINTER_MOTION_MASK | GDK_BUTTON_PRESS_MASK) | GDK_BUTTON_RELEASE_MASK) | GDK_FOCUS_CHANGE_MASK) | GDK_STRUCTURE_MASK) | GDK_SCROLL_MASK);
#line 102 "../src/book-view.vala"
	_tmp15_ = self->priv->drawing_area;
#line 102 "../src/book-view.vala"
	gtk_widget_set_vexpand (_tmp15_, TRUE);
#line 103 "../src/book-view.vala"
	_tmp16_ = self->priv->drawing_area;
#line 103 "../src/book-view.vala"
	gtk_container_add ((GtkContainer*) self, _tmp16_);
#line 105 "../src/book-view.vala"
	_tmp17_ = (GtkScrollbar*) gtk_scrollbar_new (GTK_ORIENTATION_HORIZONTAL, NULL);
#line 105 "../src/book-view.vala"
	g_object_ref_sink (_tmp17_);
#line 105 "../src/book-view.vala"
	_g_object_unref0 (self->priv->scroll);
#line 105 "../src/book-view.vala"
	self->priv->scroll = _tmp17_;
#line 106 "../src/book-view.vala"
	_tmp18_ = self->priv->scroll;
#line 106 "../src/book-view.vala"
	_tmp19_ = gtk_range_get_adjustment ((GtkRange*) _tmp18_);
#line 106 "../src/book-view.vala"
	_tmp20_ = _tmp19_;
#line 106 "../src/book-view.vala"
	_tmp21_ = _g_object_ref0 (_tmp20_);
#line 106 "../src/book-view.vala"
	_g_object_unref0 (self->priv->adjustment);
#line 106 "../src/book-view.vala"
	self->priv->adjustment = _tmp21_;
#line 107 "../src/book-view.vala"
	_tmp22_ = self->priv->scroll;
#line 107 "../src/book-view.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp22_);
#line 109 "../src/book-view.vala"
	_tmp23_ = self->priv->drawing_area;
#line 109 "../src/book-view.vala"
	g_signal_connect_object (_tmp23_, "configure-event", (GCallback) _book_view_configure_cb_gtk_widget_configure_event, self, 0);
#line 110 "../src/book-view.vala"
	_tmp24_ = self->priv->drawing_area;
#line 110 "../src/book-view.vala"
	g_signal_connect_object (_tmp24_, "draw", (GCallback) _book_view_draw_cb_gtk_widget_draw, self, 0);
#line 111 "../src/book-view.vala"
	_tmp25_ = self->priv->drawing_area;
#line 111 "../src/book-view.vala"
	g_signal_connect_object (_tmp25_, "motion-notify-event", (GCallback) _book_view_motion_cb_gtk_widget_motion_notify_event, self, 0);
#line 112 "../src/book-view.vala"
	_tmp26_ = self->priv->drawing_area;
#line 112 "../src/book-view.vala"
	g_signal_connect_object (_tmp26_, "key-press-event", (GCallback) _book_view_key_cb_gtk_widget_key_press_event, self, 0);
#line 113 "../src/book-view.vala"
	_tmp27_ = self->priv->drawing_area;
#line 113 "../src/book-view.vala"
	g_signal_connect_object (_tmp27_, "button-press-event", (GCallback) _book_view_button_cb_gtk_widget_button_press_event, self, 0);
#line 114 "../src/book-view.vala"
	_tmp28_ = self->priv->drawing_area;
#line 114 "../src/book-view.vala"
	g_signal_connect_object (_tmp28_, "button-release-event", (GCallback) _book_view_button_cb_gtk_widget_button_release_event, self, 0);
#line 115 "../src/book-view.vala"
	_tmp29_ = self->priv->drawing_area;
#line 115 "../src/book-view.vala"
	g_signal_connect_object (_tmp29_, "focus-in-event", (GCallback) _book_view_focus_cb_gtk_widget_focus_in_event, self, G_CONNECT_AFTER);
#line 116 "../src/book-view.vala"
	_tmp30_ = self->priv->drawing_area;
#line 116 "../src/book-view.vala"
	g_signal_connect_object (_tmp30_, "focus-out-event", (GCallback) _book_view_focus_cb_gtk_widget_focus_out_event, self, G_CONNECT_AFTER);
#line 117 "../src/book-view.vala"
	_tmp31_ = self->priv->adjustment;
#line 117 "../src/book-view.vala"
	g_signal_connect_object (_tmp31_, "value-changed", (GCallback) _book_view_scroll_cb_gtk_adjustment_value_changed, self, 0);
#line 119 "../src/book-view.vala"
	_tmp32_ = self->priv->drawing_area;
#line 119 "../src/book-view.vala"
	gtk_widget_set_visible (_tmp32_, TRUE);
#line 74 "../src/book-view.vala"
	return self;
#line 682 "book-view.c"
}

BookView*
book_view_new (Book* book)
{
#line 74 "../src/book-view.vala"
	return book_view_construct (TYPE_BOOK_VIEW, book);
#line 690 "book-view.c"
}

static PageView*
book_view_get_nth_page (BookView* self,
                        gint n)
{
	Page* page = NULL;
	Book* _tmp0_;
	Page* _tmp1_;
	GHashTable* _tmp2_;
	gconstpointer _tmp3_;
	PageView* _tmp4_;
	PageView* result;
#line 139 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 141 "../src/book-view.vala"
	_tmp0_ = self->priv->_book;
#line 141 "../src/book-view.vala"
	_tmp1_ = book_get_page (_tmp0_, n);
#line 141 "../src/book-view.vala"
	page = _tmp1_;
#line 142 "../src/book-view.vala"
	_tmp2_ = self->priv->page_data;
#line 142 "../src/book-view.vala"
	_tmp3_ = g_hash_table_lookup (_tmp2_, page);
#line 142 "../src/book-view.vala"
	_tmp4_ = _g_object_ref0 ((PageView*) _tmp3_);
#line 142 "../src/book-view.vala"
	result = _tmp4_;
#line 142 "../src/book-view.vala"
	_g_object_unref0 (page);
#line 142 "../src/book-view.vala"
	return result;
#line 724 "book-view.c"
}

static PageView*
book_view_get_next_page (BookView* self,
                         PageView* page)
{
	PageView* _tmp15_;
	PageView* result;
#line 145 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 145 "../src/book-view.vala"
	g_return_val_if_fail (page != NULL, NULL);
#line 737 "book-view.c"
	{
		gint i = 0;
#line 147 "../src/book-view.vala"
		i = 0;
#line 742 "book-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 147 "../src/book-view.vala"
			_tmp0_ = TRUE;
#line 147 "../src/book-view.vala"
			while (TRUE) {
#line 749 "book-view.c"
				Page* p = NULL;
				Book* _tmp2_;
				Page* _tmp3_;
				Page* _tmp4_;
				Page* _tmp5_;
				Page* _tmp6_;
				Page* _tmp7_;
#line 147 "../src/book-view.vala"
				if (!_tmp0_) {
#line 759 "book-view.c"
					gint _tmp1_;
#line 147 "../src/book-view.vala"
					_tmp1_ = i;
#line 147 "../src/book-view.vala"
					i = _tmp1_ + 1;
#line 765 "book-view.c"
				}
#line 147 "../src/book-view.vala"
				_tmp0_ = FALSE;
#line 149 "../src/book-view.vala"
				_tmp2_ = self->priv->_book;
#line 149 "../src/book-view.vala"
				_tmp3_ = book_get_page (_tmp2_, i);
#line 149 "../src/book-view.vala"
				p = _tmp3_;
#line 150 "../src/book-view.vala"
				_tmp4_ = p;
#line 150 "../src/book-view.vala"
				if (_tmp4_ == NULL) {
#line 151 "../src/book-view.vala"
					_g_object_unref0 (p);
#line 151 "../src/book-view.vala"
					break;
#line 783 "book-view.c"
				}
#line 152 "../src/book-view.vala"
				_tmp5_ = p;
#line 152 "../src/book-view.vala"
				_tmp6_ = page_view_get_page (page);
#line 152 "../src/book-view.vala"
				_tmp7_ = _tmp6_;
#line 152 "../src/book-view.vala"
				if (_tmp5_ == _tmp7_) {
#line 793 "book-view.c"
					Book* _tmp8_;
					Page* _tmp9_;
					Page* _tmp10_;
#line 154 "../src/book-view.vala"
					_tmp8_ = self->priv->_book;
#line 154 "../src/book-view.vala"
					_tmp9_ = book_get_page (_tmp8_, i + 1);
#line 154 "../src/book-view.vala"
					_g_object_unref0 (p);
#line 154 "../src/book-view.vala"
					p = _tmp9_;
#line 155 "../src/book-view.vala"
					_tmp10_ = p;
#line 155 "../src/book-view.vala"
					if (_tmp10_ != NULL) {
#line 809 "book-view.c"
						GHashTable* _tmp11_;
						Page* _tmp12_;
						gconstpointer _tmp13_;
						PageView* _tmp14_;
#line 156 "../src/book-view.vala"
						_tmp11_ = self->priv->page_data;
#line 156 "../src/book-view.vala"
						_tmp12_ = p;
#line 156 "../src/book-view.vala"
						_tmp13_ = g_hash_table_lookup (_tmp11_, _tmp12_);
#line 156 "../src/book-view.vala"
						_tmp14_ = _g_object_ref0 ((PageView*) _tmp13_);
#line 156 "../src/book-view.vala"
						result = _tmp14_;
#line 156 "../src/book-view.vala"
						_g_object_unref0 (p);
#line 156 "../src/book-view.vala"
						return result;
#line 828 "book-view.c"
					}
				}
#line 147 "../src/book-view.vala"
				_g_object_unref0 (p);
#line 833 "book-view.c"
			}
		}
	}
#line 160 "../src/book-view.vala"
	_tmp15_ = _g_object_ref0 (page);
#line 160 "../src/book-view.vala"
	result = _tmp15_;
#line 160 "../src/book-view.vala"
	return result;
#line 843 "book-view.c"
}

static PageView*
book_view_get_prev_page (BookView* self,
                         PageView* page)
{
	PageView* prev_page = NULL;
	PageView* _tmp0_;
	PageView* _tmp13_;
	PageView* result;
#line 163 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 163 "../src/book-view.vala"
	g_return_val_if_fail (page != NULL, NULL);
#line 165 "../src/book-view.vala"
	_tmp0_ = _g_object_ref0 (page);
#line 165 "../src/book-view.vala"
	prev_page = _tmp0_;
#line 862 "book-view.c"
	{
		gint i = 0;
#line 166 "../src/book-view.vala"
		i = 0;
#line 867 "book-view.c"
		{
			gboolean _tmp1_ = FALSE;
#line 166 "../src/book-view.vala"
			_tmp1_ = TRUE;
#line 166 "../src/book-view.vala"
			while (TRUE) {
#line 874 "book-view.c"
				Page* p = NULL;
				Book* _tmp3_;
				Page* _tmp4_;
				Page* _tmp5_;
				Page* _tmp6_;
				Page* _tmp7_;
				Page* _tmp8_;
				GHashTable* _tmp9_;
				Page* _tmp10_;
				gconstpointer _tmp11_;
				PageView* _tmp12_;
#line 166 "../src/book-view.vala"
				if (!_tmp1_) {
#line 888 "book-view.c"
					gint _tmp2_;
#line 166 "../src/book-view.vala"
					_tmp2_ = i;
#line 166 "../src/book-view.vala"
					i = _tmp2_ + 1;
#line 894 "book-view.c"
				}
#line 166 "../src/book-view.vala"
				_tmp1_ = FALSE;
#line 168 "../src/book-view.vala"
				_tmp3_ = self->priv->_book;
#line 168 "../src/book-view.vala"
				_tmp4_ = book_get_page (_tmp3_, i);
#line 168 "../src/book-view.vala"
				p = _tmp4_;
#line 169 "../src/book-view.vala"
				_tmp5_ = p;
#line 169 "../src/book-view.vala"
				if (_tmp5_ == NULL) {
#line 170 "../src/book-view.vala"
					_g_object_unref0 (p);
#line 170 "../src/book-view.vala"
					break;
#line 912 "book-view.c"
				}
#line 171 "../src/book-view.vala"
				_tmp6_ = p;
#line 171 "../src/book-view.vala"
				_tmp7_ = page_view_get_page (page);
#line 171 "../src/book-view.vala"
				_tmp8_ = _tmp7_;
#line 171 "../src/book-view.vala"
				if (_tmp6_ == _tmp8_) {
#line 172 "../src/book-view.vala"
					result = prev_page;
#line 172 "../src/book-view.vala"
					_g_object_unref0 (p);
#line 172 "../src/book-view.vala"
					return result;
#line 928 "book-view.c"
				}
#line 173 "../src/book-view.vala"
				_tmp9_ = self->priv->page_data;
#line 173 "../src/book-view.vala"
				_tmp10_ = p;
#line 173 "../src/book-view.vala"
				_tmp11_ = g_hash_table_lookup (_tmp9_, _tmp10_);
#line 173 "../src/book-view.vala"
				_tmp12_ = _g_object_ref0 ((PageView*) _tmp11_);
#line 173 "../src/book-view.vala"
				_g_object_unref0 (prev_page);
#line 173 "../src/book-view.vala"
				prev_page = _tmp12_;
#line 166 "../src/book-view.vala"
				_g_object_unref0 (p);
#line 944 "book-view.c"
			}
		}
	}
#line 176 "../src/book-view.vala"
	_tmp13_ = _g_object_ref0 (page);
#line 176 "../src/book-view.vala"
	result = _tmp13_;
#line 176 "../src/book-view.vala"
	_g_object_unref0 (prev_page);
#line 176 "../src/book-view.vala"
	return result;
#line 956 "book-view.c"
}

static void
book_view_page_view_changed_cb (BookView* self,
                                PageView* page)
{
#line 179 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 179 "../src/book-view.vala"
	g_return_if_fail (page != NULL);
#line 181 "../src/book-view.vala"
	book_view_redraw (self);
#line 969 "book-view.c"
}

static void
book_view_page_view_size_changed_cb (BookView* self,
                                     PageView* page)
{
#line 184 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 184 "../src/book-view.vala"
	g_return_if_fail (page != NULL);
#line 186 "../src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 187 "../src/book-view.vala"
	book_view_redraw (self);
#line 984 "book-view.c"
}

static void
_book_view_page_view_changed_cb_page_view_changed (PageView* _sender,
                                                   gpointer self)
{
#line 193 "../src/book-view.vala"
	book_view_page_view_changed_cb ((BookView*) self, _sender);
#line 993 "book-view.c"
}

static void
_book_view_page_view_size_changed_cb_page_view_size_changed (PageView* _sender,
                                                             gpointer self)
{
#line 194 "../src/book-view.vala"
	book_view_page_view_size_changed_cb ((BookView*) self, _sender);
#line 1002 "book-view.c"
}

static void
book_view_add_cb (BookView* self,
                  Book* book,
                  Page* page)
{
	PageView* page_view = NULL;
	PageView* _tmp0_;
	GHashTable* _tmp1_;
	Page* _tmp2_;
	PageView* _tmp3_;
#line 190 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 190 "../src/book-view.vala"
	g_return_if_fail (book != NULL);
#line 190 "../src/book-view.vala"
	g_return_if_fail (page != NULL);
#line 192 "../src/book-view.vala"
	_tmp0_ = page_view_new (page);
#line 192 "../src/book-view.vala"
	page_view = _tmp0_;
#line 193 "../src/book-view.vala"
	g_signal_connect_object (page_view, "changed", (GCallback) _book_view_page_view_changed_cb_page_view_changed, self, 0);
#line 194 "../src/book-view.vala"
	g_signal_connect_object (page_view, "size-changed", (GCallback) _book_view_page_view_size_changed_cb_page_view_size_changed, self, 0);
#line 195 "../src/book-view.vala"
	_tmp1_ = self->priv->page_data;
#line 195 "../src/book-view.vala"
	_tmp2_ = _g_object_ref0 (page);
#line 195 "../src/book-view.vala"
	_tmp3_ = _g_object_ref0 (page_view);
#line 195 "../src/book-view.vala"
	g_hash_table_insert (_tmp1_, _tmp2_, _tmp3_);
#line 196 "../src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 197 "../src/book-view.vala"
	book_view_redraw (self);
#line 190 "../src/book-view.vala"
	_g_object_unref0 (page_view);
#line 1043 "book-view.c"
}

static void
book_view_set_selected_page_view (BookView* self,
                                  PageView* page)
{
	gboolean _tmp0_ = FALSE;
	PageView* _tmp1_;
	PageView* _tmp4_;
	PageView* _tmp5_;
	GtkWidget* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
#line 200 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 203 "../src/book-view.vala"
	_tmp1_ = self->priv->selected_page_view;
#line 203 "../src/book-view.vala"
	if (_tmp1_ != NULL) {
#line 1063 "book-view.c"
		PageView* _tmp2_;
#line 203 "../src/book-view.vala"
		_tmp2_ = self->priv->selected_page_view;
#line 203 "../src/book-view.vala"
		_tmp0_ = page != _tmp2_;
#line 1069 "book-view.c"
	} else {
#line 203 "../src/book-view.vala"
		_tmp0_ = FALSE;
#line 1073 "book-view.c"
	}
#line 203 "../src/book-view.vala"
	if (_tmp0_) {
#line 1077 "book-view.c"
		PageView* _tmp3_;
#line 204 "../src/book-view.vala"
		_tmp3_ = self->priv->selected_page_view;
#line 204 "../src/book-view.vala"
		page_view_set_selected (_tmp3_, TRUE);
#line 1083 "book-view.c"
	}
#line 206 "../src/book-view.vala"
	_tmp4_ = _g_object_ref0 (page);
#line 206 "../src/book-view.vala"
	_g_object_unref0 (self->priv->selected_page_view);
#line 206 "../src/book-view.vala"
	self->priv->selected_page_view = _tmp4_;
#line 207 "../src/book-view.vala"
	book_view_redraw (self);
#line 208 "../src/book-view.vala"
	_tmp5_ = self->priv->selected_page_view;
#line 208 "../src/book-view.vala"
	if (_tmp5_ == NULL) {
#line 209 "../src/book-view.vala"
		return;
#line 1099 "book-view.c"
	}
#line 212 "../src/book-view.vala"
	_tmp6_ = self->priv->drawing_area;
#line 212 "../src/book-view.vala"
	g_object_get (_tmp6_, "has-focus", &_tmp7_, NULL);
#line 212 "../src/book-view.vala"
	_tmp8_ = _tmp7_;
#line 212 "../src/book-view.vala"
	if (!_tmp8_) {
#line 1109 "book-view.c"
		PageView* _tmp9_;
#line 213 "../src/book-view.vala"
		_tmp9_ = self->priv->selected_page_view;
#line 213 "../src/book-view.vala"
		page_view_set_selected (_tmp9_, FALSE);
#line 1115 "book-view.c"
	} else {
		PageView* _tmp10_;
#line 215 "../src/book-view.vala"
		_tmp10_ = self->priv->selected_page_view;
#line 215 "../src/book-view.vala"
		page_view_set_selected (_tmp10_, TRUE);
#line 1122 "book-view.c"
	}
}

static void
book_view_show_page_view (BookView* self,
                          PageView* page)
{
	gboolean _tmp0_ = FALSE;
	GtkAllocation allocation = {0};
	GtkWidget* _tmp2_;
	GtkAllocation _tmp3_ = {0};
	gint left_edge = 0;
	gint _tmp4_;
	gint _tmp5_;
	gint right_edge = 0;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
#line 218 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 220 "../src/book-view.vala"
	if (page == NULL) {
#line 220 "../src/book-view.vala"
		_tmp0_ = TRUE;
#line 1150 "book-view.c"
	} else {
		GtkScrollbar* _tmp1_;
#line 220 "../src/book-view.vala"
		_tmp1_ = self->priv->scroll;
#line 220 "../src/book-view.vala"
		_tmp0_ = !gtk_widget_get_visible ((GtkWidget*) _tmp1_);
#line 1157 "book-view.c"
	}
#line 220 "../src/book-view.vala"
	if (_tmp0_) {
#line 221 "../src/book-view.vala"
		return;
#line 1163 "book-view.c"
	}
#line 224 "../src/book-view.vala"
	_tmp2_ = self->priv->drawing_area;
#line 224 "../src/book-view.vala"
	gtk_widget_get_allocation (_tmp2_, &_tmp3_);
#line 224 "../src/book-view.vala"
	allocation = _tmp3_;
#line 225 "../src/book-view.vala"
	_tmp4_ = page_view_get_x_offset (page);
#line 225 "../src/book-view.vala"
	_tmp5_ = _tmp4_;
#line 225 "../src/book-view.vala"
	left_edge = _tmp5_;
#line 226 "../src/book-view.vala"
	_tmp6_ = page_view_get_x_offset (page);
#line 226 "../src/book-view.vala"
	_tmp7_ = _tmp6_;
#line 226 "../src/book-view.vala"
	_tmp8_ = page_view_get_width (page);
#line 226 "../src/book-view.vala"
	_tmp9_ = _tmp8_;
#line 226 "../src/book-view.vala"
	right_edge = _tmp7_ + _tmp9_;
#line 228 "../src/book-view.vala"
	_tmp10_ = book_view_get_x_offset (self);
#line 228 "../src/book-view.vala"
	_tmp11_ = _tmp10_;
#line 228 "../src/book-view.vala"
	if ((left_edge - _tmp11_) < 0) {
#line 229 "../src/book-view.vala"
		book_view_set_x_offset (self, left_edge);
#line 1195 "book-view.c"
	} else {
		gint _tmp12_;
		gint _tmp13_;
		GtkAllocation _tmp14_;
#line 230 "../src/book-view.vala"
		_tmp12_ = book_view_get_x_offset (self);
#line 230 "../src/book-view.vala"
		_tmp13_ = _tmp12_;
#line 230 "../src/book-view.vala"
		_tmp14_ = allocation;
#line 230 "../src/book-view.vala"
		if ((right_edge - _tmp13_) > _tmp14_.width) {
#line 1208 "book-view.c"
			GtkAllocation _tmp15_;
#line 231 "../src/book-view.vala"
			_tmp15_ = allocation;
#line 231 "../src/book-view.vala"
			book_view_set_x_offset (self, right_edge - _tmp15_.width);
#line 1214 "book-view.c"
		}
	}
}

static void
book_view_select_page_view (BookView* self,
                            PageView* page)
{
	Page* p = NULL;
	PageView* _tmp0_;
	Page* _tmp4_;
#line 234 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 236 "../src/book-view.vala"
	p = NULL;
#line 238 "../src/book-view.vala"
	_tmp0_ = self->priv->selected_page_view;
#line 238 "../src/book-view.vala"
	if (_tmp0_ == page) {
#line 239 "../src/book-view.vala"
		_g_object_unref0 (p);
#line 239 "../src/book-view.vala"
		return;
#line 1238 "book-view.c"
	}
#line 241 "../src/book-view.vala"
	book_view_set_selected_page_view (self, page);
#line 243 "../src/book-view.vala"
	if (self->priv->need_layout) {
#line 244 "../src/book-view.vala"
		self->priv->show_selected_page = TRUE;
#line 1246 "book-view.c"
	} else {
#line 246 "../src/book-view.vala"
		book_view_show_page_view (self, page);
#line 1250 "book-view.c"
	}
#line 248 "../src/book-view.vala"
	if (page != NULL) {
#line 1254 "book-view.c"
		Page* _tmp1_;
		Page* _tmp2_;
		Page* _tmp3_;
#line 249 "../src/book-view.vala"
		_tmp1_ = page_view_get_page (page);
#line 249 "../src/book-view.vala"
		_tmp2_ = _tmp1_;
#line 249 "../src/book-view.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 249 "../src/book-view.vala"
		_g_object_unref0 (p);
#line 249 "../src/book-view.vala"
		p = _tmp3_;
#line 1268 "book-view.c"
	}
#line 250 "../src/book-view.vala"
	_tmp4_ = p;
#line 250 "../src/book-view.vala"
	g_signal_emit (self, book_view_signals[BOOK_VIEW_PAGE_SELECTED_SIGNAL], 0, _tmp4_);
#line 234 "../src/book-view.vala"
	_g_object_unref0 (p);
#line 1276 "book-view.c"
}

static void
book_view_remove_cb (BookView* self,
                     Book* book,
                     Page* page)
{
	PageView* new_selection = NULL;
	PageView* _tmp0_;
	PageView* _tmp1_;
	Page* _tmp2_;
	Page* _tmp3_;
	PageView* page_view = NULL;
	GHashTable* _tmp10_;
	gconstpointer _tmp11_;
	PageView* _tmp12_;
	guint _tmp13_;
	guint _tmp14_;
	GHashTable* _tmp15_;
	PageView* _tmp16_;
#line 253 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 253 "../src/book-view.vala"
	g_return_if_fail (book != NULL);
#line 253 "../src/book-view.vala"
	g_return_if_fail (page != NULL);
#line 255 "../src/book-view.vala"
	_tmp0_ = self->priv->selected_page_view;
#line 255 "../src/book-view.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 255 "../src/book-view.vala"
	new_selection = _tmp1_;
#line 258 "../src/book-view.vala"
	_tmp2_ = book_view_get_selected_page (self);
#line 258 "../src/book-view.vala"
	_tmp3_ = _tmp2_;
#line 258 "../src/book-view.vala"
	if (page == _tmp3_) {
#line 1315 "book-view.c"
		PageView* _tmp4_;
		PageView* _tmp5_;
		PageView* _tmp6_;
		PageView* _tmp7_;
#line 260 "../src/book-view.vala"
		_tmp4_ = self->priv->selected_page_view;
#line 260 "../src/book-view.vala"
		_tmp5_ = book_view_get_prev_page (self, _tmp4_);
#line 260 "../src/book-view.vala"
		_g_object_unref0 (new_selection);
#line 260 "../src/book-view.vala"
		new_selection = _tmp5_;
#line 261 "../src/book-view.vala"
		_tmp6_ = new_selection;
#line 261 "../src/book-view.vala"
		_tmp7_ = self->priv->selected_page_view;
#line 261 "../src/book-view.vala"
		if (_tmp6_ == _tmp7_) {
#line 1334 "book-view.c"
			PageView* _tmp8_;
			PageView* _tmp9_;
#line 262 "../src/book-view.vala"
			_tmp8_ = self->priv->selected_page_view;
#line 262 "../src/book-view.vala"
			_tmp9_ = book_view_get_next_page (self, _tmp8_);
#line 262 "../src/book-view.vala"
			_g_object_unref0 (new_selection);
#line 262 "../src/book-view.vala"
			new_selection = _tmp9_;
#line 1345 "book-view.c"
		}
#line 263 "../src/book-view.vala"
		_g_object_unref0 (self->priv->selected_page_view);
#line 263 "../src/book-view.vala"
		self->priv->selected_page_view = NULL;
#line 1351 "book-view.c"
	}
#line 266 "../src/book-view.vala"
	_tmp10_ = self->priv->page_data;
#line 266 "../src/book-view.vala"
	_tmp11_ = g_hash_table_lookup (_tmp10_, page);
#line 266 "../src/book-view.vala"
	_tmp12_ = _g_object_ref0 ((PageView*) _tmp11_);
#line 266 "../src/book-view.vala"
	page_view = _tmp12_;
#line 267 "../src/book-view.vala"
	g_signal_parse_name ("changed", TYPE_PAGE_VIEW, &_tmp13_, NULL, FALSE);
#line 267 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (page_view, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _book_view_page_view_changed_cb_page_view_changed, self);
#line 268 "../src/book-view.vala"
	g_signal_parse_name ("size-changed", TYPE_PAGE_VIEW, &_tmp14_, NULL, FALSE);
#line 268 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (page_view, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp14_, 0, NULL, (GCallback) _book_view_page_view_size_changed_cb_page_view_size_changed, self);
#line 269 "../src/book-view.vala"
	_tmp15_ = self->priv->page_data;
#line 269 "../src/book-view.vala"
	g_hash_table_remove (_tmp15_, page);
#line 271 "../src/book-view.vala"
	_tmp16_ = new_selection;
#line 271 "../src/book-view.vala"
	book_view_select_page_view (self, _tmp16_);
#line 273 "../src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 274 "../src/book-view.vala"
	book_view_redraw (self);
#line 253 "../src/book-view.vala"
	_g_object_unref0 (page_view);
#line 253 "../src/book-view.vala"
	_g_object_unref0 (new_selection);
#line 1385 "book-view.c"
}

static void
book_view_reorder_cb (BookView* self,
                      Book* book)
{
#line 277 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 277 "../src/book-view.vala"
	g_return_if_fail (book != NULL);
#line 279 "../src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 280 "../src/book-view.vala"
	book_view_redraw (self);
#line 1400 "book-view.c"
}

static void
book_view_clear_cb (BookView* self,
                    Book* book)
{
	GHashTable* _tmp0_;
#line 283 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 283 "../src/book-view.vala"
	g_return_if_fail (book != NULL);
#line 285 "../src/book-view.vala"
	_tmp0_ = self->priv->page_data;
#line 285 "../src/book-view.vala"
	g_hash_table_remove_all (_tmp0_);
#line 286 "../src/book-view.vala"
	_g_object_unref0 (self->priv->selected_page_view);
#line 286 "../src/book-view.vala"
	self->priv->selected_page_view = NULL;
#line 287 "../src/book-view.vala"
	g_signal_emit (self, book_view_signals[BOOK_VIEW_PAGE_SELECTED_SIGNAL], 0, NULL);
#line 288 "../src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 289 "../src/book-view.vala"
	book_view_redraw (self);
#line 1426 "book-view.c"
}

static gboolean
book_view_configure_cb (BookView* self,
                        GtkWidget* widget,
                        GdkEventConfigure* event)
{
	gboolean result;
#line 292 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 292 "../src/book-view.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 292 "../src/book-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 294 "../src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 295 "../src/book-view.vala"
	result = FALSE;
#line 295 "../src/book-view.vala"
	return result;
#line 1447 "book-view.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 298 "../src/book-view.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 1455 "book-view.c"
}

static void
book_view_layout_into (BookView* self,
                       gint width,
                       gint height,
                       gint* book_width,
                       gint* book_height)
{
	gint _vala_book_width = 0;
	gint _vala_book_height = 0;
	GList* pages = NULL;
	gint max_dpi = 0;
	GList* _tmp6_;
	gint max_width = 0;
	gint max_height = 0;
	GList* _tmp18_;
	gdouble aspect = 0.0;
	gdouble max_aspect = 0.0;
	gint spacing = 0;
	GList* _tmp36_;
	GList* _tmp62_;
	gint x_offset = 0;
	GList* _tmp63_;
#line 298 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 300 "../src/book-view.vala"
	pages = NULL;
#line 1484 "book-view.c"
	{
		gint i = 0;
#line 301 "../src/book-view.vala"
		i = 0;
#line 1489 "book-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 301 "../src/book-view.vala"
			_tmp0_ = TRUE;
#line 301 "../src/book-view.vala"
			while (TRUE) {
#line 1496 "book-view.c"
				Book* _tmp2_;
				guint _tmp3_;
				guint _tmp4_;
				PageView* _tmp5_;
#line 301 "../src/book-view.vala"
				if (!_tmp0_) {
#line 1503 "book-view.c"
					gint _tmp1_;
#line 301 "../src/book-view.vala"
					_tmp1_ = i;
#line 301 "../src/book-view.vala"
					i = _tmp1_ + 1;
#line 1509 "book-view.c"
				}
#line 301 "../src/book-view.vala"
				_tmp0_ = FALSE;
#line 301 "../src/book-view.vala"
				_tmp2_ = self->priv->_book;
#line 301 "../src/book-view.vala"
				_tmp3_ = book_get_n_pages (_tmp2_);
#line 301 "../src/book-view.vala"
				_tmp4_ = _tmp3_;
#line 301 "../src/book-view.vala"
				if (!(((guint) i) < _tmp4_)) {
#line 301 "../src/book-view.vala"
					break;
#line 1523 "book-view.c"
				}
#line 302 "../src/book-view.vala"
				_tmp5_ = book_view_get_nth_page (self, i);
#line 302 "../src/book-view.vala"
				pages = g_list_append (pages, _tmp5_);
#line 1529 "book-view.c"
			}
		}
	}
#line 305 "../src/book-view.vala"
	max_dpi = 0;
#line 306 "../src/book-view.vala"
	_tmp6_ = pages;
#line 1537 "book-view.c"
	{
		GList* page_collection = NULL;
		GList* page_it = NULL;
#line 306 "../src/book-view.vala"
		page_collection = _tmp6_;
#line 306 "../src/book-view.vala"
		for (page_it = page_collection; page_it != NULL; page_it = page_it->next) {
#line 1545 "book-view.c"
			PageView* _tmp7_;
			PageView* page = NULL;
#line 306 "../src/book-view.vala"
			_tmp7_ = _g_object_ref0 ((PageView*) page_it->data);
#line 306 "../src/book-view.vala"
			page = _tmp7_;
#line 1552 "book-view.c"
			{
				Page* p = NULL;
				PageView* _tmp8_;
				Page* _tmp9_;
				Page* _tmp10_;
				Page* _tmp11_;
				Page* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
#line 308 "../src/book-view.vala"
				_tmp8_ = page;
#line 308 "../src/book-view.vala"
				_tmp9_ = page_view_get_page (_tmp8_);
#line 308 "../src/book-view.vala"
				_tmp10_ = _tmp9_;
#line 308 "../src/book-view.vala"
				_tmp11_ = _g_object_ref0 (_tmp10_);
#line 308 "../src/book-view.vala"
				p = _tmp11_;
#line 309 "../src/book-view.vala"
				_tmp12_ = p;
#line 309 "../src/book-view.vala"
				_tmp13_ = page_get_dpi (_tmp12_);
#line 309 "../src/book-view.vala"
				_tmp14_ = _tmp13_;
#line 309 "../src/book-view.vala"
				if (_tmp14_ > max_dpi) {
#line 1580 "book-view.c"
					Page* _tmp15_;
					gint _tmp16_;
					gint _tmp17_;
#line 310 "../src/book-view.vala"
					_tmp15_ = p;
#line 310 "../src/book-view.vala"
					_tmp16_ = page_get_dpi (_tmp15_);
#line 310 "../src/book-view.vala"
					_tmp17_ = _tmp16_;
#line 310 "../src/book-view.vala"
					max_dpi = _tmp17_;
#line 1592 "book-view.c"
				}
#line 306 "../src/book-view.vala"
				_g_object_unref0 (p);
#line 306 "../src/book-view.vala"
				_g_object_unref0 (page);
#line 1598 "book-view.c"
			}
		}
	}
#line 314 "../src/book-view.vala"
	max_width = 0;
#line 314 "../src/book-view.vala"
	max_height = 0;
#line 315 "../src/book-view.vala"
	_tmp18_ = pages;
#line 1608 "book-view.c"
	{
		GList* page_collection = NULL;
		GList* page_it = NULL;
#line 315 "../src/book-view.vala"
		page_collection = _tmp18_;
#line 315 "../src/book-view.vala"
		for (page_it = page_collection; page_it != NULL; page_it = page_it->next) {
#line 1616 "book-view.c"
			PageView* _tmp19_;
			PageView* page = NULL;
#line 315 "../src/book-view.vala"
			_tmp19_ = _g_object_ref0 ((PageView*) page_it->data);
#line 315 "../src/book-view.vala"
			page = _tmp19_;
#line 1623 "book-view.c"
			{
				Page* p = NULL;
				PageView* _tmp20_;
				Page* _tmp21_;
				Page* _tmp22_;
				Page* _tmp23_;
				gint w = 0;
				Page* _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				gint h = 0;
				Page* _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
				Page* _tmp30_;
				gint _tmp31_;
				gint _tmp32_;
				Page* _tmp33_;
				gint _tmp34_;
				gint _tmp35_;
#line 317 "../src/book-view.vala"
				_tmp20_ = page;
#line 317 "../src/book-view.vala"
				_tmp21_ = page_view_get_page (_tmp20_);
#line 317 "../src/book-view.vala"
				_tmp22_ = _tmp21_;
#line 317 "../src/book-view.vala"
				_tmp23_ = _g_object_ref0 (_tmp22_);
#line 317 "../src/book-view.vala"
				p = _tmp23_;
#line 318 "../src/book-view.vala"
				_tmp24_ = p;
#line 318 "../src/book-view.vala"
				_tmp25_ = page_get_width (_tmp24_);
#line 318 "../src/book-view.vala"
				_tmp26_ = _tmp25_;
#line 318 "../src/book-view.vala"
				w = _tmp26_;
#line 319 "../src/book-view.vala"
				_tmp27_ = p;
#line 319 "../src/book-view.vala"
				_tmp28_ = page_get_height (_tmp27_);
#line 319 "../src/book-view.vala"
				_tmp29_ = _tmp28_;
#line 319 "../src/book-view.vala"
				h = _tmp29_;
#line 322 "../src/book-view.vala"
				_tmp30_ = p;
#line 322 "../src/book-view.vala"
				_tmp31_ = page_get_dpi (_tmp30_);
#line 322 "../src/book-view.vala"
				_tmp32_ = _tmp31_;
#line 322 "../src/book-view.vala"
				w = (gint) (((((gdouble) w) * max_dpi) / _tmp32_) + 0.5);
#line 323 "../src/book-view.vala"
				_tmp33_ = p;
#line 323 "../src/book-view.vala"
				_tmp34_ = page_get_dpi (_tmp33_);
#line 323 "../src/book-view.vala"
				_tmp35_ = _tmp34_;
#line 323 "../src/book-view.vala"
				h = (gint) (((((gdouble) h) * max_dpi) / _tmp35_) + 0.5);
#line 325 "../src/book-view.vala"
				if (w > max_width) {
#line 326 "../src/book-view.vala"
					max_width = w;
#line 1690 "book-view.c"
				}
#line 327 "../src/book-view.vala"
				if (h > max_height) {
#line 328 "../src/book-view.vala"
					max_height = h;
#line 1696 "book-view.c"
				}
#line 315 "../src/book-view.vala"
				_g_object_unref0 (p);
#line 315 "../src/book-view.vala"
				_g_object_unref0 (page);
#line 1702 "book-view.c"
			}
		}
	}
#line 331 "../src/book-view.vala"
	aspect = ((gdouble) width) / height;
#line 332 "../src/book-view.vala"
	max_aspect = ((gdouble) max_width) / max_height;
#line 335 "../src/book-view.vala"
	spacing = 12;
#line 336 "../src/book-view.vala"
	_vala_book_width = 0;
#line 337 "../src/book-view.vala"
	_vala_book_height = 0;
#line 338 "../src/book-view.vala"
	_tmp36_ = pages;
#line 1718 "book-view.c"
	{
		GList* page_collection = NULL;
		GList* page_it = NULL;
#line 338 "../src/book-view.vala"
		page_collection = _tmp36_;
#line 338 "../src/book-view.vala"
		for (page_it = page_collection; page_it != NULL; page_it = page_it->next) {
#line 1726 "book-view.c"
			PageView* _tmp37_;
			PageView* page = NULL;
#line 338 "../src/book-view.vala"
			_tmp37_ = _g_object_ref0 ((PageView*) page_it->data);
#line 338 "../src/book-view.vala"
			page = _tmp37_;
#line 1733 "book-view.c"
			{
				Page* p = NULL;
				PageView* _tmp38_;
				Page* _tmp39_;
				Page* _tmp40_;
				Page* _tmp41_;
				gint h = 0;
				PageView* _tmp56_;
				gint _tmp57_;
				gint _tmp58_;
				PageView* _tmp59_;
				gint _tmp60_;
				gint _tmp61_;
#line 340 "../src/book-view.vala"
				_tmp38_ = page;
#line 340 "../src/book-view.vala"
				_tmp39_ = page_view_get_page (_tmp38_);
#line 340 "../src/book-view.vala"
				_tmp40_ = _tmp39_;
#line 340 "../src/book-view.vala"
				_tmp41_ = _g_object_ref0 (_tmp40_);
#line 340 "../src/book-view.vala"
				p = _tmp41_;
#line 343 "../src/book-view.vala"
				if (max_aspect > aspect) {
#line 1759 "book-view.c"
					gint w = 0;
					Page* _tmp42_;
					gint _tmp43_;
					gint _tmp44_;
					Page* _tmp45_;
					gint _tmp46_;
					gint _tmp47_;
					PageView* _tmp48_;
#line 346 "../src/book-view.vala"
					_tmp42_ = p;
#line 346 "../src/book-view.vala"
					_tmp43_ = page_get_width (_tmp42_);
#line 346 "../src/book-view.vala"
					_tmp44_ = _tmp43_;
#line 346 "../src/book-view.vala"
					_tmp45_ = p;
#line 346 "../src/book-view.vala"
					_tmp46_ = page_get_dpi (_tmp45_);
#line 346 "../src/book-view.vala"
					_tmp47_ = _tmp46_;
#line 346 "../src/book-view.vala"
					w = (gint) (((((gdouble) _tmp44_) * max_dpi) * width) / (_tmp47_ * max_width));
#line 347 "../src/book-view.vala"
					_tmp48_ = page;
#line 347 "../src/book-view.vala"
					page_view_set_width (_tmp48_, w);
#line 1786 "book-view.c"
				} else {
					gint h = 0;
					Page* _tmp49_;
					gint _tmp50_;
					gint _tmp51_;
					Page* _tmp52_;
					gint _tmp53_;
					gint _tmp54_;
					PageView* _tmp55_;
#line 352 "../src/book-view.vala"
					_tmp49_ = p;
#line 352 "../src/book-view.vala"
					_tmp50_ = page_get_height (_tmp49_);
#line 352 "../src/book-view.vala"
					_tmp51_ = _tmp50_;
#line 352 "../src/book-view.vala"
					_tmp52_ = p;
#line 352 "../src/book-view.vala"
					_tmp53_ = page_get_dpi (_tmp52_);
#line 352 "../src/book-view.vala"
					_tmp54_ = _tmp53_;
#line 352 "../src/book-view.vala"
					h = (gint) (((((gdouble) _tmp51_) * max_dpi) * height) / (_tmp54_ * max_height));
#line 353 "../src/book-view.vala"
					_tmp55_ = page;
#line 353 "../src/book-view.vala"
					page_view_set_height (_tmp55_, h);
#line 1814 "book-view.c"
				}
#line 356 "../src/book-view.vala"
				_tmp56_ = page;
#line 356 "../src/book-view.vala"
				_tmp57_ = page_view_get_height (_tmp56_);
#line 356 "../src/book-view.vala"
				_tmp58_ = _tmp57_;
#line 356 "../src/book-view.vala"
				h = _tmp58_;
#line 357 "../src/book-view.vala"
				if (h > _vala_book_height) {
#line 358 "../src/book-view.vala"
					_vala_book_height = h;
#line 1828 "book-view.c"
				}
#line 359 "../src/book-view.vala"
				_tmp59_ = page;
#line 359 "../src/book-view.vala"
				_tmp60_ = page_view_get_width (_tmp59_);
#line 359 "../src/book-view.vala"
				_tmp61_ = _tmp60_;
#line 359 "../src/book-view.vala"
				_vala_book_width = _vala_book_width + (_tmp61_ + spacing);
#line 338 "../src/book-view.vala"
				_g_object_unref0 (p);
#line 338 "../src/book-view.vala"
				_g_object_unref0 (page);
#line 1842 "book-view.c"
			}
		}
	}
#line 361 "../src/book-view.vala"
	_tmp62_ = pages;
#line 361 "../src/book-view.vala"
	if (_tmp62_ != NULL) {
#line 362 "../src/book-view.vala"
		_vala_book_width = _vala_book_width - spacing;
#line 1852 "book-view.c"
	}
#line 364 "../src/book-view.vala"
	x_offset = 0;
#line 365 "../src/book-view.vala"
	_tmp63_ = pages;
#line 1858 "book-view.c"
	{
		GList* page_collection = NULL;
		GList* page_it = NULL;
#line 365 "../src/book-view.vala"
		page_collection = _tmp63_;
#line 365 "../src/book-view.vala"
		for (page_it = page_collection; page_it != NULL; page_it = page_it->next) {
#line 1866 "book-view.c"
			PageView* _tmp64_;
			PageView* page = NULL;
#line 365 "../src/book-view.vala"
			_tmp64_ = _g_object_ref0 ((PageView*) page_it->data);
#line 365 "../src/book-view.vala"
			page = _tmp64_;
#line 1873 "book-view.c"
			{
				PageView* _tmp65_;
				PageView* _tmp66_;
				gint _tmp67_;
				gint _tmp68_;
				PageView* _tmp69_;
				PageView* _tmp70_;
				gint _tmp71_;
				gint _tmp72_;
#line 368 "../src/book-view.vala"
				_tmp65_ = page;
#line 368 "../src/book-view.vala"
				page_view_set_x_offset (_tmp65_, x_offset);
#line 369 "../src/book-view.vala"
				_tmp66_ = page;
#line 369 "../src/book-view.vala"
				_tmp67_ = page_view_get_width (_tmp66_);
#line 369 "../src/book-view.vala"
				_tmp68_ = _tmp67_;
#line 369 "../src/book-view.vala"
				x_offset += _tmp68_ + spacing;
#line 372 "../src/book-view.vala"
				_tmp69_ = page;
#line 372 "../src/book-view.vala"
				_tmp70_ = page;
#line 372 "../src/book-view.vala"
				_tmp71_ = page_view_get_height (_tmp70_);
#line 372 "../src/book-view.vala"
				_tmp72_ = _tmp71_;
#line 372 "../src/book-view.vala"
				page_view_set_y_offset (_tmp69_, (height - _tmp72_) / 2);
#line 365 "../src/book-view.vala"
				_g_object_unref0 (page);
#line 1907 "book-view.c"
			}
		}
	}
#line 298 "../src/book-view.vala"
	(pages == NULL) ? NULL : (pages = (_g_list_free__g_object_unref0_ (pages), NULL));
#line 298 "../src/book-view.vala"
	if (book_width) {
#line 298 "../src/book-view.vala"
		*book_width = _vala_book_width;
#line 1917 "book-view.c"
	}
#line 298 "../src/book-view.vala"
	if (book_height) {
#line 298 "../src/book-view.vala"
		*book_height = _vala_book_height;
#line 1923 "book-view.c"
	}
}

static void
book_view_layout (BookView* self)
{
	GtkAllocation allocation = {0};
	GtkWidget* _tmp0_;
	GtkAllocation _tmp1_ = {0};
	GtkAllocation box_allocation = {0};
	GtkAllocation _tmp2_ = {0};
	gboolean right_aligned = FALSE;
	GtkAdjustment* _tmp3_;
	GtkAdjustment* _tmp4_;
	GtkAdjustment* _tmp5_;
	gint width = 0;
	GtkAllocation _tmp6_;
	gint height = 0;
	GtkAllocation _tmp7_;
	gint book_width = 0;
	gint book_height = 0;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	GtkAllocation _tmp10_;
#line 376 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 378 "../src/book-view.vala"
	if (!self->priv->need_layout) {
#line 379 "../src/book-view.vala"
		return;
#line 1954 "book-view.c"
	}
#line 381 "../src/book-view.vala"
	self->priv->laying_out = TRUE;
#line 384 "../src/book-view.vala"
	_tmp0_ = self->priv->drawing_area;
#line 384 "../src/book-view.vala"
	gtk_widget_get_allocation (_tmp0_, &_tmp1_);
#line 384 "../src/book-view.vala"
	allocation = _tmp1_;
#line 386 "../src/book-view.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp2_);
#line 386 "../src/book-view.vala"
	box_allocation = _tmp2_;
#line 389 "../src/book-view.vala"
	right_aligned = TRUE;
#line 390 "../src/book-view.vala"
	_tmp3_ = self->priv->adjustment;
#line 390 "../src/book-view.vala"
	_tmp4_ = self->priv->adjustment;
#line 390 "../src/book-view.vala"
	_tmp5_ = self->priv->adjustment;
#line 390 "../src/book-view.vala"
	if (gtk_adjustment_get_value (_tmp3_) < (gtk_adjustment_get_upper (_tmp4_) - gtk_adjustment_get_page_size (_tmp5_))) {
#line 391 "../src/book-view.vala"
		right_aligned = FALSE;
#line 1980 "book-view.c"
	}
#line 394 "../src/book-view.vala"
	_tmp6_ = allocation;
#line 394 "../src/book-view.vala"
	width = (gint) _tmp6_.width;
#line 395 "../src/book-view.vala"
	_tmp7_ = box_allocation;
#line 395 "../src/book-view.vala"
	height = (gint) (_tmp7_.height - (gtk_container_get_border_width ((GtkContainer*) self) * 2));
#line 397 "../src/book-view.vala"
	book_view_layout_into (self, width, height, &_tmp8_, &_tmp9_);
#line 397 "../src/book-view.vala"
	book_width = _tmp8_;
#line 397 "../src/book-view.vala"
	book_height = _tmp9_;
#line 400 "../src/book-view.vala"
	_tmp10_ = allocation;
#line 400 "../src/book-view.vala"
	if (book_width > _tmp10_.width) {
#line 2000 "book-view.c"
		GtkAllocation _tmp11_;
		gint _tmp12_ = 0;
		gint _tmp13_ = 0;
		GtkAdjustment* _tmp14_;
		GtkAdjustment* _tmp15_;
		GtkAdjustment* _tmp16_;
		GtkAllocation _tmp17_;
		gint max_offset = 0;
		GtkAllocation _tmp18_;
		gboolean _tmp19_ = FALSE;
		GtkScrollbar* _tmp22_;
#line 403 "../src/book-view.vala"
		_tmp11_ = allocation;
#line 403 "../src/book-view.vala"
		height = _tmp11_.height;
#line 404 "../src/book-view.vala"
		book_view_layout_into (self, width, height, &_tmp12_, &_tmp13_);
#line 404 "../src/book-view.vala"
		book_width = _tmp12_;
#line 404 "../src/book-view.vala"
		book_height = _tmp13_;
#line 407 "../src/book-view.vala"
		_tmp14_ = self->priv->adjustment;
#line 407 "../src/book-view.vala"
		gtk_adjustment_set_lower (_tmp14_, (gdouble) 0);
#line 408 "../src/book-view.vala"
		_tmp15_ = self->priv->adjustment;
#line 408 "../src/book-view.vala"
		gtk_adjustment_set_upper (_tmp15_, (gdouble) book_width);
#line 409 "../src/book-view.vala"
		_tmp16_ = self->priv->adjustment;
#line 409 "../src/book-view.vala"
		_tmp17_ = allocation;
#line 409 "../src/book-view.vala"
		gtk_adjustment_set_page_size (_tmp16_, (gdouble) _tmp17_.width);
#line 412 "../src/book-view.vala"
		_tmp18_ = allocation;
#line 412 "../src/book-view.vala"
		max_offset = book_width - _tmp18_.width;
#line 413 "../src/book-view.vala"
		if (right_aligned) {
#line 413 "../src/book-view.vala"
			_tmp19_ = TRUE;
#line 2044 "book-view.c"
		} else {
			gint _tmp20_;
			gint _tmp21_;
#line 413 "../src/book-view.vala"
			_tmp20_ = book_view_get_x_offset (self);
#line 413 "../src/book-view.vala"
			_tmp21_ = _tmp20_;
#line 413 "../src/book-view.vala"
			_tmp19_ = _tmp21_ > max_offset;
#line 2054 "book-view.c"
		}
#line 413 "../src/book-view.vala"
		if (_tmp19_) {
#line 414 "../src/book-view.vala"
			book_view_set_x_offset (self, max_offset);
#line 2060 "book-view.c"
		}
#line 416 "../src/book-view.vala"
		_tmp22_ = self->priv->scroll;
#line 416 "../src/book-view.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp22_, TRUE);
#line 2066 "book-view.c"
	} else {
		GtkScrollbar* _tmp23_;
		gint offset = 0;
		GtkAllocation _tmp24_;
		GtkAdjustment* _tmp25_;
		GtkAdjustment* _tmp26_;
		GtkAdjustment* _tmp27_;
#line 420 "../src/book-view.vala"
		_tmp23_ = self->priv->scroll;
#line 420 "../src/book-view.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp23_, FALSE);
#line 421 "../src/book-view.vala"
		_tmp24_ = allocation;
#line 421 "../src/book-view.vala"
		offset = (book_width - _tmp24_.width) / 2;
#line 422 "../src/book-view.vala"
		_tmp25_ = self->priv->adjustment;
#line 422 "../src/book-view.vala"
		gtk_adjustment_set_lower (_tmp25_, (gdouble) offset);
#line 423 "../src/book-view.vala"
		_tmp26_ = self->priv->adjustment;
#line 423 "../src/book-view.vala"
		gtk_adjustment_set_upper (_tmp26_, (gdouble) offset);
#line 424 "../src/book-view.vala"
		_tmp27_ = self->priv->adjustment;
#line 424 "../src/book-view.vala"
		gtk_adjustment_set_page_size (_tmp27_, (gdouble) 0);
#line 425 "../src/book-view.vala"
		book_view_set_x_offset (self, offset);
#line 2096 "book-view.c"
	}
#line 428 "../src/book-view.vala"
	if (self->priv->show_selected_page) {
#line 2100 "book-view.c"
		PageView* _tmp28_;
#line 429 "../src/book-view.vala"
		_tmp28_ = self->priv->selected_page_view;
#line 429 "../src/book-view.vala"
		book_view_show_page_view (self, _tmp28_);
#line 2106 "book-view.c"
	}
#line 431 "../src/book-view.vala"
	self->priv->need_layout = FALSE;
#line 432 "../src/book-view.vala"
	self->priv->show_selected_page = FALSE;
#line 433 "../src/book-view.vala"
	self->priv->laying_out = FALSE;
#line 2114 "book-view.c"
}

static gboolean
book_view_draw_cb (BookView* self,
                   GtkWidget* widget,
                   cairo_t* context)
{
	gdouble left = 0.0;
	gdouble top = 0.0;
	gdouble right = 0.0;
	gdouble bottom = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	GList* pages = NULL;
	GdkRGBA ruler_color = {0};
	GtkStyleContext* _tmp10_;
	GdkRGBA _tmp11_ = {0};
	GdkRGBA ruler_color_selected = {0};
	GdkRGBA _tmp12_ = {0};
	GList* _tmp13_;
	gboolean result;
#line 436 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 436 "../src/book-view.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 436 "../src/book-view.vala"
	g_return_val_if_fail (context != NULL, FALSE);
#line 438 "../src/book-view.vala"
	book_view_layout (self);
#line 441 "../src/book-view.vala"
	cairo_clip_extents (context, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 441 "../src/book-view.vala"
	left = _tmp0_;
#line 441 "../src/book-view.vala"
	top = _tmp1_;
#line 441 "../src/book-view.vala"
	right = _tmp2_;
#line 441 "../src/book-view.vala"
	bottom = _tmp3_;
#line 443 "../src/book-view.vala"
	pages = NULL;
#line 2158 "book-view.c"
	{
		gint i = 0;
#line 444 "../src/book-view.vala"
		i = 0;
#line 2163 "book-view.c"
		{
			gboolean _tmp4_ = FALSE;
#line 444 "../src/book-view.vala"
			_tmp4_ = TRUE;
#line 444 "../src/book-view.vala"
			while (TRUE) {
#line 2170 "book-view.c"
				Book* _tmp6_;
				guint _tmp7_;
				guint _tmp8_;
				PageView* _tmp9_;
#line 444 "../src/book-view.vala"
				if (!_tmp4_) {
#line 2177 "book-view.c"
					gint _tmp5_;
#line 444 "../src/book-view.vala"
					_tmp5_ = i;
#line 444 "../src/book-view.vala"
					i = _tmp5_ + 1;
#line 2183 "book-view.c"
				}
#line 444 "../src/book-view.vala"
				_tmp4_ = FALSE;
#line 444 "../src/book-view.vala"
				_tmp6_ = self->priv->_book;
#line 444 "../src/book-view.vala"
				_tmp7_ = book_get_n_pages (_tmp6_);
#line 444 "../src/book-view.vala"
				_tmp8_ = _tmp7_;
#line 444 "../src/book-view.vala"
				if (!(((guint) i) < _tmp8_)) {
#line 444 "../src/book-view.vala"
					break;
#line 2197 "book-view.c"
				}
#line 445 "../src/book-view.vala"
				_tmp9_ = book_view_get_nth_page (self, i);
#line 445 "../src/book-view.vala"
				pages = g_list_append (pages, _tmp9_);
#line 2203 "book-view.c"
			}
		}
	}
#line 447 "../src/book-view.vala"
	_tmp10_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 447 "../src/book-view.vala"
	gtk_style_context_get_color (_tmp10_, gtk_widget_get_state_flags ((GtkWidget*) self), &_tmp11_);
#line 447 "../src/book-view.vala"
	ruler_color = _tmp11_;
#line 448 "../src/book-view.vala"
	ruler_color_selected = _tmp12_;
#line 449 "../src/book-view.vala"
	gdk_rgba_parse (&ruler_color_selected, "#3584e4");
#line 452 "../src/book-view.vala"
	_tmp13_ = pages;
#line 2219 "book-view.c"
	{
		GList* page_collection = NULL;
		GList* page_it = NULL;
#line 452 "../src/book-view.vala"
		page_collection = _tmp13_;
#line 452 "../src/book-view.vala"
		for (page_it = page_collection; page_it != NULL; page_it = page_it->next) {
#line 2227 "book-view.c"
			PageView* _tmp14_;
			PageView* page = NULL;
#line 452 "../src/book-view.vala"
			_tmp14_ = _g_object_ref0 ((PageView*) page_it->data);
#line 452 "../src/book-view.vala"
			page = _tmp14_;
#line 2234 "book-view.c"
			{
				gint left_edge = 0;
				PageView* _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
				gint right_edge = 0;
				PageView* _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				PageView* _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				gint _tmp27_;
				gboolean _tmp28_ = FALSE;
				gint _tmp29_;
				gint _tmp30_;
				GdkRGBA _tmp31_ = {0};
				PageView* _tmp32_;
				PageView* _tmp33_;
				PageView* _tmp36_;
				PageView* _tmp37_;
				gboolean _tmp38_;
				gboolean _tmp39_;
#line 454 "../src/book-view.vala"
				_tmp15_ = page;
#line 454 "../src/book-view.vala"
				_tmp16_ = page_view_get_x_offset (_tmp15_);
#line 454 "../src/book-view.vala"
				_tmp17_ = _tmp16_;
#line 454 "../src/book-view.vala"
				_tmp18_ = book_view_get_x_offset (self);
#line 454 "../src/book-view.vala"
				_tmp19_ = _tmp18_;
#line 454 "../src/book-view.vala"
				left_edge = _tmp17_ - _tmp19_;
#line 455 "../src/book-view.vala"
				_tmp20_ = page;
#line 455 "../src/book-view.vala"
				_tmp21_ = page_view_get_x_offset (_tmp20_);
#line 455 "../src/book-view.vala"
				_tmp22_ = _tmp21_;
#line 455 "../src/book-view.vala"
				_tmp23_ = page;
#line 455 "../src/book-view.vala"
				_tmp24_ = page_view_get_width (_tmp23_);
#line 455 "../src/book-view.vala"
				_tmp25_ = _tmp24_;
#line 455 "../src/book-view.vala"
				_tmp26_ = book_view_get_x_offset (self);
#line 455 "../src/book-view.vala"
				_tmp27_ = _tmp26_;
#line 455 "../src/book-view.vala"
				right_edge = (_tmp22_ + _tmp25_) - _tmp27_;
#line 458 "../src/book-view.vala"
				if (((gdouble) right_edge) < left) {
#line 458 "../src/book-view.vala"
					_tmp28_ = TRUE;
#line 2295 "book-view.c"
				} else {
#line 458 "../src/book-view.vala"
					_tmp28_ = ((gdouble) left_edge) > right;
#line 2299 "book-view.c"
				}
#line 458 "../src/book-view.vala"
				if (_tmp28_) {
#line 459 "../src/book-view.vala"
					_g_object_unref0 (page);
#line 459 "../src/book-view.vala"
					continue;
#line 2307 "book-view.c"
				}
#line 461 "../src/book-view.vala"
				cairo_save (context);
#line 462 "../src/book-view.vala"
				_tmp29_ = book_view_get_x_offset (self);
#line 462 "../src/book-view.vala"
				_tmp30_ = _tmp29_;
#line 462 "../src/book-view.vala"
				cairo_translate (context, (gdouble) (-_tmp30_), (gdouble) 0);
#line 463 "../src/book-view.vala"
				_tmp32_ = page;
#line 463 "../src/book-view.vala"
				_tmp33_ = self->priv->selected_page_view;
#line 463 "../src/book-view.vala"
				if (_tmp32_ == _tmp33_) {
#line 2323 "book-view.c"
					GdkRGBA _tmp34_;
#line 463 "../src/book-view.vala"
					_tmp34_ = ruler_color_selected;
#line 463 "../src/book-view.vala"
					_tmp31_ = _tmp34_;
#line 2329 "book-view.c"
				} else {
					GdkRGBA _tmp35_;
#line 463 "../src/book-view.vala"
					_tmp35_ = ruler_color;
#line 463 "../src/book-view.vala"
					_tmp31_ = _tmp35_;
#line 2336 "book-view.c"
				}
#line 463 "../src/book-view.vala"
				_tmp36_ = page;
#line 463 "../src/book-view.vala"
				page_view_render (_tmp36_, context, &_tmp31_);
#line 464 "../src/book-view.vala"
				cairo_restore (context);
#line 466 "../src/book-view.vala"
				_tmp37_ = page;
#line 466 "../src/book-view.vala"
				_tmp38_ = page_view_get_selected (_tmp37_);
#line 466 "../src/book-view.vala"
				_tmp39_ = _tmp38_;
#line 466 "../src/book-view.vala"
				if (_tmp39_) {
#line 2352 "book-view.c"
					GtkWidget* _tmp40_;
					GtkStyleContext* _tmp41_;
					PageView* _tmp42_;
					gint _tmp43_;
					gint _tmp44_;
					gint _tmp45_;
					gint _tmp46_;
					PageView* _tmp47_;
					gint _tmp48_;
					gint _tmp49_;
					PageView* _tmp50_;
					gint _tmp51_;
					gint _tmp52_;
					PageView* _tmp53_;
					gint _tmp54_;
					gint _tmp55_;
#line 467 "../src/book-view.vala"
					_tmp40_ = self->priv->drawing_area;
#line 467 "../src/book-view.vala"
					_tmp41_ = gtk_widget_get_style_context (_tmp40_);
#line 467 "../src/book-view.vala"
					_tmp42_ = page;
#line 467 "../src/book-view.vala"
					_tmp43_ = page_view_get_x_offset (_tmp42_);
#line 467 "../src/book-view.vala"
					_tmp44_ = _tmp43_;
#line 467 "../src/book-view.vala"
					_tmp45_ = book_view_get_x_offset (self);
#line 467 "../src/book-view.vala"
					_tmp46_ = _tmp45_;
#line 467 "../src/book-view.vala"
					_tmp47_ = page;
#line 467 "../src/book-view.vala"
					_tmp48_ = page_view_get_y_offset (_tmp47_);
#line 467 "../src/book-view.vala"
					_tmp49_ = _tmp48_;
#line 467 "../src/book-view.vala"
					_tmp50_ = page;
#line 467 "../src/book-view.vala"
					_tmp51_ = page_view_get_width (_tmp50_);
#line 467 "../src/book-view.vala"
					_tmp52_ = _tmp51_;
#line 467 "../src/book-view.vala"
					_tmp53_ = page;
#line 467 "../src/book-view.vala"
					_tmp54_ = page_view_get_height (_tmp53_);
#line 467 "../src/book-view.vala"
					_tmp55_ = _tmp54_;
#line 467 "../src/book-view.vala"
					gtk_render_focus (_tmp41_, context, (gdouble) (_tmp44_ - _tmp46_), (gdouble) _tmp49_, (gdouble) _tmp52_, (gdouble) _tmp55_);
#line 2403 "book-view.c"
				}
#line 452 "../src/book-view.vala"
				_g_object_unref0 (page);
#line 2407 "book-view.c"
			}
		}
	}
#line 474 "../src/book-view.vala"
	result = FALSE;
#line 474 "../src/book-view.vala"
	(pages == NULL) ? NULL : (pages = (_g_list_free__g_object_unref0_ (pages), NULL));
#line 474 "../src/book-view.vala"
	return result;
#line 2417 "book-view.c"
}

static PageView*
book_view_get_page_at (BookView* self,
                       gint x,
                       gint y,
                       gint* x_,
                       gint* y_)
{
	gint _vala_x_ = 0;
	gint _vala_y_ = 0;
	PageView* result;
#line 477 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 479 "../src/book-view.vala"
	_vala_y_ = 0;
#line 479 "../src/book-view.vala"
	_vala_x_ = _vala_y_;
#line 2436 "book-view.c"
	{
		gint i = 0;
#line 480 "../src/book-view.vala"
		i = 0;
#line 2441 "book-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 480 "../src/book-view.vala"
			_tmp0_ = TRUE;
#line 480 "../src/book-view.vala"
			while (TRUE) {
#line 2448 "book-view.c"
				Book* _tmp2_;
				guint _tmp3_;
				guint _tmp4_;
				PageView* page = NULL;
				PageView* _tmp5_;
				gint left = 0;
				PageView* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				gint right = 0;
				PageView* _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				gint top = 0;
				PageView* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
				gint bottom = 0;
				PageView* _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				gboolean _tmp18_ = FALSE;
				gboolean _tmp19_ = FALSE;
				gboolean _tmp20_ = FALSE;
#line 480 "../src/book-view.vala"
				if (!_tmp0_) {
#line 2475 "book-view.c"
					gint _tmp1_;
#line 480 "../src/book-view.vala"
					_tmp1_ = i;
#line 480 "../src/book-view.vala"
					i = _tmp1_ + 1;
#line 2481 "book-view.c"
				}
#line 480 "../src/book-view.vala"
				_tmp0_ = FALSE;
#line 480 "../src/book-view.vala"
				_tmp2_ = self->priv->_book;
#line 480 "../src/book-view.vala"
				_tmp3_ = book_get_n_pages (_tmp2_);
#line 480 "../src/book-view.vala"
				_tmp4_ = _tmp3_;
#line 480 "../src/book-view.vala"
				if (!(((guint) i) < _tmp4_)) {
#line 480 "../src/book-view.vala"
					break;
#line 2495 "book-view.c"
				}
#line 482 "../src/book-view.vala"
				_tmp5_ = book_view_get_nth_page (self, i);
#line 482 "../src/book-view.vala"
				page = _tmp5_;
#line 483 "../src/book-view.vala"
				_tmp6_ = page;
#line 483 "../src/book-view.vala"
				_tmp7_ = page_view_get_x_offset (_tmp6_);
#line 483 "../src/book-view.vala"
				_tmp8_ = _tmp7_;
#line 483 "../src/book-view.vala"
				left = _tmp8_;
#line 484 "../src/book-view.vala"
				_tmp9_ = page;
#line 484 "../src/book-view.vala"
				_tmp10_ = page_view_get_width (_tmp9_);
#line 484 "../src/book-view.vala"
				_tmp11_ = _tmp10_;
#line 484 "../src/book-view.vala"
				right = left + _tmp11_;
#line 485 "../src/book-view.vala"
				_tmp12_ = page;
#line 485 "../src/book-view.vala"
				_tmp13_ = page_view_get_y_offset (_tmp12_);
#line 485 "../src/book-view.vala"
				_tmp14_ = _tmp13_;
#line 485 "../src/book-view.vala"
				top = _tmp14_;
#line 486 "../src/book-view.vala"
				_tmp15_ = page;
#line 486 "../src/book-view.vala"
				_tmp16_ = page_view_get_height (_tmp15_);
#line 486 "../src/book-view.vala"
				_tmp17_ = _tmp16_;
#line 486 "../src/book-view.vala"
				bottom = top + _tmp17_;
#line 487 "../src/book-view.vala"
				if (x >= left) {
#line 487 "../src/book-view.vala"
					_tmp20_ = x <= right;
#line 2537 "book-view.c"
				} else {
#line 487 "../src/book-view.vala"
					_tmp20_ = FALSE;
#line 2541 "book-view.c"
				}
#line 487 "../src/book-view.vala"
				if (_tmp20_) {
#line 487 "../src/book-view.vala"
					_tmp19_ = y >= top;
#line 2547 "book-view.c"
				} else {
#line 487 "../src/book-view.vala"
					_tmp19_ = FALSE;
#line 2551 "book-view.c"
				}
#line 487 "../src/book-view.vala"
				if (_tmp19_) {
#line 487 "../src/book-view.vala"
					_tmp18_ = y <= bottom;
#line 2557 "book-view.c"
				} else {
#line 487 "../src/book-view.vala"
					_tmp18_ = FALSE;
#line 2561 "book-view.c"
				}
#line 487 "../src/book-view.vala"
				if (_tmp18_) {
#line 489 "../src/book-view.vala"
					_vala_x_ = x - left;
#line 490 "../src/book-view.vala"
					_vala_y_ = y - top;
#line 491 "../src/book-view.vala"
					result = page;
#line 491 "../src/book-view.vala"
					if (x_) {
#line 491 "../src/book-view.vala"
						*x_ = _vala_x_;
#line 2575 "book-view.c"
					}
#line 491 "../src/book-view.vala"
					if (y_) {
#line 491 "../src/book-view.vala"
						*y_ = _vala_y_;
#line 2581 "book-view.c"
					}
#line 491 "../src/book-view.vala"
					return result;
#line 2585 "book-view.c"
				}
#line 480 "../src/book-view.vala"
				_g_object_unref0 (page);
#line 2589 "book-view.c"
			}
		}
	}
#line 495 "../src/book-view.vala"
	result = NULL;
#line 495 "../src/book-view.vala"
	if (x_) {
#line 495 "../src/book-view.vala"
		*x_ = _vala_x_;
#line 2599 "book-view.c"
	}
#line 495 "../src/book-view.vala"
	if (y_) {
#line 495 "../src/book-view.vala"
		*y_ = _vala_y_;
#line 2605 "book-view.c"
	}
#line 495 "../src/book-view.vala"
	return result;
#line 2609 "book-view.c"
}

static gboolean
book_view_button_cb (BookView* self,
                     GtkWidget* widget,
                     GdkEventButton* event)
{
	GtkWidget* _tmp0_;
	gint x = 0;
	gint y = 0;
	PageView* _tmp7_;
	gboolean result;
#line 498 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 498 "../src/book-view.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 498 "../src/book-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 500 "../src/book-view.vala"
	book_view_layout (self);
#line 502 "../src/book-view.vala"
	_tmp0_ = self->priv->drawing_area;
#line 502 "../src/book-view.vala"
	gtk_widget_grab_focus (_tmp0_);
#line 504 "../src/book-view.vala"
	x = 0;
#line 504 "../src/book-view.vala"
	y = 0;
#line 505 "../src/book-view.vala"
	if (event->type == GDK_BUTTON_PRESS) {
#line 2640 "book-view.c"
		gint _tmp1_;
		gint _tmp2_;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		PageView* _tmp5_;
		PageView* _tmp6_;
#line 506 "../src/book-view.vala"
		_tmp1_ = book_view_get_x_offset (self);
#line 506 "../src/book-view.vala"
		_tmp2_ = _tmp1_;
#line 506 "../src/book-view.vala"
		_tmp5_ = book_view_get_page_at (self, (gint) (event->x + _tmp2_), (gint) event->y, &_tmp3_, &_tmp4_);
#line 506 "../src/book-view.vala"
		x = _tmp3_;
#line 506 "../src/book-view.vala"
		y = _tmp4_;
#line 506 "../src/book-view.vala"
		_tmp6_ = _tmp5_;
#line 506 "../src/book-view.vala"
		book_view_select_page_view (self, _tmp6_);
#line 506 "../src/book-view.vala"
		_g_object_unref0 (_tmp6_);
#line 2663 "book-view.c"
	}
#line 508 "../src/book-view.vala"
	_tmp7_ = self->priv->selected_page_view;
#line 508 "../src/book-view.vala"
	if (_tmp7_ == NULL) {
#line 509 "../src/book-view.vala"
		result = FALSE;
#line 509 "../src/book-view.vala"
		return result;
#line 2673 "book-view.c"
	}
#line 512 "../src/book-view.vala"
	if (event->button == ((guint) 1)) {
#line 514 "../src/book-view.vala"
		if (event->type == GDK_BUTTON_PRESS) {
#line 2679 "book-view.c"
			PageView* _tmp8_;
#line 515 "../src/book-view.vala"
			_tmp8_ = self->priv->selected_page_view;
#line 515 "../src/book-view.vala"
			page_view_button_press (_tmp8_, x, y);
#line 2685 "book-view.c"
		} else {
#line 516 "../src/book-view.vala"
			if (event->type == GDK_BUTTON_RELEASE) {
#line 2689 "book-view.c"
				PageView* _tmp9_;
#line 517 "../src/book-view.vala"
				_tmp9_ = self->priv->selected_page_view;
#line 517 "../src/book-view.vala"
				page_view_button_release (_tmp9_, x, y);
#line 2695 "book-view.c"
			} else {
#line 518 "../src/book-view.vala"
				if (event->type == GDK_2BUTTON_PRESS) {
#line 2699 "book-view.c"
					Page* _tmp10_;
					Page* _tmp11_;
#line 519 "../src/book-view.vala"
					_tmp10_ = book_view_get_selected_page (self);
#line 519 "../src/book-view.vala"
					_tmp11_ = _tmp10_;
#line 519 "../src/book-view.vala"
					g_signal_emit (self, book_view_signals[BOOK_VIEW_SHOW_PAGE_SIGNAL], 0, _tmp11_);
#line 2708 "book-view.c"
				}
			}
		}
	}
#line 523 "../src/book-view.vala"
	if (event->button == ((guint) 3)) {
#line 524 "../src/book-view.vala"
		g_signal_emit (self, book_view_signals[BOOK_VIEW_SHOW_MENU_SIGNAL], 0, (GdkEvent*) event);
#line 2717 "book-view.c"
	}
#line 526 "../src/book-view.vala"
	result = FALSE;
#line 526 "../src/book-view.vala"
	return result;
#line 2723 "book-view.c"
}

static void
book_view_set_cursor (BookView* self,
                      GdkCursorType cursor)
{
	GdkCursor* c = NULL;
	GdkDisplay* _tmp0_;
	GdkCursor* _tmp1_;
	GtkWidget* _tmp2_;
	GdkWindow* _tmp3_;
	GdkCursor* _tmp4_;
#line 529 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 533 "../src/book-view.vala"
	if (self->priv->cursor == cursor) {
#line 534 "../src/book-view.vala"
		_g_object_unref0 (c);
#line 534 "../src/book-view.vala"
		return;
#line 2744 "book-view.c"
	}
#line 535 "../src/book-view.vala"
	self->priv->cursor = cursor;
#line 537 "../src/book-view.vala"
	_tmp0_ = gtk_widget_get_display ((GtkWidget*) self);
#line 537 "../src/book-view.vala"
	_tmp1_ = gdk_cursor_new_for_display (_tmp0_, cursor);
#line 537 "../src/book-view.vala"
	_g_object_unref0 (c);
#line 537 "../src/book-view.vala"
	c = _tmp1_;
#line 538 "../src/book-view.vala"
	_tmp2_ = self->priv->drawing_area;
#line 538 "../src/book-view.vala"
	_tmp3_ = gtk_widget_get_window (_tmp2_);
#line 538 "../src/book-view.vala"
	_tmp4_ = c;
#line 538 "../src/book-view.vala"
	gdk_window_set_cursor (_tmp3_, _tmp4_);
#line 529 "../src/book-view.vala"
	_g_object_unref0 (c);
#line 2766 "book-view.c"
}

static gboolean
book_view_motion_cb (BookView* self,
                     GtkWidget* widget,
                     GdkEventMotion* event)
{
	GdkCursorType cursor = 0;
	gboolean _tmp0_ = FALSE;
	PageView* _tmp1_;
	gboolean result;
#line 541 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 541 "../src/book-view.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 541 "../src/book-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 543 "../src/book-view.vala"
	cursor = GDK_ARROW;
#line 546 "../src/book-view.vala"
	_tmp1_ = self->priv->selected_page_view;
#line 546 "../src/book-view.vala"
	if (_tmp1_ != NULL) {
#line 546 "../src/book-view.vala"
		_tmp0_ = (event->state & GDK_BUTTON1_MASK) != 0;
#line 2792 "book-view.c"
	} else {
#line 546 "../src/book-view.vala"
		_tmp0_ = FALSE;
#line 2796 "book-view.c"
	}
#line 546 "../src/book-view.vala"
	if (_tmp0_) {
#line 2800 "book-view.c"
		gint x = 0;
		gint _tmp2_;
		gint _tmp3_;
		PageView* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint y = 0;
		PageView* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		PageView* _tmp10_;
		PageView* _tmp11_;
		GdkCursorType _tmp12_;
		GdkCursorType _tmp13_;
#line 548 "../src/book-view.vala"
		_tmp2_ = book_view_get_x_offset (self);
#line 548 "../src/book-view.vala"
		_tmp3_ = _tmp2_;
#line 548 "../src/book-view.vala"
		_tmp4_ = self->priv->selected_page_view;
#line 548 "../src/book-view.vala"
		_tmp5_ = page_view_get_x_offset (_tmp4_);
#line 548 "../src/book-view.vala"
		_tmp6_ = _tmp5_;
#line 548 "../src/book-view.vala"
		x = (gint) ((event->x + _tmp3_) - _tmp6_);
#line 549 "../src/book-view.vala"
		_tmp7_ = self->priv->selected_page_view;
#line 549 "../src/book-view.vala"
		_tmp8_ = page_view_get_y_offset (_tmp7_);
#line 549 "../src/book-view.vala"
		_tmp9_ = _tmp8_;
#line 549 "../src/book-view.vala"
		y = (gint) (event->y - _tmp9_);
#line 550 "../src/book-view.vala"
		_tmp10_ = self->priv->selected_page_view;
#line 550 "../src/book-view.vala"
		page_view_motion (_tmp10_, x, y);
#line 551 "../src/book-view.vala"
		_tmp11_ = self->priv->selected_page_view;
#line 551 "../src/book-view.vala"
		_tmp12_ = page_view_get_cursor (_tmp11_);
#line 551 "../src/book-view.vala"
		_tmp13_ = _tmp12_;
#line 551 "../src/book-view.vala"
		cursor = _tmp13_;
#line 2847 "book-view.c"
	} else {
		gint x = 0;
		gint y = 0;
		PageView* over_page = NULL;
		gint _tmp14_;
		gint _tmp15_;
		gint _tmp16_ = 0;
		gint _tmp17_ = 0;
		PageView* _tmp18_;
		PageView* _tmp19_;
#line 556 "../src/book-view.vala"
		_tmp14_ = book_view_get_x_offset (self);
#line 556 "../src/book-view.vala"
		_tmp15_ = _tmp14_;
#line 556 "../src/book-view.vala"
		_tmp18_ = book_view_get_page_at (self, (gint) (event->x + _tmp15_), (gint) event->y, &_tmp16_, &_tmp17_);
#line 556 "../src/book-view.vala"
		x = _tmp16_;
#line 556 "../src/book-view.vala"
		y = _tmp17_;
#line 556 "../src/book-view.vala"
		over_page = _tmp18_;
#line 557 "../src/book-view.vala"
		_tmp19_ = over_page;
#line 557 "../src/book-view.vala"
		if (_tmp19_ != NULL) {
#line 2874 "book-view.c"
			PageView* _tmp20_;
			PageView* _tmp21_;
			GdkCursorType _tmp22_;
			GdkCursorType _tmp23_;
#line 559 "../src/book-view.vala"
			_tmp20_ = over_page;
#line 559 "../src/book-view.vala"
			page_view_motion (_tmp20_, x, y);
#line 560 "../src/book-view.vala"
			_tmp21_ = over_page;
#line 560 "../src/book-view.vala"
			_tmp22_ = page_view_get_cursor (_tmp21_);
#line 560 "../src/book-view.vala"
			_tmp23_ = _tmp22_;
#line 560 "../src/book-view.vala"
			cursor = _tmp23_;
#line 2891 "book-view.c"
		}
#line 546 "../src/book-view.vala"
		_g_object_unref0 (over_page);
#line 2895 "book-view.c"
	}
#line 564 "../src/book-view.vala"
	book_view_set_cursor (self, cursor);
#line 566 "../src/book-view.vala"
	result = FALSE;
#line 566 "../src/book-view.vala"
	return result;
#line 2903 "book-view.c"
}

static gboolean
book_view_key_cb (BookView* self,
                  GtkWidget* widget,
                  GdkEventKey* event)
{
	gboolean result;
#line 569 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 569 "../src/book-view.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 569 "../src/book-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 571 "../src/book-view.vala"
	switch (event->keyval) {
#line 571 "../src/book-view.vala"
		case 0xff50:
#line 2922 "book-view.c"
		{
			Book* _tmp0_;
			Page* _tmp1_;
			Page* _tmp2_;
#line 574 "../src/book-view.vala"
			_tmp0_ = self->priv->_book;
#line 574 "../src/book-view.vala"
			_tmp1_ = book_get_page (_tmp0_, 0);
#line 574 "../src/book-view.vala"
			_tmp2_ = _tmp1_;
#line 574 "../src/book-view.vala"
			book_view_set_selected_page (self, _tmp2_);
#line 574 "../src/book-view.vala"
			_g_object_unref0 (_tmp2_);
#line 575 "../src/book-view.vala"
			result = TRUE;
#line 575 "../src/book-view.vala"
			return result;
#line 2941 "book-view.c"
		}
#line 571 "../src/book-view.vala"
		case 0xff51:
#line 2945 "book-view.c"
		{
			PageView* _tmp3_;
			PageView* _tmp4_;
			PageView* _tmp5_;
#line 577 "../src/book-view.vala"
			_tmp3_ = self->priv->selected_page_view;
#line 577 "../src/book-view.vala"
			_tmp4_ = book_view_get_prev_page (self, _tmp3_);
#line 577 "../src/book-view.vala"
			_tmp5_ = _tmp4_;
#line 577 "../src/book-view.vala"
			book_view_select_page_view (self, _tmp5_);
#line 577 "../src/book-view.vala"
			_g_object_unref0 (_tmp5_);
#line 578 "../src/book-view.vala"
			result = TRUE;
#line 578 "../src/book-view.vala"
			return result;
#line 2964 "book-view.c"
		}
#line 571 "../src/book-view.vala"
		case 0xff53:
#line 2968 "book-view.c"
		{
			PageView* _tmp6_;
			PageView* _tmp7_;
			PageView* _tmp8_;
#line 580 "../src/book-view.vala"
			_tmp6_ = self->priv->selected_page_view;
#line 580 "../src/book-view.vala"
			_tmp7_ = book_view_get_next_page (self, _tmp6_);
#line 580 "../src/book-view.vala"
			_tmp8_ = _tmp7_;
#line 580 "../src/book-view.vala"
			book_view_select_page_view (self, _tmp8_);
#line 580 "../src/book-view.vala"
			_g_object_unref0 (_tmp8_);
#line 581 "../src/book-view.vala"
			result = TRUE;
#line 581 "../src/book-view.vala"
			return result;
#line 2987 "book-view.c"
		}
#line 571 "../src/book-view.vala"
		case 0xFF57:
#line 2991 "book-view.c"
		{
			Book* _tmp9_;
			Book* _tmp10_;
			guint _tmp11_;
			guint _tmp12_;
			Page* _tmp13_;
			Page* _tmp14_;
#line 583 "../src/book-view.vala"
			_tmp9_ = self->priv->_book;
#line 583 "../src/book-view.vala"
			_tmp10_ = self->priv->_book;
#line 583 "../src/book-view.vala"
			_tmp11_ = book_get_n_pages (_tmp10_);
#line 583 "../src/book-view.vala"
			_tmp12_ = _tmp11_;
#line 583 "../src/book-view.vala"
			_tmp13_ = book_get_page (_tmp9_, ((gint) _tmp12_) - 1);
#line 583 "../src/book-view.vala"
			_tmp14_ = _tmp13_;
#line 583 "../src/book-view.vala"
			book_view_set_selected_page (self, _tmp14_);
#line 583 "../src/book-view.vala"
			_g_object_unref0 (_tmp14_);
#line 584 "../src/book-view.vala"
			result = TRUE;
#line 584 "../src/book-view.vala"
			return result;
#line 3019 "book-view.c"
		}
		default:
		{
#line 587 "../src/book-view.vala"
			result = FALSE;
#line 587 "../src/book-view.vala"
			return result;
#line 3027 "book-view.c"
		}
	}
}

static gboolean
book_view_focus_cb (BookView* self,
                    GtkWidget* widget,
                    GdkEventFocus* event)
{
	PageView* _tmp0_;
	gboolean result;
#line 591 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 591 "../src/book-view.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 591 "../src/book-view.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 593 "../src/book-view.vala"
	_tmp0_ = self->priv->selected_page_view;
#line 593 "../src/book-view.vala"
	book_view_set_selected_page_view (self, _tmp0_);
#line 594 "../src/book-view.vala"
	result = FALSE;
#line 594 "../src/book-view.vala"
	return result;
#line 3053 "book-view.c"
}

static void
book_view_scroll_cb (BookView* self,
                     GtkAdjustment* adjustment)
{
#line 597 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 597 "../src/book-view.vala"
	g_return_if_fail (adjustment != NULL);
#line 599 "../src/book-view.vala"
	if (!self->priv->laying_out) {
#line 600 "../src/book-view.vala"
		book_view_redraw (self);
#line 3068 "book-view.c"
	}
}

void
book_view_redraw (BookView* self)
{
	GtkWidget* _tmp0_;
#line 603 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 605 "../src/book-view.vala"
	_tmp0_ = self->priv->drawing_area;
#line 605 "../src/book-view.vala"
	gtk_widget_queue_draw (_tmp0_);
#line 3082 "book-view.c"
}

void
book_view_select_next_page (BookView* self)
{
	PageView* _tmp0_;
	PageView* _tmp1_;
	PageView* _tmp2_;
#line 608 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 610 "../src/book-view.vala"
	_tmp0_ = self->priv->selected_page_view;
#line 610 "../src/book-view.vala"
	_tmp1_ = book_view_get_next_page (self, _tmp0_);
#line 610 "../src/book-view.vala"
	_tmp2_ = _tmp1_;
#line 610 "../src/book-view.vala"
	book_view_select_page_view (self, _tmp2_);
#line 610 "../src/book-view.vala"
	_g_object_unref0 (_tmp2_);
#line 3103 "book-view.c"
}

void
book_view_select_prev_page (BookView* self)
{
	PageView* _tmp0_;
	PageView* _tmp1_;
	PageView* _tmp2_;
#line 613 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 615 "../src/book-view.vala"
	_tmp0_ = self->priv->selected_page_view;
#line 615 "../src/book-view.vala"
	_tmp1_ = book_view_get_prev_page (self, _tmp0_);
#line 615 "../src/book-view.vala"
	_tmp2_ = _tmp1_;
#line 615 "../src/book-view.vala"
	book_view_select_page_view (self, _tmp2_);
#line 615 "../src/book-view.vala"
	_g_object_unref0 (_tmp2_);
#line 3124 "book-view.c"
}

Book*
book_view_get_book (BookView* self)
{
	Book* result;
	Book* _tmp0_;
#line 18 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 18 "../src/book-view.vala"
	_tmp0_ = self->priv->_book;
#line 18 "../src/book-view.vala"
	result = _tmp0_;
#line 18 "../src/book-view.vala"
	return result;
#line 3140 "book-view.c"
}

static void
book_view_set_book (BookView* self,
                    Book* value)
{
	Book* old_value;
#line 18 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 18 "../src/book-view.vala"
	old_value = book_view_get_book (self);
#line 18 "../src/book-view.vala"
	if (old_value != value) {
#line 3154 "book-view.c"
		Book* _tmp0_;
#line 18 "../src/book-view.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 18 "../src/book-view.vala"
		_g_object_unref0 (self->priv->_book);
#line 18 "../src/book-view.vala"
		self->priv->_book = _tmp0_;
#line 18 "../src/book-view.vala"
		g_object_notify_by_pspec ((GObject *) self, book_view_properties[BOOK_VIEW_BOOK_PROPERTY]);
#line 3164 "book-view.c"
	}
}

Page*
book_view_get_selected_page (BookView* self)
{
	Page* result;
	PageView* _tmp0_;
#line 30 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../src/book-view.vala"
	_tmp0_ = self->priv->selected_page_view;
#line 32 "../src/book-view.vala"
	if (_tmp0_ != NULL) {
#line 3179 "book-view.c"
		PageView* _tmp1_;
		Page* _tmp2_;
		Page* _tmp3_;
#line 33 "../src/book-view.vala"
		_tmp1_ = self->priv->selected_page_view;
#line 33 "../src/book-view.vala"
		_tmp2_ = page_view_get_page (_tmp1_);
#line 33 "../src/book-view.vala"
		_tmp3_ = _tmp2_;
#line 33 "../src/book-view.vala"
		result = _tmp3_;
#line 33 "../src/book-view.vala"
		return result;
#line 3193 "book-view.c"
	} else {
#line 35 "../src/book-view.vala"
		result = NULL;
#line 35 "../src/book-view.vala"
		return result;
#line 3199 "book-view.c"
	}
}

void
book_view_set_selected_page (BookView* self,
                             Page* value)
{
	Page* _tmp0_;
	Page* _tmp1_;
#line 37 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/book-view.vala"
	_tmp0_ = book_view_get_selected_page (self);
#line 39 "../src/book-view.vala"
	_tmp1_ = _tmp0_;
#line 39 "../src/book-view.vala"
	if (_tmp1_ == value) {
#line 40 "../src/book-view.vala"
		return;
#line 3219 "book-view.c"
	}
#line 42 "../src/book-view.vala"
	if (value != NULL) {
#line 3223 "book-view.c"
		GHashTable* _tmp2_;
		gconstpointer _tmp3_;
#line 43 "../src/book-view.vala"
		_tmp2_ = self->priv->page_data;
#line 43 "../src/book-view.vala"
		_tmp3_ = g_hash_table_lookup (_tmp2_, value);
#line 43 "../src/book-view.vala"
		book_view_select_page_view (self, (PageView*) _tmp3_);
#line 3232 "book-view.c"
	} else {
#line 45 "../src/book-view.vala"
		book_view_select_page_view (self, NULL);
#line 3236 "book-view.c"
	}
#line 37 "../src/book-view.vala"
	g_object_notify_by_pspec ((GObject *) self, book_view_properties[BOOK_VIEW_SELECTED_PAGE_PROPERTY]);
#line 3240 "book-view.c"
}

gint
book_view_get_x_offset (BookView* self)
{
	gint result;
	GtkAdjustment* _tmp0_;
#line 64 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 66 "../src/book-view.vala"
	_tmp0_ = self->priv->adjustment;
#line 66 "../src/book-view.vala"
	result = (gint) gtk_adjustment_get_value (_tmp0_);
#line 66 "../src/book-view.vala"
	return result;
#line 3256 "book-view.c"
}

void
book_view_set_x_offset (BookView* self,
                        gint value)
{
	GtkAdjustment* _tmp0_;
#line 68 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 70 "../src/book-view.vala"
	_tmp0_ = self->priv->adjustment;
#line 70 "../src/book-view.vala"
	gtk_adjustment_set_value (_tmp0_, (gdouble) value);
#line 68 "../src/book-view.vala"
	g_object_notify_by_pspec ((GObject *) self, book_view_properties[BOOK_VIEW_X_OFFSET_PROPERTY]);
#line 3272 "book-view.c"
}

static void
book_view_class_init (BookViewClass * klass,
                      gpointer klass_data)
{
#line 15 "../src/book-view.vala"
	book_view_parent_class = g_type_class_peek_parent (klass);
#line 15 "../src/book-view.vala"
	g_type_class_adjust_private_offset (klass, &BookView_private_offset);
#line 15 "../src/book-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_book_view_get_property;
#line 15 "../src/book-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_book_view_set_property;
#line 15 "../src/book-view.vala"
	G_OBJECT_CLASS (klass)->finalize = book_view_finalize;
#line 15 "../src/book-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOOK_VIEW_BOOK_PROPERTY, book_view_properties[BOOK_VIEW_BOOK_PROPERTY] = g_param_spec_object ("book", "book", "book", TYPE_BOOK, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 15 "../src/book-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOOK_VIEW_SELECTED_PAGE_PROPERTY, book_view_properties[BOOK_VIEW_SELECTED_PAGE_PROPERTY] = g_param_spec_object ("selected-page", "selected-page", "selected-page", TYPE_PAGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15 "../src/book-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOOK_VIEW_X_OFFSET_PROPERTY, book_view_properties[BOOK_VIEW_X_OFFSET_PROPERTY] = g_param_spec_int ("x-offset", "x-offset", "x-offset", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15 "../src/book-view.vala"
	book_view_signals[BOOK_VIEW_PAGE_SELECTED_SIGNAL] = g_signal_new ("page-selected", TYPE_BOOK_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_PAGE);
#line 15 "../src/book-view.vala"
	book_view_signals[BOOK_VIEW_SHOW_PAGE_SIGNAL] = g_signal_new ("show-page", TYPE_BOOK_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_PAGE);
#line 15 "../src/book-view.vala"
	book_view_signals[BOOK_VIEW_SHOW_MENU_SIGNAL] = g_signal_new ("show-menu", TYPE_BOOK_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOXED, G_TYPE_NONE, 1, gdk_event_get_type ());
#line 3301 "book-view.c"
}

static void
book_view_instance_init (BookView * self,
                         gpointer klass)
{
#line 15 "../src/book-view.vala"
	self->priv = book_view_get_instance_private (self);
#line 27 "../src/book-view.vala"
	self->priv->selected_page_view = NULL;
#line 3312 "book-view.c"
}

static void
book_view_finalize (GObject * obj)
{
	BookView * self;
	Book* _tmp0_;
	guint _tmp1_;
	Book* _tmp2_;
	guint _tmp3_;
	Book* _tmp4_;
	guint _tmp5_;
	Book* _tmp6_;
	guint _tmp7_;
	GtkWidget* _tmp8_;
	guint _tmp9_;
	GtkWidget* _tmp10_;
	guint _tmp11_;
	GtkWidget* _tmp12_;
	guint _tmp13_;
	GtkWidget* _tmp14_;
	guint _tmp15_;
	GtkWidget* _tmp16_;
	guint _tmp17_;
	GtkWidget* _tmp18_;
	guint _tmp19_;
	GtkWidget* _tmp20_;
	guint _tmp21_;
	GtkWidget* _tmp22_;
	guint _tmp23_;
	GtkAdjustment* _tmp24_;
	guint _tmp25_;
#line 15 "../src/book-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOOK_VIEW, BookView);
#line 124 "../src/book-view.vala"
	_tmp0_ = self->priv->_book;
#line 124 "../src/book-view.vala"
	g_signal_parse_name ("page-added", TYPE_BOOK, &_tmp1_, NULL, FALSE);
#line 124 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _book_view_add_cb_book_page_added, self);
#line 125 "../src/book-view.vala"
	_tmp2_ = self->priv->_book;
#line 125 "../src/book-view.vala"
	g_signal_parse_name ("page-removed", TYPE_BOOK, &_tmp3_, NULL, FALSE);
#line 125 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _book_view_remove_cb_book_page_removed, self);
#line 126 "../src/book-view.vala"
	_tmp4_ = self->priv->_book;
#line 126 "../src/book-view.vala"
	g_signal_parse_name ("reordered", TYPE_BOOK, &_tmp5_, NULL, FALSE);
#line 126 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _book_view_reorder_cb_book_reordered, self);
#line 127 "../src/book-view.vala"
	_tmp6_ = self->priv->_book;
#line 127 "../src/book-view.vala"
	g_signal_parse_name ("cleared", TYPE_BOOK, &_tmp7_, NULL, FALSE);
#line 127 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _book_view_clear_cb_book_cleared, self);
#line 128 "../src/book-view.vala"
	_tmp8_ = self->priv->drawing_area;
#line 128 "../src/book-view.vala"
	g_signal_parse_name ("configure-event", gtk_widget_get_type (), &_tmp9_, NULL, FALSE);
#line 128 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _book_view_configure_cb_gtk_widget_configure_event, self);
#line 129 "../src/book-view.vala"
	_tmp10_ = self->priv->drawing_area;
#line 129 "../src/book-view.vala"
	g_signal_parse_name ("draw", gtk_widget_get_type (), &_tmp11_, NULL, FALSE);
#line 129 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _book_view_draw_cb_gtk_widget_draw, self);
#line 130 "../src/book-view.vala"
	_tmp12_ = self->priv->drawing_area;
#line 130 "../src/book-view.vala"
	g_signal_parse_name ("motion-notify-event", gtk_widget_get_type (), &_tmp13_, NULL, FALSE);
#line 130 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _book_view_motion_cb_gtk_widget_motion_notify_event, self);
#line 131 "../src/book-view.vala"
	_tmp14_ = self->priv->drawing_area;
#line 131 "../src/book-view.vala"
	g_signal_parse_name ("key-press-event", gtk_widget_get_type (), &_tmp15_, NULL, FALSE);
#line 131 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp14_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp15_, 0, NULL, (GCallback) _book_view_key_cb_gtk_widget_key_press_event, self);
#line 132 "../src/book-view.vala"
	_tmp16_ = self->priv->drawing_area;
#line 132 "../src/book-view.vala"
	g_signal_parse_name ("button-press-event", gtk_widget_get_type (), &_tmp17_, NULL, FALSE);
#line 132 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp16_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _book_view_button_cb_gtk_widget_button_press_event, self);
#line 133 "../src/book-view.vala"
	_tmp18_ = self->priv->drawing_area;
#line 133 "../src/book-view.vala"
	g_signal_parse_name ("button-release-event", gtk_widget_get_type (), &_tmp19_, NULL, FALSE);
#line 133 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp18_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp19_, 0, NULL, (GCallback) _book_view_button_cb_gtk_widget_button_release_event, self);
#line 134 "../src/book-view.vala"
	_tmp20_ = self->priv->drawing_area;
#line 134 "../src/book-view.vala"
	g_signal_parse_name ("focus-in-event", gtk_widget_get_type (), &_tmp21_, NULL, FALSE);
#line 134 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp20_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp21_, 0, NULL, (GCallback) _book_view_focus_cb_gtk_widget_focus_in_event, self);
#line 135 "../src/book-view.vala"
	_tmp22_ = self->priv->drawing_area;
#line 135 "../src/book-view.vala"
	g_signal_parse_name ("focus-out-event", gtk_widget_get_type (), &_tmp23_, NULL, FALSE);
#line 135 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp22_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp23_, 0, NULL, (GCallback) _book_view_focus_cb_gtk_widget_focus_out_event, self);
#line 136 "../src/book-view.vala"
	_tmp24_ = self->priv->adjustment;
#line 136 "../src/book-view.vala"
	g_signal_parse_name ("value-changed", gtk_adjustment_get_type (), &_tmp25_, NULL, FALSE);
#line 136 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp24_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp25_, 0, NULL, (GCallback) _book_view_scroll_cb_gtk_adjustment_value_changed, self);
#line 18 "../src/book-view.vala"
	_g_object_unref0 (self->priv->_book);
#line 19 "../src/book-view.vala"
	_g_hash_table_unref0 (self->priv->page_data);
#line 27 "../src/book-view.vala"
	_g_object_unref0 (self->priv->selected_page_view);
#line 50 "../src/book-view.vala"
	_g_object_unref0 (self->priv->drawing_area);
#line 53 "../src/book-view.vala"
	_g_object_unref0 (self->priv->scroll);
#line 54 "../src/book-view.vala"
	_g_object_unref0 (self->priv->adjustment);
#line 15 "../src/book-view.vala"
	G_OBJECT_CLASS (book_view_parent_class)->finalize (obj);
#line 3439 "book-view.c"
}

static GType
book_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BookViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) book_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BookView), 0, (GInstanceInitFunc) book_view_instance_init, NULL };
	GType book_view_type_id;
	book_view_type_id = g_type_register_static (gtk_box_get_type (), "BookView", &g_define_type_info, 0);
	BookView_private_offset = g_type_add_instance_private (book_view_type_id, sizeof (BookViewPrivate));
	return book_view_type_id;
}

GType
book_view_get_type (void)
{
	static volatile gsize book_view_type_id__once = 0;
	if (g_once_init_enter (&book_view_type_id__once)) {
		GType book_view_type_id;
		book_view_type_id = book_view_get_type_once ();
		g_once_init_leave (&book_view_type_id__once, book_view_type_id);
	}
	return book_view_type_id__once;
}

static void
_vala_book_view_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	BookView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BOOK_VIEW, BookView);
#line 15 "../src/book-view.vala"
	switch (property_id) {
#line 15 "../src/book-view.vala"
		case BOOK_VIEW_BOOK_PROPERTY:
#line 15 "../src/book-view.vala"
		g_value_set_object (value, book_view_get_book (self));
#line 15 "../src/book-view.vala"
		break;
#line 15 "../src/book-view.vala"
		case BOOK_VIEW_SELECTED_PAGE_PROPERTY:
#line 15 "../src/book-view.vala"
		g_value_set_object (value, book_view_get_selected_page (self));
#line 15 "../src/book-view.vala"
		break;
#line 15 "../src/book-view.vala"
		case BOOK_VIEW_X_OFFSET_PROPERTY:
#line 15 "../src/book-view.vala"
		g_value_set_int (value, book_view_get_x_offset (self));
#line 15 "../src/book-view.vala"
		break;
#line 3492 "book-view.c"
		default:
#line 15 "../src/book-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 15 "../src/book-view.vala"
		break;
#line 3498 "book-view.c"
	}
}

static void
_vala_book_view_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	BookView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BOOK_VIEW, BookView);
#line 15 "../src/book-view.vala"
	switch (property_id) {
#line 15 "../src/book-view.vala"
		case BOOK_VIEW_BOOK_PROPERTY:
#line 15 "../src/book-view.vala"
		book_view_set_book (self, g_value_get_object (value));
#line 15 "../src/book-view.vala"
		break;
#line 15 "../src/book-view.vala"
		case BOOK_VIEW_SELECTED_PAGE_PROPERTY:
#line 15 "../src/book-view.vala"
		book_view_set_selected_page (self, g_value_get_object (value));
#line 15 "../src/book-view.vala"
		break;
#line 15 "../src/book-view.vala"
		case BOOK_VIEW_X_OFFSET_PROPERTY:
#line 15 "../src/book-view.vala"
		book_view_set_x_offset (self, g_value_get_int (value));
#line 15 "../src/book-view.vala"
		break;
#line 3530 "book-view.c"
		default:
#line 15 "../src/book-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 15 "../src/book-view.vala"
		break;
#line 3536 "book-view.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

