/* page-icon.c generated by valac 0.56.14, the Vala compiler
 * generated from page-icon.vala, do not modify */

/*
 * Copyright (C) 2009-2017 Canonical Ltd.
 * Author: Robert Ancell <robert.ancell@canonical.com>,
 *         Eduard Gotwig <g@ox.io>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <cairo-gobject.h>
#include <math.h>
#include <float.h>
#include <handy.h>
#include <gdk/gdk.h>
#include <string.h>

#define PAGE_ICON_MINIMUM_WIDTH 20
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PAGE_ICON (page_icon_get_type ())
#define PAGE_ICON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_ICON, PageIcon))
#define PAGE_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_ICON, PageIconClass))
#define IS_PAGE_ICON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_ICON))
#define IS_PAGE_ICON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_ICON))
#define PAGE_ICON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_ICON, PageIconClass))

typedef struct _PageIcon PageIcon;
typedef struct _PageIconClass PageIconClass;
typedef struct _PageIconPrivate PageIconPrivate;
enum  {
	PAGE_ICON_0_PROPERTY,
	PAGE_ICON_NUM_PROPERTIES
};
static GParamSpec* page_icon_properties[PAGE_ICON_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _PageIcon {
	GtkDrawingArea parent_instance;
	PageIconPrivate * priv;
};

struct _PageIconClass {
	GtkDrawingAreaClass parent_class;
};

struct _PageIconPrivate {
	gchar side;
	gint position;
	gint angle;
};

static gint PageIcon_private_offset;
static gpointer page_icon_parent_class = NULL;

VALA_EXTERN GType page_icon_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PageIcon, g_object_unref)
VALA_EXTERN PageIcon* page_icon_new (gchar side,
                         gint position,
                         gint angle);
VALA_EXTERN PageIcon* page_icon_construct (GType object_type,
                               gchar side,
                               gint position,
                               gint angle);
static void page_icon_real_get_preferred_width (GtkWidget* base,
                                         gint* minimum_width,
                                         gint* natural_width);
static void page_icon_real_get_preferred_height (GtkWidget* base,
                                          gint* minimum_height,
                                          gint* natural_height);
static void page_icon_real_get_preferred_height_for_width (GtkWidget* base,
                                                    gint width,
                                                    gint* minimum_height,
                                                    gint* natural_height);
static void page_icon_real_get_preferred_width_for_height (GtkWidget* base,
                                                    gint height,
                                                    gint* minimum_width,
                                                    gint* natural_width);
static gboolean page_icon_real_draw (GtkWidget* base,
                              cairo_t* c);
static void page_icon_finalize (GObject * obj);
static GType page_icon_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
page_icon_get_instance_private (PageIcon* self)
{
	return G_STRUCT_MEMBER_P (self, PageIcon_private_offset);
}

PageIcon*
page_icon_construct (GType object_type,
                     gchar side,
                     gint position,
                     gint angle)
{
	PageIcon * self = NULL;
#line 20 "../src/page-icon.vala"
	self = (PageIcon*) g_object_new (object_type, NULL);
#line 22 "../src/page-icon.vala"
	self->priv->side = side;
#line 23 "../src/page-icon.vala"
	self->priv->position = position;
#line 24 "../src/page-icon.vala"
	self->priv->angle = angle;
#line 20 "../src/page-icon.vala"
	return self;
#line 132 "page-icon.c"
}

PageIcon*
page_icon_new (gchar side,
               gint position,
               gint angle)
{
#line 20 "../src/page-icon.vala"
	return page_icon_construct (TYPE_PAGE_ICON, side, position, angle);
#line 142 "page-icon.c"
}

static void
page_icon_real_get_preferred_width (GtkWidget* base,
                                    gint* minimum_width,
                                    gint* natural_width)
{
	PageIcon * self;
	gint _vala_minimum_width = 0;
	gint _vala_natural_width = 0;
#line 27 "../src/page-icon.vala"
	self = (PageIcon*) base;
#line 29 "../src/page-icon.vala"
	_vala_natural_width = PAGE_ICON_MINIMUM_WIDTH;
#line 29 "../src/page-icon.vala"
	_vala_minimum_width = _vala_natural_width;
#line 27 "../src/page-icon.vala"
	if (minimum_width) {
#line 27 "../src/page-icon.vala"
		*minimum_width = _vala_minimum_width;
#line 163 "page-icon.c"
	}
#line 27 "../src/page-icon.vala"
	if (natural_width) {
#line 27 "../src/page-icon.vala"
		*natural_width = _vala_natural_width;
#line 169 "page-icon.c"
	}
}

static void
page_icon_real_get_preferred_height (GtkWidget* base,
                                     gint* minimum_height,
                                     gint* natural_height)
{
	PageIcon * self;
	gint _vala_minimum_height = 0;
	gint _vala_natural_height = 0;
#line 32 "../src/page-icon.vala"
	self = (PageIcon*) base;
#line 34 "../src/page-icon.vala"
	_vala_natural_height = (gint) round (PAGE_ICON_MINIMUM_WIDTH * G_SQRT2);
#line 34 "../src/page-icon.vala"
	_vala_minimum_height = _vala_natural_height;
#line 32 "../src/page-icon.vala"
	if (minimum_height) {
#line 32 "../src/page-icon.vala"
		*minimum_height = _vala_minimum_height;
#line 191 "page-icon.c"
	}
#line 32 "../src/page-icon.vala"
	if (natural_height) {
#line 32 "../src/page-icon.vala"
		*natural_height = _vala_natural_height;
#line 197 "page-icon.c"
	}
}

static void
page_icon_real_get_preferred_height_for_width (GtkWidget* base,
                                               gint width,
                                               gint* minimum_height,
                                               gint* natural_height)
{
	PageIcon * self;
	gint _vala_minimum_height = 0;
	gint _vala_natural_height = 0;
#line 37 "../src/page-icon.vala"
	self = (PageIcon*) base;
#line 39 "../src/page-icon.vala"
	_vala_natural_height = (gint) (width * G_SQRT2);
#line 39 "../src/page-icon.vala"
	_vala_minimum_height = _vala_natural_height;
#line 37 "../src/page-icon.vala"
	if (minimum_height) {
#line 37 "../src/page-icon.vala"
		*minimum_height = _vala_minimum_height;
#line 220 "page-icon.c"
	}
#line 37 "../src/page-icon.vala"
	if (natural_height) {
#line 37 "../src/page-icon.vala"
		*natural_height = _vala_natural_height;
#line 226 "page-icon.c"
	}
}

static void
page_icon_real_get_preferred_width_for_height (GtkWidget* base,
                                               gint height,
                                               gint* minimum_width,
                                               gint* natural_width)
{
	PageIcon * self;
	gint _vala_minimum_width = 0;
	gint _vala_natural_width = 0;
#line 42 "../src/page-icon.vala"
	self = (PageIcon*) base;
#line 44 "../src/page-icon.vala"
	_vala_natural_width = (gint) (height / G_SQRT2);
#line 44 "../src/page-icon.vala"
	_vala_minimum_width = _vala_natural_width;
#line 42 "../src/page-icon.vala"
	if (minimum_width) {
#line 42 "../src/page-icon.vala"
		*minimum_width = _vala_minimum_width;
#line 249 "page-icon.c"
	}
#line 42 "../src/page-icon.vala"
	if (natural_width) {
#line 42 "../src/page-icon.vala"
		*natural_width = _vala_natural_width;
#line 255 "page-icon.c"
	}
}

static gboolean
page_icon_real_draw (GtkWidget* base,
                     cairo_t* c)
{
	PageIcon * self;
	gint w = 0;
	gint h = 0;
	gboolean dark = FALSE;
	HdyStyleManager* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean hc = FALSE;
	HdyStyleManager* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_ = FALSE;
	GdkRGBA rgba = {0};
	GdkRGBA _tmp7_ = {0};
	GdkRGBA _tmp19_;
	gboolean _tmp20_ = FALSE;
	gchar* text = NULL;
	gchar* _tmp21_;
	cairo_text_extents_t extents = {0};
	gdouble rad = 0.0;
	cairo_text_extents_t _tmp22_ = {0};
	cairo_text_extents_t _tmp23_;
	cairo_text_extents_t _tmp24_;
	cairo_text_extents_t _tmp25_;
	gdouble tx = 0.0;
	cairo_text_extents_t _tmp26_;
	gdouble ty = 0.0;
	cairo_text_extents_t _tmp27_;
	gboolean result;
#line 47 "../src/page-icon.vala"
	self = (PageIcon*) base;
#line 47 "../src/page-icon.vala"
	g_return_val_if_fail (c != NULL, FALSE);
#line 49 "../src/page-icon.vala"
	w = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 50 "../src/page-icon.vala"
	h = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 51 "../src/page-icon.vala"
	if ((w * G_SQRT2) > ((gdouble) h)) {
#line 52 "../src/page-icon.vala"
		w = (gint) round (h / G_SQRT2);
#line 304 "page-icon.c"
	} else {
#line 54 "../src/page-icon.vala"
		h = (gint) round (w * G_SQRT2);
#line 308 "page-icon.c"
	}
#line 56 "../src/page-icon.vala"
	cairo_translate (c, (gdouble) ((gtk_widget_get_allocated_width ((GtkWidget*) self) - w) / 2), (gdouble) ((gtk_widget_get_allocated_height ((GtkWidget*) self) - h) / 2));
#line 58 "../src/page-icon.vala"
	_tmp0_ = hdy_style_manager_get_default ();
#line 58 "../src/page-icon.vala"
	_tmp1_ = hdy_style_manager_get_dark (_tmp0_);
#line 58 "../src/page-icon.vala"
	_tmp2_ = _tmp1_;
#line 58 "../src/page-icon.vala"
	dark = _tmp2_;
#line 59 "../src/page-icon.vala"
	_tmp3_ = hdy_style_manager_get_default ();
#line 59 "../src/page-icon.vala"
	_tmp4_ = hdy_style_manager_get_high_contrast (_tmp3_);
#line 59 "../src/page-icon.vala"
	_tmp5_ = _tmp4_;
#line 59 "../src/page-icon.vala"
	hc = _tmp5_;
#line 61 "../src/page-icon.vala"
	if (dark) {
#line 61 "../src/page-icon.vala"
		_tmp6_ = !hc;
#line 332 "page-icon.c"
	} else {
#line 61 "../src/page-icon.vala"
		_tmp6_ = FALSE;
#line 336 "page-icon.c"
	}
#line 61 "../src/page-icon.vala"
	if (_tmp6_) {
#line 62 "../src/page-icon.vala"
		cairo_rectangle (c, (gdouble) 1, (gdouble) 1, (gdouble) (w - 2), (gdouble) (h - 2));
#line 342 "page-icon.c"
	} else {
#line 64 "../src/page-icon.vala"
		cairo_rectangle (c, (gdouble) 0, (gdouble) 0, (gdouble) w, (gdouble) h);
#line 346 "page-icon.c"
	}
#line 66 "../src/page-icon.vala"
	rgba = _tmp7_;
#line 68 "../src/page-icon.vala"
	switch (self->priv->side) {
#line 68 "../src/page-icon.vala"
		case 'F':
#line 354 "page-icon.c"
		{
#line 72 "../src/page-icon.vala"
			gdk_rgba_parse (&rgba, "#c061cb");
#line 73 "../src/page-icon.vala"
			break;
#line 360 "page-icon.c"
		}
#line 68 "../src/page-icon.vala"
		case 'B':
#line 364 "page-icon.c"
		{
#line 76 "../src/page-icon.vala"
			gdk_rgba_parse (&rgba, "#ff7800");
#line 77 "../src/page-icon.vala"
			break;
#line 370 "page-icon.c"
		}
#line 68 "../src/page-icon.vala"
		case 'U':
#line 374 "page-icon.c"
		{
#line 80 "../src/page-icon.vala"
			gdk_rgba_parse (&rgba, "#5cc02e");
#line 81 "../src/page-icon.vala"
			break;
#line 380 "page-icon.c"
		}
#line 68 "../src/page-icon.vala"
		case 'R':
#line 384 "page-icon.c"
		{
#line 84 "../src/page-icon.vala"
			gdk_rgba_parse (&rgba, "#0deee7");
#line 85 "../src/page-icon.vala"
			break;
#line 390 "page-icon.c"
		}
		default:
		{
			GdkRGBA start = {0};
			GdkRGBA _tmp8_ = {0};
			GdkRGBA end = {0};
			GdkRGBA _tmp9_ = {0};
			gdouble progress = 0.0;
			GdkRGBA _tmp10_;
			GdkRGBA _tmp11_;
			GdkRGBA _tmp12_;
			GdkRGBA _tmp13_;
			GdkRGBA _tmp14_;
			GdkRGBA _tmp15_;
			GdkRGBA _tmp16_;
			GdkRGBA _tmp17_;
			GdkRGBA _tmp18_;
#line 88 "../src/page-icon.vala"
			start = _tmp8_;
#line 88 "../src/page-icon.vala"
			end = _tmp9_;
#line 89 "../src/page-icon.vala"
			gdk_rgba_parse (&start, "#f6d32d");
#line 90 "../src/page-icon.vala"
			gdk_rgba_parse (&end, "#ed333b");
#line 92 "../src/page-icon.vala"
			progress = self->priv->position / 5.0;
#line 93 "../src/page-icon.vala"
			_tmp10_ = start;
#line 93 "../src/page-icon.vala"
			_tmp11_ = end;
#line 93 "../src/page-icon.vala"
			_tmp12_ = start;
#line 93 "../src/page-icon.vala"
			rgba.red = _tmp10_.red + ((_tmp11_.red - _tmp12_.red) * progress);
#line 94 "../src/page-icon.vala"
			_tmp13_ = start;
#line 94 "../src/page-icon.vala"
			_tmp14_ = end;
#line 94 "../src/page-icon.vala"
			_tmp15_ = start;
#line 94 "../src/page-icon.vala"
			rgba.green = _tmp13_.green + ((_tmp14_.green - _tmp15_.green) * progress);
#line 95 "../src/page-icon.vala"
			_tmp16_ = start;
#line 95 "../src/page-icon.vala"
			_tmp17_ = end;
#line 95 "../src/page-icon.vala"
			_tmp18_ = start;
#line 95 "../src/page-icon.vala"
			rgba.blue = _tmp16_.blue + ((_tmp17_.blue - _tmp18_.blue) * progress);
#line 96 "../src/page-icon.vala"
			break;
#line 444 "page-icon.c"
		}
	}
#line 99 "../src/page-icon.vala"
	rgba.alpha = 0.3;
#line 101 "../src/page-icon.vala"
	_tmp19_ = rgba;
#line 101 "../src/page-icon.vala"
	gdk_cairo_set_source_rgba (c, &_tmp19_);
#line 102 "../src/page-icon.vala"
	cairo_fill (c);
#line 104 "../src/page-icon.vala"
	cairo_set_line_width (c, 1.0);
#line 105 "../src/page-icon.vala"
	if (hc) {
#line 105 "../src/page-icon.vala"
		_tmp20_ = dark;
#line 461 "page-icon.c"
	} else {
#line 105 "../src/page-icon.vala"
		_tmp20_ = FALSE;
#line 465 "page-icon.c"
	}
#line 105 "../src/page-icon.vala"
	if (_tmp20_) {
#line 106 "../src/page-icon.vala"
		cairo_set_source_rgba (c, (gdouble) 1, (gdouble) 1, (gdouble) 1, 0.5);
#line 471 "page-icon.c"
	} else {
#line 107 "../src/page-icon.vala"
		if (hc) {
#line 108 "../src/page-icon.vala"
			cairo_set_source_rgba (c, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.5);
#line 477 "page-icon.c"
		} else {
#line 110 "../src/page-icon.vala"
			cairo_set_source_rgba (c, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.15);
#line 481 "page-icon.c"
		}
	}
#line 112 "../src/page-icon.vala"
	cairo_rectangle (c, 0.5, 0.5, (gdouble) (w - 1), (gdouble) (h - 1));
#line 113 "../src/page-icon.vala"
	cairo_stroke (c);
#line 115 "../src/page-icon.vala"
	if (dark) {
#line 116 "../src/page-icon.vala"
		cairo_set_source_rgb (c, (gdouble) 1, (gdouble) 1, (gdouble) 1);
#line 492 "page-icon.c"
	} else {
#line 118 "../src/page-icon.vala"
		cairo_set_source_rgb (c, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 496 "page-icon.c"
	}
#line 120 "../src/page-icon.vala"
	_tmp21_ = g_strdup_printf ("%i", self->priv->position + 1);
#line 120 "../src/page-icon.vala"
	text = _tmp21_;
#line 123 "../src/page-icon.vala"
	rad = (G_PI / 180.0) * self->priv->angle;
#line 124 "../src/page-icon.vala"
	cairo_text_extents (c, text, &_tmp22_);
#line 124 "../src/page-icon.vala"
	extents = _tmp22_;
#line 125 "../src/page-icon.vala"
	_tmp23_ = extents;
#line 125 "../src/page-icon.vala"
	_tmp24_ = extents;
#line 125 "../src/page-icon.vala"
	_tmp25_ = extents;
#line 125 "../src/page-icon.vala"
	cairo_translate (c, ((w - _tmp23_.width) * 0.5) - 0.5, (_tmp24_.height + ((h - _tmp25_.height) * 0.5)) - 0.5);
#line 126 "../src/page-icon.vala"
	cairo_rotate (c, rad);
#line 128 "../src/page-icon.vala"
	_tmp26_ = extents;
#line 128 "../src/page-icon.vala"
	tx = ((1.0 - sin (rad)) * _tmp26_.width) / 2;
#line 129 "../src/page-icon.vala"
	_tmp27_ = extents;
#line 129 "../src/page-icon.vala"
	ty = ((1.0 - sin (rad)) * _tmp27_.height) / 2;
#line 130 "../src/page-icon.vala"
	cairo_translate (c, -tx, +ty);
#line 131 "../src/page-icon.vala"
	cairo_show_text (c, text);
#line 133 "../src/page-icon.vala"
	result = TRUE;
#line 133 "../src/page-icon.vala"
	_g_free0 (text);
#line 133 "../src/page-icon.vala"
	return result;
#line 536 "page-icon.c"
}

static void
page_icon_class_init (PageIconClass * klass,
                      gpointer klass_data)
{
#line 13 "../src/page-icon.vala"
	page_icon_parent_class = g_type_class_peek_parent (klass);
#line 13 "../src/page-icon.vala"
	g_type_class_adjust_private_offset (klass, &PageIcon_private_offset);
#line 13 "../src/page-icon.vala"
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) page_icon_real_get_preferred_width;
#line 13 "../src/page-icon.vala"
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget*, gint*, gint*)) page_icon_real_get_preferred_height;
#line 13 "../src/page-icon.vala"
	((GtkWidgetClass *) klass)->get_preferred_height_for_width = (void (*) (GtkWidget*, gint, gint*, gint*)) page_icon_real_get_preferred_height_for_width;
#line 13 "../src/page-icon.vala"
	((GtkWidgetClass *) klass)->get_preferred_width_for_height = (void (*) (GtkWidget*, gint, gint*, gint*)) page_icon_real_get_preferred_width_for_height;
#line 13 "../src/page-icon.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) page_icon_real_draw;
#line 13 "../src/page-icon.vala"
	G_OBJECT_CLASS (klass)->finalize = page_icon_finalize;
#line 559 "page-icon.c"
}

static void
page_icon_instance_init (PageIcon * self,
                         gpointer klass)
{
#line 13 "../src/page-icon.vala"
	self->priv = page_icon_get_instance_private (self);
#line 568 "page-icon.c"
}

static void
page_icon_finalize (GObject * obj)
{
	PageIcon * self;
#line 13 "../src/page-icon.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAGE_ICON, PageIcon);
#line 13 "../src/page-icon.vala"
	G_OBJECT_CLASS (page_icon_parent_class)->finalize (obj);
#line 579 "page-icon.c"
}

static GType
page_icon_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PageIconClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) page_icon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PageIcon), 0, (GInstanceInitFunc) page_icon_instance_init, NULL };
	GType page_icon_type_id;
	page_icon_type_id = g_type_register_static (gtk_drawing_area_get_type (), "PageIcon", &g_define_type_info, 0);
	PageIcon_private_offset = g_type_add_instance_private (page_icon_type_id, sizeof (PageIconPrivate));
	return page_icon_type_id;
}

GType
page_icon_get_type (void)
{
	static volatile gsize page_icon_type_id__once = 0;
	if (g_once_init_enter (&page_icon_type_id__once)) {
		GType page_icon_type_id;
		page_icon_type_id = page_icon_get_type_once ();
		g_once_init_leave (&page_icon_type_id__once, page_icon_type_id);
	}
	return page_icon_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

