/* page-view.c generated by valac 0.56.14, the Vala compiler
 * generated from page-view.vala, do not modify */

/*
 * Copyright (C) 2009-2015 Canonical Ltd.
 * Author: Robert Ancell <robert.ancell@canonical.com>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib-object.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <string.h>
#include <stdlib.h>
#include <cairo-gobject.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	CROP_LOCATION_NONE = 0,
	CROP_LOCATION_MIDDLE,
	CROP_LOCATION_TOP,
	CROP_LOCATION_BOTTOM,
	CROP_LOCATION_LEFT,
	CROP_LOCATION_RIGHT,
	CROP_LOCATION_TOP_LEFT,
	CROP_LOCATION_TOP_RIGHT,
	CROP_LOCATION_BOTTOM_LEFT,
	CROP_LOCATION_BOTTOM_RIGHT
} CropLocation;

#define TYPE_CROP_LOCATION (crop_location_get_type ())

#define TYPE_PAGE_VIEW (page_view_get_type ())
#define PAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_VIEW, PageView))
#define PAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_VIEW, PageViewClass))
#define IS_PAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_VIEW))
#define IS_PAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_VIEW))
#define PAGE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_VIEW, PageViewClass))

typedef struct _PageView PageView;
typedef struct _PageViewClass PageViewClass;
typedef struct _PageViewPrivate PageViewPrivate;

#define TYPE_PAGE (page_get_type ())
#define PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE, Page))
#define PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE, PageClass))
#define IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE))
#define IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE))
#define PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE, PageClass))

typedef struct _Page Page;
typedef struct _PageClass PageClass;
typedef enum  {
	SCAN_DIRECTION_TOP_TO_BOTTOM,
	SCAN_DIRECTION_LEFT_TO_RIGHT,
	SCAN_DIRECTION_BOTTOM_TO_TOP,
	SCAN_DIRECTION_RIGHT_TO_LEFT
} ScanDirection;

#define TYPE_SCAN_DIRECTION (scan_direction_get_type ())
enum  {
	PAGE_VIEW_0_PROPERTY,
	PAGE_VIEW_PAGE_PROPERTY,
	PAGE_VIEW_SELECTED_PROPERTY,
	PAGE_VIEW_X_OFFSET_PROPERTY,
	PAGE_VIEW_Y_OFFSET_PROPERTY,
	PAGE_VIEW_CURSOR_PROPERTY,
	PAGE_VIEW_WIDTH_PROPERTY,
	PAGE_VIEW_HEIGHT_PROPERTY,
	PAGE_VIEW_NUM_PROPERTIES
};
static GParamSpec* page_view_properties[PAGE_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	PAGE_VIEW_SIZE_CHANGED_SIGNAL,
	PAGE_VIEW_CHANGED_SIGNAL,
	PAGE_VIEW_NUM_SIGNALS
};
static guint page_view_signals[PAGE_VIEW_NUM_SIGNALS] = {0};

struct _PageView {
	GObject parent_instance;
	PageViewPrivate * priv;
};

struct _PageViewClass {
	GObjectClass parent_class;
};

struct _PageViewPrivate {
	Page* _page;
	GdkPixbuf* image;
	gboolean selected_;
	gint ruler_width;
	gint border_width;
	gboolean update_image;
	ScanDirection scan_direction;
	gint scan_line;
	gint width_;
	gint height_;
	gint _x_offset;
	gint _y_offset;
	CropLocation crop_location;
	gdouble selected_crop_px;
	gdouble selected_crop_py;
	gint selected_crop_x;
	gint selected_crop_y;
	gint selected_crop_w;
	gint selected_crop_h;
	GdkCursorType _cursor;
	gint animate_n_segments;
	gint animate_segment;
	guint animate_timeout;
};

static gint PageView_private_offset;
static gpointer page_view_parent_class = NULL;

VALA_EXTERN GType crop_location_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType page_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PageView, g_object_unref)
VALA_EXTERN GType page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Page, g_object_unref)
VALA_EXTERN GType scan_direction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Page* page_view_get_page (PageView* self);
static void page_view_page_pixels_changed_cb (PageView* self,
                                       Page* p);
static void _page_view_page_pixels_changed_cb_page_pixels_changed (Page* _sender,
                                                            gpointer self);
static void page_view_page_size_changed_cb (PageView* self,
                                     Page* p);
static void _page_view_page_size_changed_cb_page_size_changed (Page* _sender,
                                                        gpointer self);
static void page_view_page_overlay_changed_cb (PageView* self,
                                        Page* p);
static void _page_view_page_overlay_changed_cb_page_crop_changed (Page* _sender,
                                                           gpointer self);
static void _page_view_page_overlay_changed_cb_page_scan_line_changed (Page* _sender,
                                                                gpointer self);
static void page_view_scan_direction_changed_cb (PageView* self,
                                          Page* p);
static void _page_view_scan_direction_changed_cb_page_scan_direction_changed (Page* _sender,
                                                                       gpointer self);
VALA_EXTERN PageView* page_view_new (Page* page);
VALA_EXTERN PageView* page_view_construct (GType object_type,
                               Page* page);
static void page_view_set_page (PageView* self,
                         Page* value);
static guchar page_view_get_sample (PageView* self,
                             guchar* pixels,
                             gint pixels_length1,
                             gint offset,
                             gint x,
                             gint depth,
                             gint sample);
static void page_view_get_pixel (PageView* self,
                          Page* page,
                          gint x,
                          gint y,
                          guchar* pixel,
                          gint pixel_length1);
VALA_EXTERN ScanDirection page_get_scan_direction (Page* self);
VALA_EXTERN gint page_get_scan_width (Page* self);
VALA_EXTERN gint page_get_scan_height (Page* self);
VALA_EXTERN gint page_get_depth (Page* self);
VALA_EXTERN gint page_get_n_channels (Page* self);
VALA_EXTERN guchar* page_get_pixels (Page* self,
                         gint* result_length1);
VALA_EXTERN gint page_get_rowstride (Page* self);
static void page_view_set_pixel (PageView* self,
                          Page* page,
                          gdouble l,
                          gdouble r,
                          gdouble t,
                          gdouble b,
                          guchar* output,
                          gint output_length1,
                          gint offset);
static void page_view_update_preview (PageView* self,
                               Page* page,
                               GdkPixbuf** output_image,
                               gint output_width,
                               gint output_height,
                               ScanDirection scan_direction,
                               gint old_scan_line,
                               gint scan_line);
VALA_EXTERN gint page_get_width (Page* self);
VALA_EXTERN gint page_get_height (Page* self);
VALA_EXTERN gboolean page_get_has_data (Page* self);
static gint page_view_get_preview_width (PageView* self);
static gint page_view_get_preview_height (PageView* self);
static void page_view_update_page_view (PageView* self);
VALA_EXTERN gint page_get_scan_line (Page* self);
static gint page_view_page_to_screen_x (PageView* self,
                                 gint x);
static gint page_view_page_to_screen_y (PageView* self,
                                 gint y);
static gint page_view_screen_to_page_x (PageView* self,
                                 gint x);
static gint page_view_screen_to_page_y (PageView* self,
                                 gint y);
static CropLocation page_view_get_crop_location (PageView* self,
                                          gint x,
                                          gint y);
VALA_EXTERN gboolean page_get_has_crop (Page* self);
VALA_EXTERN gint page_get_crop_x (Page* self);
VALA_EXTERN gint page_get_crop_y (Page* self);
VALA_EXTERN gint page_get_crop_width (Page* self);
VALA_EXTERN gint page_get_crop_height (Page* self);
VALA_EXTERN const gchar* page_get_crop_name (Page* self);
VALA_EXTERN void page_view_button_press (PageView* self,
                             gint x,
                             gint y);
VALA_EXTERN void page_view_motion (PageView* self,
                       gint x,
                       gint y);
static void page_view_set_cursor (PageView* self,
                           GdkCursorType value);
VALA_EXTERN void page_move_crop (Page* self,
                     gint x,
                     gint y);
VALA_EXTERN void page_set_custom_crop (Page* self,
                           gint width,
                           gint height);
VALA_EXTERN void page_view_button_release (PageView* self,
                               gint x,
                               gint y);
static gboolean page_view_animation_cb (PageView* self);
static void page_view_update_animation (PageView* self);
VALA_EXTERN gboolean page_get_is_scanning (Page* self);
static gboolean _page_view_animation_cb_gsource_func (gpointer self);
VALA_EXTERN void page_view_render (PageView* self,
                       cairo_t* context,
                       GdkRGBA* ruler_color);
VALA_EXTERN gint page_view_get_x_offset (PageView* self);
VALA_EXTERN gint page_view_get_y_offset (PageView* self);
VALA_EXTERN gint page_get_dpi (Page* self);
VALA_EXTERN gboolean page_view_get_selected (PageView* self);
VALA_EXTERN void page_view_set_selected (PageView* self,
                             gboolean value);
VALA_EXTERN void page_view_set_x_offset (PageView* self,
                             gint value);
VALA_EXTERN void page_view_set_y_offset (PageView* self,
                             gint value);
VALA_EXTERN GdkCursorType page_view_get_cursor (PageView* self);
VALA_EXTERN gint page_view_get_width (PageView* self);
VALA_EXTERN void page_view_set_width (PageView* self,
                          gint value);
VALA_EXTERN gint page_view_get_height (PageView* self);
VALA_EXTERN void page_view_set_height (PageView* self,
                           gint value);
static void page_view_finalize (GObject * obj);
static GType page_view_get_type_once (void);
static void _vala_page_view_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_page_view_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static GType
crop_location_get_type_once (void)
{
	static const GEnumValue values[] = {{CROP_LOCATION_NONE, "CROP_LOCATION_NONE", "none"}, {CROP_LOCATION_MIDDLE, "CROP_LOCATION_MIDDLE", "middle"}, {CROP_LOCATION_TOP, "CROP_LOCATION_TOP", "top"}, {CROP_LOCATION_BOTTOM, "CROP_LOCATION_BOTTOM", "bottom"}, {CROP_LOCATION_LEFT, "CROP_LOCATION_LEFT", "left"}, {CROP_LOCATION_RIGHT, "CROP_LOCATION_RIGHT", "right"}, {CROP_LOCATION_TOP_LEFT, "CROP_LOCATION_TOP_LEFT", "top-left"}, {CROP_LOCATION_TOP_RIGHT, "CROP_LOCATION_TOP_RIGHT", "top-right"}, {CROP_LOCATION_BOTTOM_LEFT, "CROP_LOCATION_BOTTOM_LEFT", "bottom-left"}, {CROP_LOCATION_BOTTOM_RIGHT, "CROP_LOCATION_BOTTOM_RIGHT", "bottom-right"}, {0, NULL, NULL}};
	GType crop_location_type_id;
	crop_location_type_id = g_enum_register_static ("CropLocation", values);
	return crop_location_type_id;
}

GType
crop_location_get_type (void)
{
	static volatile gsize crop_location_type_id__once = 0;
	if (g_once_init_enter (&crop_location_type_id__once)) {
		GType crop_location_type_id;
		crop_location_type_id = crop_location_get_type_once ();
		g_once_init_leave (&crop_location_type_id__once, crop_location_type_id);
	}
	return crop_location_type_id__once;
}

static inline gpointer
page_view_get_instance_private (PageView* self)
{
	return G_STRUCT_MEMBER_P (self, PageView_private_offset);
}

static void
_page_view_page_pixels_changed_cb_page_pixels_changed (Page* _sender,
                                                       gpointer self)
{
#line 99 "../src/page-view.vala"
	page_view_page_pixels_changed_cb ((PageView*) self, _sender);
#line 323 "page-view.c"
}

static void
_page_view_page_size_changed_cb_page_size_changed (Page* _sender,
                                                   gpointer self)
{
#line 100 "../src/page-view.vala"
	page_view_page_size_changed_cb ((PageView*) self, _sender);
#line 332 "page-view.c"
}

static void
_page_view_page_overlay_changed_cb_page_crop_changed (Page* _sender,
                                                      gpointer self)
{
#line 101 "../src/page-view.vala"
	page_view_page_overlay_changed_cb ((PageView*) self, _sender);
#line 341 "page-view.c"
}

static void
_page_view_page_overlay_changed_cb_page_scan_line_changed (Page* _sender,
                                                           gpointer self)
{
#line 102 "../src/page-view.vala"
	page_view_page_overlay_changed_cb ((PageView*) self, _sender);
#line 350 "page-view.c"
}

static void
_page_view_scan_direction_changed_cb_page_scan_direction_changed (Page* _sender,
                                                                  gpointer self)
{
#line 103 "../src/page-view.vala"
	page_view_scan_direction_changed_cb ((PageView*) self, _sender);
#line 359 "page-view.c"
}

PageView*
page_view_construct (GType object_type,
                     Page* page)
{
	PageView * self = NULL;
#line 87 "../src/page-view.vala"
	g_return_val_if_fail (page != NULL, NULL);
#line 87 "../src/page-view.vala"
	self = (PageView*) g_object_new (object_type, NULL);
#line 89 "../src/page-view.vala"
	page_view_set_page (self, page);
#line 90 "../src/page-view.vala"
	g_signal_connect_object (page, "pixels-changed", (GCallback) _page_view_page_pixels_changed_cb_page_pixels_changed, self, 0);
#line 91 "../src/page-view.vala"
	g_signal_connect_object (page, "size-changed", (GCallback) _page_view_page_size_changed_cb_page_size_changed, self, 0);
#line 92 "../src/page-view.vala"
	g_signal_connect_object (page, "crop-changed", (GCallback) _page_view_page_overlay_changed_cb_page_crop_changed, self, 0);
#line 93 "../src/page-view.vala"
	g_signal_connect_object (page, "scan-line-changed", (GCallback) _page_view_page_overlay_changed_cb_page_scan_line_changed, self, 0);
#line 94 "../src/page-view.vala"
	g_signal_connect_object (page, "scan-direction-changed", (GCallback) _page_view_scan_direction_changed_cb_page_scan_direction_changed, self, 0);
#line 87 "../src/page-view.vala"
	return self;
#line 385 "page-view.c"
}

PageView*
page_view_new (Page* page)
{
#line 87 "../src/page-view.vala"
	return page_view_construct (TYPE_PAGE_VIEW, page);
#line 393 "page-view.c"
}

static guchar
page_view_get_sample (PageView* self,
                      guchar* pixels,
                      gint pixels_length1,
                      gint offset,
                      gint x,
                      gint depth,
                      gint sample)
{
	guchar result;
#line 106 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, '\0');
#line 109 "../src/page-view.vala"
	result = (guchar) 0xFF;
#line 109 "../src/page-view.vala"
	return result;
#line 412 "page-view.c"
}

static void
page_view_get_pixel (PageView* self,
                     Page* page,
                     gint x,
                     gint y,
                     guchar* pixel,
                     gint pixel_length1)
{
	ScanDirection _tmp0_;
	ScanDirection _tmp1_;
	gint depth = 0;
	gint _tmp10_;
	gint _tmp11_;
	gint n_channels = 0;
	gint _tmp12_;
	gint _tmp13_;
	guchar* pixels = NULL;
	gint _tmp14_ = 0;
	guchar* _tmp15_;
	gint pixels_length1;
	gint _pixels_size_;
	gint offset = 0;
	gint _tmp16_;
	gint _tmp17_;
	gboolean _tmp18_ = FALSE;
	guchar* _tmp37_;
	gint _tmp37__length1;
	guchar* _tmp38_;
	gint _tmp38__length1;
	guchar* _tmp39_;
	gint _tmp39__length1;
#line 112 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 112 "../src/page-view.vala"
	g_return_if_fail (page != NULL);
#line 114 "../src/page-view.vala"
	_tmp0_ = page_get_scan_direction (page);
#line 114 "../src/page-view.vala"
	_tmp1_ = _tmp0_;
#line 114 "../src/page-view.vala"
	switch (_tmp1_) {
#line 114 "../src/page-view.vala"
		case SCAN_DIRECTION_TOP_TO_BOTTOM:
#line 458 "page-view.c"
		{
#line 117 "../src/page-view.vala"
			break;
#line 462 "page-view.c"
		}
#line 114 "../src/page-view.vala"
		case SCAN_DIRECTION_BOTTOM_TO_TOP:
#line 466 "page-view.c"
		{
			gint _tmp2_;
			gint _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
#line 119 "../src/page-view.vala"
			_tmp2_ = page_get_scan_width (page);
#line 119 "../src/page-view.vala"
			_tmp3_ = _tmp2_;
#line 119 "../src/page-view.vala"
			x = (_tmp3_ - x) - 1;
#line 120 "../src/page-view.vala"
			_tmp4_ = page_get_scan_height (page);
#line 120 "../src/page-view.vala"
			_tmp5_ = _tmp4_;
#line 120 "../src/page-view.vala"
			y = (_tmp5_ - y) - 1;
#line 121 "../src/page-view.vala"
			break;
#line 486 "page-view.c"
		}
#line 114 "../src/page-view.vala"
		case SCAN_DIRECTION_LEFT_TO_RIGHT:
#line 490 "page-view.c"
		{
			gint t = 0;
			gint _tmp6_;
			gint _tmp7_;
#line 123 "../src/page-view.vala"
			t = x;
#line 124 "../src/page-view.vala"
			_tmp6_ = page_get_scan_width (page);
#line 124 "../src/page-view.vala"
			_tmp7_ = _tmp6_;
#line 124 "../src/page-view.vala"
			x = (_tmp7_ - y) - 1;
#line 125 "../src/page-view.vala"
			y = t;
#line 126 "../src/page-view.vala"
			break;
#line 507 "page-view.c"
		}
#line 114 "../src/page-view.vala"
		case SCAN_DIRECTION_RIGHT_TO_LEFT:
#line 511 "page-view.c"
		{
			gint t = 0;
			gint _tmp8_;
			gint _tmp9_;
#line 128 "../src/page-view.vala"
			t = x;
#line 129 "../src/page-view.vala"
			x = y;
#line 130 "../src/page-view.vala"
			_tmp8_ = page_get_scan_height (page);
#line 130 "../src/page-view.vala"
			_tmp9_ = _tmp8_;
#line 130 "../src/page-view.vala"
			y = (_tmp9_ - t) - 1;
#line 131 "../src/page-view.vala"
			break;
#line 528 "page-view.c"
		}
		default:
#line 114 "../src/page-view.vala"
		break;
#line 533 "page-view.c"
	}
#line 134 "../src/page-view.vala"
	_tmp10_ = page_get_depth (page);
#line 134 "../src/page-view.vala"
	_tmp11_ = _tmp10_;
#line 134 "../src/page-view.vala"
	depth = _tmp11_;
#line 135 "../src/page-view.vala"
	_tmp12_ = page_get_n_channels (page);
#line 135 "../src/page-view.vala"
	_tmp13_ = _tmp12_;
#line 135 "../src/page-view.vala"
	n_channels = _tmp13_;
#line 136 "../src/page-view.vala"
	_tmp15_ = page_get_pixels (page, &_tmp14_);
#line 136 "../src/page-view.vala"
	pixels = _tmp15_;
#line 136 "../src/page-view.vala"
	pixels_length1 = _tmp14_;
#line 136 "../src/page-view.vala"
	_pixels_size_ = pixels_length1;
#line 137 "../src/page-view.vala"
	_tmp16_ = page_get_rowstride (page);
#line 137 "../src/page-view.vala"
	_tmp17_ = _tmp16_;
#line 137 "../src/page-view.vala"
	offset = _tmp17_ * y;
#line 140 "../src/page-view.vala"
	if (depth == 8) {
#line 140 "../src/page-view.vala"
		_tmp18_ = n_channels == 3;
#line 565 "page-view.c"
	} else {
#line 140 "../src/page-view.vala"
		_tmp18_ = FALSE;
#line 569 "page-view.c"
	}
#line 140 "../src/page-view.vala"
	if (_tmp18_) {
#line 573 "page-view.c"
		gint o = 0;
		guchar* _tmp19_;
		gint _tmp19__length1;
		guchar _tmp20_;
		guchar* _tmp21_;
		gint _tmp21__length1;
		guchar _tmp22_;
		guchar* _tmp23_;
		gint _tmp23__length1;
		guchar _tmp24_;
#line 142 "../src/page-view.vala"
		o = offset + (x * n_channels);
#line 143 "../src/page-view.vala"
		_tmp19_ = pixels;
#line 143 "../src/page-view.vala"
		_tmp19__length1 = pixels_length1;
#line 143 "../src/page-view.vala"
		_tmp20_ = _tmp19_[o];
#line 143 "../src/page-view.vala"
		pixel[0] = _tmp20_;
#line 144 "../src/page-view.vala"
		_tmp21_ = pixels;
#line 144 "../src/page-view.vala"
		_tmp21__length1 = pixels_length1;
#line 144 "../src/page-view.vala"
		_tmp22_ = _tmp21_[o + 1];
#line 144 "../src/page-view.vala"
		pixel[1] = _tmp22_;
#line 145 "../src/page-view.vala"
		_tmp23_ = pixels;
#line 145 "../src/page-view.vala"
		_tmp23__length1 = pixels_length1;
#line 145 "../src/page-view.vala"
		_tmp24_ = _tmp23_[o + 2];
#line 145 "../src/page-view.vala"
		pixel[2] = _tmp24_;
#line 146 "../src/page-view.vala"
		return;
#line 612 "page-view.c"
	} else {
		gboolean _tmp25_ = FALSE;
#line 148 "../src/page-view.vala"
		if (depth == 8) {
#line 148 "../src/page-view.vala"
			_tmp25_ = n_channels == 1;
#line 619 "page-view.c"
		} else {
#line 148 "../src/page-view.vala"
			_tmp25_ = FALSE;
#line 623 "page-view.c"
		}
#line 148 "../src/page-view.vala"
		if (_tmp25_) {
#line 627 "page-view.c"
			guchar* _tmp26_;
			gint _tmp26__length1;
			guchar _tmp27_;
#line 150 "../src/page-view.vala"
			_tmp26_ = pixels;
#line 150 "../src/page-view.vala"
			_tmp26__length1 = pixels_length1;
#line 150 "../src/page-view.vala"
			_tmp27_ = _tmp26_[offset + x];
#line 150 "../src/page-view.vala"
			pixel[2] = _tmp27_;
#line 150 "../src/page-view.vala"
			pixel[1] = pixel[2];
#line 150 "../src/page-view.vala"
			pixel[0] = pixel[1];
#line 151 "../src/page-view.vala"
			return;
#line 645 "page-view.c"
		} else {
			gboolean _tmp28_ = FALSE;
#line 155 "../src/page-view.vala"
			if (depth == 1) {
#line 155 "../src/page-view.vala"
				_tmp28_ = n_channels == 1;
#line 652 "page-view.c"
			} else {
#line 155 "../src/page-view.vala"
				_tmp28_ = FALSE;
#line 656 "page-view.c"
			}
#line 155 "../src/page-view.vala"
			if (_tmp28_) {
#line 660 "page-view.c"
				gint o = 0;
				gint _tmp29_ = 0;
				guchar* _tmp30_;
				gint _tmp30__length1;
				guchar _tmp31_;
#line 157 "../src/page-view.vala"
				o = offset + (x / 8);
#line 158 "../src/page-view.vala"
				_tmp30_ = pixels;
#line 158 "../src/page-view.vala"
				_tmp30__length1 = pixels_length1;
#line 158 "../src/page-view.vala"
				_tmp31_ = _tmp30_[o];
#line 158 "../src/page-view.vala"
				if (((gint) (_tmp31_ & (0x80 >> (x % 8)))) != 0) {
#line 158 "../src/page-view.vala"
					_tmp29_ = 0x00;
#line 678 "page-view.c"
				} else {
#line 158 "../src/page-view.vala"
					_tmp29_ = 0xFF;
#line 682 "page-view.c"
				}
#line 158 "../src/page-view.vala"
				pixel[2] = (guchar) _tmp29_;
#line 158 "../src/page-view.vala"
				pixel[1] = pixel[2];
#line 158 "../src/page-view.vala"
				pixel[0] = pixel[1];
#line 159 "../src/page-view.vala"
				return;
#line 692 "page-view.c"
			} else {
				gboolean _tmp32_ = FALSE;
#line 163 "../src/page-view.vala"
				if (depth == 2) {
#line 163 "../src/page-view.vala"
					_tmp32_ = n_channels == 1;
#line 699 "page-view.c"
				} else {
#line 163 "../src/page-view.vala"
					_tmp32_ = FALSE;
#line 703 "page-view.c"
				}
#line 163 "../src/page-view.vala"
				if (_tmp32_) {
#line 707 "page-view.c"
					gint block_shift[4] = {0};
					gint _tmp33_[4] = {0};
					gint o = 0;
					gint sample = 0;
					guchar* _tmp34_;
					gint _tmp34__length1;
					guchar _tmp35_;
					gint _tmp36_;
#line 165 "../src/page-view.vala"
					_tmp33_[0] = 6;
#line 165 "../src/page-view.vala"
					_tmp33_[1] = 4;
#line 165 "../src/page-view.vala"
					_tmp33_[2] = 2;
#line 165 "../src/page-view.vala"
					_tmp33_[3] = 0;
#line 165 "../src/page-view.vala"
					memcpy (block_shift, _tmp33_, 4 * sizeof (gint));
#line 167 "../src/page-view.vala"
					o = offset + (x / 4);
#line 168 "../src/page-view.vala"
					_tmp34_ = pixels;
#line 168 "../src/page-view.vala"
					_tmp34__length1 = pixels_length1;
#line 168 "../src/page-view.vala"
					_tmp35_ = _tmp34_[o];
#line 168 "../src/page-view.vala"
					_tmp36_ = block_shift[x % 4];
#line 168 "../src/page-view.vala"
					sample = (_tmp35_ >> _tmp36_) & 0x3;
#line 169 "../src/page-view.vala"
					sample = (sample * 255) / 3;
#line 171 "../src/page-view.vala"
					pixel[2] = (guchar) sample;
#line 171 "../src/page-view.vala"
					pixel[1] = pixel[2];
#line 171 "../src/page-view.vala"
					pixel[0] = pixel[1];
#line 172 "../src/page-view.vala"
					return;
#line 748 "page-view.c"
				}
			}
		}
	}
#line 176 "../src/page-view.vala"
	_tmp37_ = pixels;
#line 176 "../src/page-view.vala"
	_tmp37__length1 = pixels_length1;
#line 176 "../src/page-view.vala"
	pixel[0] = page_view_get_sample (self, _tmp37_, (gint) _tmp37__length1, offset, x, depth, x * n_channels);
#line 177 "../src/page-view.vala"
	_tmp38_ = pixels;
#line 177 "../src/page-view.vala"
	_tmp38__length1 = pixels_length1;
#line 177 "../src/page-view.vala"
	pixel[1] = page_view_get_sample (self, _tmp38_, (gint) _tmp38__length1, offset, x, depth, (x * n_channels) + 1);
#line 178 "../src/page-view.vala"
	_tmp39_ = pixels;
#line 178 "../src/page-view.vala"
	_tmp39__length1 = pixels_length1;
#line 178 "../src/page-view.vala"
	pixel[2] = page_view_get_sample (self, _tmp39_, (gint) _tmp39__length1, offset, x, depth, (x * n_channels) + 2);
#line 771 "page-view.c"
}

static void
page_view_set_pixel (PageView* self,
                     Page* page,
                     gdouble l,
                     gdouble r,
                     gdouble t,
                     gdouble b,
                     guchar* output,
                     gint output_length1,
                     gint offset)
{
	gint L = 0;
	gint R = 0;
	gint T = 0;
	gint B = 0;
	gdouble red = 0.0;
	gdouble green = 0.0;
	gdouble blue = 0.0;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp54_ = FALSE;
	gboolean _tmp58_ = FALSE;
	gboolean _tmp62_ = FALSE;
	gboolean _tmp66_ = FALSE;
	gdouble scale = 0.0;
#line 181 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 181 "../src/page-view.vala"
	g_return_if_fail (page != NULL);
#line 227 "../src/page-view.vala"
	L = (gint) l;
#line 228 "../src/page-view.vala"
	if (((gdouble) L) != l) {
#line 807 "page-view.c"
		gint _tmp0_;
#line 229 "../src/page-view.vala"
		_tmp0_ = L;
#line 229 "../src/page-view.vala"
		L = _tmp0_ + 1;
#line 813 "page-view.c"
	}
#line 230 "../src/page-view.vala"
	R = (gint) r;
#line 231 "../src/page-view.vala"
	T = (gint) t;
#line 232 "../src/page-view.vala"
	if (((gdouble) T) != t) {
#line 821 "page-view.c"
		gint _tmp1_;
#line 233 "../src/page-view.vala"
		_tmp1_ = T;
#line 233 "../src/page-view.vala"
		T = _tmp1_ + 1;
#line 827 "page-view.c"
	}
#line 234 "../src/page-view.vala"
	B = (gint) b;
#line 236 "../src/page-view.vala"
	red = 0.0;
#line 237 "../src/page-view.vala"
	green = 0.0;
#line 238 "../src/page-view.vala"
	blue = 0.0;
#line 249 "../src/page-view.vala"
	if ((r - l) <= 1.0) {
#line 249 "../src/page-view.vala"
		_tmp3_ = ((gint) r) == ((gint) l);
#line 841 "page-view.c"
	} else {
#line 249 "../src/page-view.vala"
		_tmp3_ = FALSE;
#line 845 "page-view.c"
	}
#line 249 "../src/page-view.vala"
	if (_tmp3_) {
#line 249 "../src/page-view.vala"
		_tmp2_ = TRUE;
#line 851 "page-view.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 249 "../src/page-view.vala"
		if ((b - t) <= 1.0) {
#line 249 "../src/page-view.vala"
			_tmp4_ = ((gint) b) == ((gint) t);
#line 858 "page-view.c"
		} else {
#line 249 "../src/page-view.vala"
			_tmp4_ = FALSE;
#line 862 "page-view.c"
		}
#line 249 "../src/page-view.vala"
		_tmp2_ = _tmp4_;
#line 866 "page-view.c"
	}
#line 249 "../src/page-view.vala"
	if (_tmp2_) {
#line 870 "page-view.c"
		gboolean _tmp5_ = FALSE;
		gdouble scale = 0.0;
#line 252 "../src/page-view.vala"
		if (((gint) l) == ((gint) r)) {
#line 252 "../src/page-view.vala"
			_tmp5_ = TRUE;
#line 877 "page-view.c"
		} else {
#line 252 "../src/page-view.vala"
			_tmp5_ = ((gint) t) == ((gint) b);
#line 881 "page-view.c"
		}
#line 252 "../src/page-view.vala"
		if (_tmp5_) {
#line 885 "page-view.c"
			guchar p[3] = {0};
			guchar _tmp6_;
			guchar _tmp7_;
			guchar _tmp8_;
#line 255 "../src/page-view.vala"
			page_view_get_pixel (self, page, (gint) l, (gint) t, p, (gint) 3);
#line 256 "../src/page-view.vala"
			_tmp6_ = p[0];
#line 256 "../src/page-view.vala"
			output[offset] = _tmp6_;
#line 257 "../src/page-view.vala"
			_tmp7_ = p[1];
#line 257 "../src/page-view.vala"
			output[offset + 1] = _tmp7_;
#line 258 "../src/page-view.vala"
			_tmp8_ = p[2];
#line 258 "../src/page-view.vala"
			output[offset + 2] = _tmp8_;
#line 259 "../src/page-view.vala"
			return;
#line 906 "page-view.c"
		}
#line 263 "../src/page-view.vala"
		if (L > R) {
#line 910 "page-view.c"
			guchar p[3] = {0};
			guchar _tmp9_;
			guchar _tmp10_;
			guchar _tmp11_;
			guchar _tmp17_;
			guchar _tmp18_;
			guchar _tmp19_;
#line 266 "../src/page-view.vala"
			page_view_get_pixel (self, page, R, T - 1, p, (gint) 3);
#line 267 "../src/page-view.vala"
			_tmp9_ = p[0];
#line 267 "../src/page-view.vala"
			red += (_tmp9_ * (r - l)) * (T - t);
#line 268 "../src/page-view.vala"
			_tmp10_ = p[1];
#line 268 "../src/page-view.vala"
			green += (_tmp10_ * (r - l)) * (T - t);
#line 269 "../src/page-view.vala"
			_tmp11_ = p[2];
#line 269 "../src/page-view.vala"
			blue += (_tmp11_ * (r - l)) * (T - t);
#line 932 "page-view.c"
			{
				gint y = 0;
#line 270 "../src/page-view.vala"
				y = T;
#line 937 "page-view.c"
				{
					gboolean _tmp12_ = FALSE;
#line 270 "../src/page-view.vala"
					_tmp12_ = TRUE;
#line 270 "../src/page-view.vala"
					while (TRUE) {
#line 944 "page-view.c"
						guchar _tmp14_;
						guchar _tmp15_;
						guchar _tmp16_;
#line 270 "../src/page-view.vala"
						if (!_tmp12_) {
#line 950 "page-view.c"
							gint _tmp13_;
#line 270 "../src/page-view.vala"
							_tmp13_ = y;
#line 270 "../src/page-view.vala"
							y = _tmp13_ + 1;
#line 956 "page-view.c"
						}
#line 270 "../src/page-view.vala"
						_tmp12_ = FALSE;
#line 270 "../src/page-view.vala"
						if (!(y < B)) {
#line 270 "../src/page-view.vala"
							break;
#line 964 "page-view.c"
						}
#line 272 "../src/page-view.vala"
						page_view_get_pixel (self, page, R, y, p, (gint) 3);
#line 273 "../src/page-view.vala"
						_tmp14_ = p[0];
#line 273 "../src/page-view.vala"
						red += _tmp14_ * (r - l);
#line 274 "../src/page-view.vala"
						_tmp15_ = p[1];
#line 274 "../src/page-view.vala"
						green += _tmp15_ * (r - l);
#line 275 "../src/page-view.vala"
						_tmp16_ = p[2];
#line 275 "../src/page-view.vala"
						blue += _tmp16_ * (r - l);
#line 980 "page-view.c"
					}
				}
			}
#line 277 "../src/page-view.vala"
			page_view_get_pixel (self, page, R, B, p, (gint) 3);
#line 278 "../src/page-view.vala"
			_tmp17_ = p[0];
#line 278 "../src/page-view.vala"
			red += (_tmp17_ * (r - l)) * (b - B);
#line 279 "../src/page-view.vala"
			_tmp18_ = p[1];
#line 279 "../src/page-view.vala"
			green += (_tmp18_ * (r - l)) * (b - B);
#line 280 "../src/page-view.vala"
			_tmp19_ = p[2];
#line 280 "../src/page-view.vala"
			blue += (_tmp19_ * (r - l)) * (b - B);
#line 998 "page-view.c"
		} else {
			guchar p[3] = {0};
			guchar _tmp20_;
			guchar _tmp21_;
			guchar _tmp22_;
			guchar _tmp28_;
			guchar _tmp29_;
			guchar _tmp30_;
#line 286 "../src/page-view.vala"
			page_view_get_pixel (self, page, L - 1, B, p, (gint) 3);
#line 287 "../src/page-view.vala"
			_tmp20_ = p[0];
#line 287 "../src/page-view.vala"
			red += (_tmp20_ * (b - t)) * (L - l);
#line 288 "../src/page-view.vala"
			_tmp21_ = p[1];
#line 288 "../src/page-view.vala"
			green += (_tmp21_ * (b - t)) * (L - l);
#line 289 "../src/page-view.vala"
			_tmp22_ = p[2];
#line 289 "../src/page-view.vala"
			blue += (_tmp22_ * (b - t)) * (L - l);
#line 1021 "page-view.c"
			{
				gint x = 0;
#line 290 "../src/page-view.vala"
				x = L;
#line 1026 "page-view.c"
				{
					gboolean _tmp23_ = FALSE;
#line 290 "../src/page-view.vala"
					_tmp23_ = TRUE;
#line 290 "../src/page-view.vala"
					while (TRUE) {
#line 1033 "page-view.c"
						guchar _tmp25_;
						guchar _tmp26_;
						guchar _tmp27_;
#line 290 "../src/page-view.vala"
						if (!_tmp23_) {
#line 1039 "page-view.c"
							gint _tmp24_;
#line 290 "../src/page-view.vala"
							_tmp24_ = x;
#line 290 "../src/page-view.vala"
							x = _tmp24_ + 1;
#line 1045 "page-view.c"
						}
#line 290 "../src/page-view.vala"
						_tmp23_ = FALSE;
#line 290 "../src/page-view.vala"
						if (!(x < R)) {
#line 290 "../src/page-view.vala"
							break;
#line 1053 "page-view.c"
						}
#line 291 "../src/page-view.vala"
						page_view_get_pixel (self, page, x, B, p, (gint) 3);
#line 292 "../src/page-view.vala"
						_tmp25_ = p[0];
#line 292 "../src/page-view.vala"
						red += _tmp25_ * (b - t);
#line 293 "../src/page-view.vala"
						_tmp26_ = p[1];
#line 293 "../src/page-view.vala"
						green += _tmp26_ * (b - t);
#line 294 "../src/page-view.vala"
						_tmp27_ = p[2];
#line 294 "../src/page-view.vala"
						blue += _tmp27_ * (b - t);
#line 1069 "page-view.c"
					}
				}
			}
#line 296 "../src/page-view.vala"
			page_view_get_pixel (self, page, R, B, p, (gint) 3);
#line 297 "../src/page-view.vala"
			_tmp28_ = p[0];
#line 297 "../src/page-view.vala"
			red += (_tmp28_ * (b - t)) * (r - R);
#line 298 "../src/page-view.vala"
			_tmp29_ = p[1];
#line 298 "../src/page-view.vala"
			green += (_tmp29_ * (b - t)) * (r - R);
#line 299 "../src/page-view.vala"
			_tmp30_ = p[2];
#line 299 "../src/page-view.vala"
			blue += (_tmp30_ * (b - t)) * (r - R);
#line 1087 "page-view.c"
		}
#line 302 "../src/page-view.vala"
		scale = 1.0 / ((r - l) * (b - t));
#line 303 "../src/page-view.vala"
		output[offset] = (guchar) ((red * scale) + 0.5);
#line 304 "../src/page-view.vala"
		output[offset + 1] = (guchar) ((green * scale) + 0.5);
#line 305 "../src/page-view.vala"
		output[offset + 2] = (guchar) ((blue * scale) + 0.5);
#line 306 "../src/page-view.vala"
		return;
#line 1099 "page-view.c"
	}
	{
		gint x = 0;
#line 310 "../src/page-view.vala"
		x = L;
#line 1105 "page-view.c"
		{
			gboolean _tmp31_ = FALSE;
#line 310 "../src/page-view.vala"
			_tmp31_ = TRUE;
#line 310 "../src/page-view.vala"
			while (TRUE) {
#line 310 "../src/page-view.vala"
				if (!_tmp31_) {
#line 1114 "page-view.c"
					gint _tmp32_;
#line 310 "../src/page-view.vala"
					_tmp32_ = x;
#line 310 "../src/page-view.vala"
					x = _tmp32_ + 1;
#line 1120 "page-view.c"
				}
#line 310 "../src/page-view.vala"
				_tmp31_ = FALSE;
#line 310 "../src/page-view.vala"
				if (!(x < R)) {
#line 310 "../src/page-view.vala"
					break;
#line 1128 "page-view.c"
				}
				{
					gint y = 0;
#line 312 "../src/page-view.vala"
					y = T;
#line 1134 "page-view.c"
					{
						gboolean _tmp33_ = FALSE;
#line 312 "../src/page-view.vala"
						_tmp33_ = TRUE;
#line 312 "../src/page-view.vala"
						while (TRUE) {
#line 1141 "page-view.c"
							guchar p[3] = {0};
							guchar _tmp35_;
							guchar _tmp36_;
							guchar _tmp37_;
#line 312 "../src/page-view.vala"
							if (!_tmp33_) {
#line 1148 "page-view.c"
								gint _tmp34_;
#line 312 "../src/page-view.vala"
								_tmp34_ = y;
#line 312 "../src/page-view.vala"
								y = _tmp34_ + 1;
#line 1154 "page-view.c"
							}
#line 312 "../src/page-view.vala"
							_tmp33_ = FALSE;
#line 312 "../src/page-view.vala"
							if (!(y < B)) {
#line 312 "../src/page-view.vala"
								break;
#line 1162 "page-view.c"
							}
#line 315 "../src/page-view.vala"
							page_view_get_pixel (self, page, x, y, p, (gint) 3);
#line 316 "../src/page-view.vala"
							_tmp35_ = p[0];
#line 316 "../src/page-view.vala"
							red += (gdouble) _tmp35_;
#line 317 "../src/page-view.vala"
							_tmp36_ = p[1];
#line 317 "../src/page-view.vala"
							green += (gdouble) _tmp36_;
#line 318 "../src/page-view.vala"
							_tmp37_ = p[2];
#line 318 "../src/page-view.vala"
							blue += (gdouble) _tmp37_;
#line 1178 "page-view.c"
						}
					}
				}
			}
		}
	}
	{
		gint x = 0;
#line 323 "../src/page-view.vala"
		x = L;
#line 1189 "page-view.c"
		{
			gboolean _tmp38_ = FALSE;
#line 323 "../src/page-view.vala"
			_tmp38_ = TRUE;
#line 323 "../src/page-view.vala"
			while (TRUE) {
#line 323 "../src/page-view.vala"
				if (!_tmp38_) {
#line 1198 "page-view.c"
					gint _tmp39_;
#line 323 "../src/page-view.vala"
					_tmp39_ = x;
#line 323 "../src/page-view.vala"
					x = _tmp39_ + 1;
#line 1204 "page-view.c"
				}
#line 323 "../src/page-view.vala"
				_tmp38_ = FALSE;
#line 323 "../src/page-view.vala"
				if (!(x < R)) {
#line 323 "../src/page-view.vala"
					break;
#line 1212 "page-view.c"
				}
#line 325 "../src/page-view.vala"
				if (t != ((gdouble) T)) {
#line 1216 "page-view.c"
					guchar p[3] = {0};
					guchar _tmp40_;
					guchar _tmp41_;
					guchar _tmp42_;
#line 328 "../src/page-view.vala"
					page_view_get_pixel (self, page, x, T - 1, p, (gint) 3);
#line 329 "../src/page-view.vala"
					_tmp40_ = p[0];
#line 329 "../src/page-view.vala"
					red += _tmp40_ * (T - t);
#line 330 "../src/page-view.vala"
					_tmp41_ = p[1];
#line 330 "../src/page-view.vala"
					green += _tmp41_ * (T - t);
#line 331 "../src/page-view.vala"
					_tmp42_ = p[2];
#line 331 "../src/page-view.vala"
					blue += _tmp42_ * (T - t);
#line 1235 "page-view.c"
				}
#line 334 "../src/page-view.vala"
				if (b != ((gdouble) B)) {
#line 1239 "page-view.c"
					guchar p[3] = {0};
					guchar _tmp43_;
					guchar _tmp44_;
					guchar _tmp45_;
#line 337 "../src/page-view.vala"
					page_view_get_pixel (self, page, x, B, p, (gint) 3);
#line 338 "../src/page-view.vala"
					_tmp43_ = p[0];
#line 338 "../src/page-view.vala"
					red += _tmp43_ * (b - B);
#line 339 "../src/page-view.vala"
					_tmp44_ = p[1];
#line 339 "../src/page-view.vala"
					green += _tmp44_ * (b - B);
#line 340 "../src/page-view.vala"
					_tmp45_ = p[2];
#line 340 "../src/page-view.vala"
					blue += _tmp45_ * (b - B);
#line 1258 "page-view.c"
				}
			}
		}
	}
	{
		gint y = 0;
#line 345 "../src/page-view.vala"
		y = T;
#line 1267 "page-view.c"
		{
			gboolean _tmp46_ = FALSE;
#line 345 "../src/page-view.vala"
			_tmp46_ = TRUE;
#line 345 "../src/page-view.vala"
			while (TRUE) {
#line 345 "../src/page-view.vala"
				if (!_tmp46_) {
#line 1276 "page-view.c"
					gint _tmp47_;
#line 345 "../src/page-view.vala"
					_tmp47_ = y;
#line 345 "../src/page-view.vala"
					y = _tmp47_ + 1;
#line 1282 "page-view.c"
				}
#line 345 "../src/page-view.vala"
				_tmp46_ = FALSE;
#line 345 "../src/page-view.vala"
				if (!(y < B)) {
#line 345 "../src/page-view.vala"
					break;
#line 1290 "page-view.c"
				}
#line 347 "../src/page-view.vala"
				if (l != ((gdouble) L)) {
#line 1294 "page-view.c"
					guchar p[3] = {0};
					guchar _tmp48_;
					guchar _tmp49_;
					guchar _tmp50_;
#line 350 "../src/page-view.vala"
					page_view_get_pixel (self, page, L - 1, y, p, (gint) 3);
#line 351 "../src/page-view.vala"
					_tmp48_ = p[0];
#line 351 "../src/page-view.vala"
					red += _tmp48_ * (L - l);
#line 352 "../src/page-view.vala"
					_tmp49_ = p[1];
#line 352 "../src/page-view.vala"
					green += _tmp49_ * (L - l);
#line 353 "../src/page-view.vala"
					_tmp50_ = p[2];
#line 353 "../src/page-view.vala"
					blue += _tmp50_ * (L - l);
#line 1313 "page-view.c"
				}
#line 356 "../src/page-view.vala"
				if (r != ((gdouble) R)) {
#line 1317 "page-view.c"
					guchar p[3] = {0};
					guchar _tmp51_;
					guchar _tmp52_;
					guchar _tmp53_;
#line 359 "../src/page-view.vala"
					page_view_get_pixel (self, page, R, y, p, (gint) 3);
#line 360 "../src/page-view.vala"
					_tmp51_ = p[0];
#line 360 "../src/page-view.vala"
					red += _tmp51_ * (r - R);
#line 361 "../src/page-view.vala"
					_tmp52_ = p[1];
#line 361 "../src/page-view.vala"
					green += _tmp52_ * (r - R);
#line 362 "../src/page-view.vala"
					_tmp53_ = p[2];
#line 362 "../src/page-view.vala"
					blue += _tmp53_ * (r - R);
#line 1336 "page-view.c"
				}
			}
		}
	}
#line 367 "../src/page-view.vala"
	if (l != ((gdouble) L)) {
#line 367 "../src/page-view.vala"
		_tmp54_ = t != ((gdouble) T);
#line 1345 "page-view.c"
	} else {
#line 367 "../src/page-view.vala"
		_tmp54_ = FALSE;
#line 1349 "page-view.c"
	}
#line 367 "../src/page-view.vala"
	if (_tmp54_) {
#line 1353 "page-view.c"
		guchar p[3] = {0};
		guchar _tmp55_;
		guchar _tmp56_;
		guchar _tmp57_;
#line 370 "../src/page-view.vala"
		page_view_get_pixel (self, page, L - 1, T - 1, p, (gint) 3);
#line 371 "../src/page-view.vala"
		_tmp55_ = p[0];
#line 371 "../src/page-view.vala"
		red += (_tmp55_ * (L - l)) * (T - t);
#line 372 "../src/page-view.vala"
		_tmp56_ = p[1];
#line 372 "../src/page-view.vala"
		green += (_tmp56_ * (L - l)) * (T - t);
#line 373 "../src/page-view.vala"
		_tmp57_ = p[2];
#line 373 "../src/page-view.vala"
		blue += (_tmp57_ * (L - l)) * (T - t);
#line 1372 "page-view.c"
	}
#line 375 "../src/page-view.vala"
	if (r != ((gdouble) R)) {
#line 375 "../src/page-view.vala"
		_tmp58_ = t != ((gdouble) T);
#line 1378 "page-view.c"
	} else {
#line 375 "../src/page-view.vala"
		_tmp58_ = FALSE;
#line 1382 "page-view.c"
	}
#line 375 "../src/page-view.vala"
	if (_tmp58_) {
#line 1386 "page-view.c"
		guchar p[3] = {0};
		guchar _tmp59_;
		guchar _tmp60_;
		guchar _tmp61_;
#line 378 "../src/page-view.vala"
		page_view_get_pixel (self, page, R, T - 1, p, (gint) 3);
#line 379 "../src/page-view.vala"
		_tmp59_ = p[0];
#line 379 "../src/page-view.vala"
		red += (_tmp59_ * (r - R)) * (T - t);
#line 380 "../src/page-view.vala"
		_tmp60_ = p[1];
#line 380 "../src/page-view.vala"
		green += (_tmp60_ * (r - R)) * (T - t);
#line 381 "../src/page-view.vala"
		_tmp61_ = p[2];
#line 381 "../src/page-view.vala"
		blue += (_tmp61_ * (r - R)) * (T - t);
#line 1405 "page-view.c"
	}
#line 383 "../src/page-view.vala"
	if (r != ((gdouble) R)) {
#line 383 "../src/page-view.vala"
		_tmp62_ = b != ((gdouble) B);
#line 1411 "page-view.c"
	} else {
#line 383 "../src/page-view.vala"
		_tmp62_ = FALSE;
#line 1415 "page-view.c"
	}
#line 383 "../src/page-view.vala"
	if (_tmp62_) {
#line 1419 "page-view.c"
		guchar p[3] = {0};
		guchar _tmp63_;
		guchar _tmp64_;
		guchar _tmp65_;
#line 386 "../src/page-view.vala"
		page_view_get_pixel (self, page, R, B, p, (gint) 3);
#line 387 "../src/page-view.vala"
		_tmp63_ = p[0];
#line 387 "../src/page-view.vala"
		red += (_tmp63_ * (r - R)) * (b - B);
#line 388 "../src/page-view.vala"
		_tmp64_ = p[1];
#line 388 "../src/page-view.vala"
		green += (_tmp64_ * (r - R)) * (b - B);
#line 389 "../src/page-view.vala"
		_tmp65_ = p[2];
#line 389 "../src/page-view.vala"
		blue += (_tmp65_ * (r - R)) * (b - B);
#line 1438 "page-view.c"
	}
#line 391 "../src/page-view.vala"
	if (l != ((gdouble) L)) {
#line 391 "../src/page-view.vala"
		_tmp66_ = b != ((gdouble) B);
#line 1444 "page-view.c"
	} else {
#line 391 "../src/page-view.vala"
		_tmp66_ = FALSE;
#line 1448 "page-view.c"
	}
#line 391 "../src/page-view.vala"
	if (_tmp66_) {
#line 1452 "page-view.c"
		guchar p[3] = {0};
		guchar _tmp67_;
		guchar _tmp68_;
		guchar _tmp69_;
#line 394 "../src/page-view.vala"
		page_view_get_pixel (self, page, L - 1, B, p, (gint) 3);
#line 395 "../src/page-view.vala"
		_tmp67_ = p[0];
#line 395 "../src/page-view.vala"
		red += (_tmp67_ * (L - l)) * (b - B);
#line 396 "../src/page-view.vala"
		_tmp68_ = p[1];
#line 396 "../src/page-view.vala"
		green += (_tmp68_ * (L - l)) * (b - B);
#line 397 "../src/page-view.vala"
		_tmp69_ = p[2];
#line 397 "../src/page-view.vala"
		blue += (_tmp69_ * (L - l)) * (b - B);
#line 1471 "page-view.c"
	}
#line 401 "../src/page-view.vala"
	scale = 1.0 / ((r - l) * (b - t));
#line 402 "../src/page-view.vala"
	output[offset] = (guchar) ((red * scale) + 0.5);
#line 403 "../src/page-view.vala"
	output[offset + 1] = (guchar) ((green * scale) + 0.5);
#line 404 "../src/page-view.vala"
	output[offset + 2] = (guchar) ((blue * scale) + 0.5);
#line 1481 "page-view.c"
}

static void
page_view_update_preview (PageView* self,
                          Page* page,
                          GdkPixbuf** output_image,
                          gint output_width,
                          gint output_height,
                          ScanDirection scan_direction,
                          gint old_scan_line,
                          gint scan_line)
{
	gint input_width = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint input_height = 0;
	gint _tmp2_;
	gint _tmp3_;
	gint L = 0;
	gint R = 0;
	gint T = 0;
	gint B = 0;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	guchar* output = NULL;
	guint8* _tmp11_;
	gint output_length1;
	gint _output_size_;
	gint output_rowstride = 0;
	gint _tmp12_;
	gint _tmp13_;
	gint output_n_channels = 0;
	gint _tmp14_;
	gint _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
#line 407 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 407 "../src/page-view.vala"
	g_return_if_fail (page != NULL);
#line 410 "../src/page-view.vala"
	_tmp0_ = page_get_width (page);
#line 410 "../src/page-view.vala"
	_tmp1_ = _tmp0_;
#line 410 "../src/page-view.vala"
	input_width = _tmp1_;
#line 411 "../src/page-view.vala"
	_tmp2_ = page_get_height (page);
#line 411 "../src/page-view.vala"
	_tmp3_ = _tmp2_;
#line 411 "../src/page-view.vala"
	input_height = _tmp3_;
#line 415 "../src/page-view.vala"
	if ((*output_image) == NULL) {
#line 415 "../src/page-view.vala"
		_tmp5_ = TRUE;
#line 1538 "page-view.c"
	} else {
		gint _tmp6_;
		gint _tmp7_;
#line 416 "../src/page-view.vala"
		_tmp6_ = gdk_pixbuf_get_width (*output_image);
#line 416 "../src/page-view.vala"
		_tmp7_ = _tmp6_;
#line 416 "../src/page-view.vala"
		_tmp5_ = _tmp7_ != output_width;
#line 1548 "page-view.c"
	}
#line 415 "../src/page-view.vala"
	if (_tmp5_) {
#line 415 "../src/page-view.vala"
		_tmp4_ = TRUE;
#line 1554 "page-view.c"
	} else {
		gint _tmp8_;
		gint _tmp9_;
#line 417 "../src/page-view.vala"
		_tmp8_ = gdk_pixbuf_get_height (*output_image);
#line 417 "../src/page-view.vala"
		_tmp9_ = _tmp8_;
#line 417 "../src/page-view.vala"
		_tmp4_ = _tmp9_ != output_height;
#line 1564 "page-view.c"
	}
#line 415 "../src/page-view.vala"
	if (_tmp4_) {
#line 1568 "page-view.c"
		GdkPixbuf* _tmp10_;
#line 419 "../src/page-view.vala"
		_tmp10_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, FALSE, 8, output_width, output_height);
#line 419 "../src/page-view.vala"
		_g_object_unref0 (*output_image);
#line 419 "../src/page-view.vala"
		*output_image = _tmp10_;
#line 426 "../src/page-view.vala"
		L = 0;
#line 427 "../src/page-view.vala"
		R = output_width - 1;
#line 428 "../src/page-view.vala"
		T = 0;
#line 429 "../src/page-view.vala"
		B = output_height - 1;
#line 1584 "page-view.c"
	} else {
#line 434 "../src/page-view.vala"
		switch (scan_direction) {
#line 434 "../src/page-view.vala"
			case SCAN_DIRECTION_TOP_TO_BOTTOM:
#line 1590 "page-view.c"
			{
#line 437 "../src/page-view.vala"
				L = 0;
#line 438 "../src/page-view.vala"
				R = output_width - 1;
#line 439 "../src/page-view.vala"
				T = (gint) ((((gdouble) old_scan_line) * output_height) / input_height);
#line 440 "../src/page-view.vala"
				B = (gint) (((((gdouble) scan_line) * output_height) / input_height) + 0.5);
#line 441 "../src/page-view.vala"
				break;
#line 1602 "page-view.c"
			}
#line 434 "../src/page-view.vala"
			case SCAN_DIRECTION_LEFT_TO_RIGHT:
#line 1606 "page-view.c"
			{
#line 443 "../src/page-view.vala"
				L = (gint) ((((gdouble) old_scan_line) * output_width) / input_width);
#line 444 "../src/page-view.vala"
				R = (gint) (((((gdouble) scan_line) * output_width) / input_width) + 0.5);
#line 445 "../src/page-view.vala"
				T = 0;
#line 446 "../src/page-view.vala"
				B = output_height - 1;
#line 447 "../src/page-view.vala"
				break;
#line 1618 "page-view.c"
			}
#line 434 "../src/page-view.vala"
			case SCAN_DIRECTION_BOTTOM_TO_TOP:
#line 1622 "page-view.c"
			{
#line 449 "../src/page-view.vala"
				L = 0;
#line 450 "../src/page-view.vala"
				R = output_width - 1;
#line 451 "../src/page-view.vala"
				T = (gint) ((((gdouble) (input_height - scan_line)) * output_height) / input_height);
#line 452 "../src/page-view.vala"
				B = (gint) (((((gdouble) (input_height - old_scan_line)) * output_height) / input_height) + 0.5);
#line 453 "../src/page-view.vala"
				break;
#line 1634 "page-view.c"
			}
#line 434 "../src/page-view.vala"
			case SCAN_DIRECTION_RIGHT_TO_LEFT:
#line 1638 "page-view.c"
			{
#line 455 "../src/page-view.vala"
				L = (gint) ((((gdouble) (input_width - scan_line)) * output_width) / input_width);
#line 456 "../src/page-view.vala"
				R = (gint) (((((gdouble) (input_width - old_scan_line)) * output_width) / input_width) + 0.5);
#line 457 "../src/page-view.vala"
				T = 0;
#line 458 "../src/page-view.vala"
				B = output_height - 1;
#line 459 "../src/page-view.vala"
				break;
#line 1650 "page-view.c"
			}
			default:
			{
#line 461 "../src/page-view.vala"
				T = 0;
#line 461 "../src/page-view.vala"
				B = T;
#line 461 "../src/page-view.vala"
				R = B;
#line 461 "../src/page-view.vala"
				L = R;
#line 462 "../src/page-view.vala"
				break;
#line 1664 "page-view.c"
			}
		}
	}
#line 467 "../src/page-view.vala"
	if (R >= output_width) {
#line 468 "../src/page-view.vala"
		R = output_width - 1;
#line 1672 "page-view.c"
	}
#line 469 "../src/page-view.vala"
	if (B >= output_height) {
#line 470 "../src/page-view.vala"
		B = output_height - 1;
#line 1678 "page-view.c"
	}
#line 472 "../src/page-view.vala"
	g_return_if_fail (L >= 0);
#line 473 "../src/page-view.vala"
	g_return_if_fail (R < output_width);
#line 474 "../src/page-view.vala"
	g_return_if_fail (T >= 0);
#line 475 "../src/page-view.vala"
	g_return_if_fail (B < output_height);
#line 476 "../src/page-view.vala"
	g_return_if_fail ((*output_image) != NULL);
#line 478 "../src/page-view.vala"
	_tmp11_ = gdk_pixbuf_get_pixels (*output_image);
#line 478 "../src/page-view.vala"
	output = _tmp11_;
#line 478 "../src/page-view.vala"
	output_length1 = -1;
#line 478 "../src/page-view.vala"
	_output_size_ = output_length1;
#line 479 "../src/page-view.vala"
	_tmp12_ = gdk_pixbuf_get_rowstride (*output_image);
#line 479 "../src/page-view.vala"
	_tmp13_ = _tmp12_;
#line 479 "../src/page-view.vala"
	output_rowstride = _tmp13_;
#line 480 "../src/page-view.vala"
	_tmp14_ = gdk_pixbuf_get_n_channels (*output_image);
#line 480 "../src/page-view.vala"
	_tmp15_ = _tmp14_;
#line 480 "../src/page-view.vala"
	output_n_channels = _tmp15_;
#line 482 "../src/page-view.vala"
	_tmp16_ = page_get_has_data (page);
#line 482 "../src/page-view.vala"
	_tmp17_ = _tmp16_;
#line 482 "../src/page-view.vala"
	if (!_tmp17_) {
#line 1716 "page-view.c"
		{
			gint x = 0;
#line 484 "../src/page-view.vala"
			x = L;
#line 1721 "page-view.c"
			{
				gboolean _tmp18_ = FALSE;
#line 484 "../src/page-view.vala"
				_tmp18_ = TRUE;
#line 484 "../src/page-view.vala"
				while (TRUE) {
#line 484 "../src/page-view.vala"
					if (!_tmp18_) {
#line 1730 "page-view.c"
						gint _tmp19_;
#line 484 "../src/page-view.vala"
						_tmp19_ = x;
#line 484 "../src/page-view.vala"
						x = _tmp19_ + 1;
#line 1736 "page-view.c"
					}
#line 484 "../src/page-view.vala"
					_tmp18_ = FALSE;
#line 484 "../src/page-view.vala"
					if (!(x <= R)) {
#line 484 "../src/page-view.vala"
						break;
#line 1744 "page-view.c"
					}
					{
						gint y = 0;
#line 485 "../src/page-view.vala"
						y = T;
#line 1750 "page-view.c"
						{
							gboolean _tmp20_ = FALSE;
#line 485 "../src/page-view.vala"
							_tmp20_ = TRUE;
#line 485 "../src/page-view.vala"
							while (TRUE) {
#line 1757 "page-view.c"
								gint o = 0;
								guchar* _tmp22_;
								gint _tmp22__length1;
								guchar* _tmp23_;
								gint _tmp23__length1;
								guchar* _tmp24_;
								gint _tmp24__length1;
#line 485 "../src/page-view.vala"
								if (!_tmp20_) {
#line 1767 "page-view.c"
									gint _tmp21_;
#line 485 "../src/page-view.vala"
									_tmp21_ = y;
#line 485 "../src/page-view.vala"
									y = _tmp21_ + 1;
#line 1773 "page-view.c"
								}
#line 485 "../src/page-view.vala"
								_tmp20_ = FALSE;
#line 485 "../src/page-view.vala"
								if (!(y <= B)) {
#line 485 "../src/page-view.vala"
									break;
#line 1781 "page-view.c"
								}
#line 487 "../src/page-view.vala"
								o = (output_rowstride * y) + (x * output_n_channels);
#line 488 "../src/page-view.vala"
								_tmp22_ = output;
#line 488 "../src/page-view.vala"
								_tmp22__length1 = output_length1;
#line 488 "../src/page-view.vala"
								_tmp23_ = output;
#line 488 "../src/page-view.vala"
								_tmp23__length1 = output_length1;
#line 488 "../src/page-view.vala"
								_tmp24_ = output;
#line 488 "../src/page-view.vala"
								_tmp24__length1 = output_length1;
#line 488 "../src/page-view.vala"
								_tmp24_[o + 2] = (guchar) 0xFF;
#line 488 "../src/page-view.vala"
								_tmp23_[o + 1] = _tmp24_[o + 2];
#line 488 "../src/page-view.vala"
								_tmp22_[o] = _tmp23_[o + 1];
#line 1803 "page-view.c"
							}
						}
					}
				}
			}
		}
#line 490 "../src/page-view.vala"
		return;
#line 1812 "page-view.c"
	}
	{
		gint x = 0;
#line 494 "../src/page-view.vala"
		x = L;
#line 1818 "page-view.c"
		{
			gboolean _tmp25_ = FALSE;
#line 494 "../src/page-view.vala"
			_tmp25_ = TRUE;
#line 494 "../src/page-view.vala"
			while (TRUE) {
#line 1825 "page-view.c"
				gdouble l = 0.0;
				gdouble r = 0.0;
#line 494 "../src/page-view.vala"
				if (!_tmp25_) {
#line 1830 "page-view.c"
					gint _tmp26_;
#line 494 "../src/page-view.vala"
					_tmp26_ = x;
#line 494 "../src/page-view.vala"
					x = _tmp26_ + 1;
#line 1836 "page-view.c"
				}
#line 494 "../src/page-view.vala"
				_tmp25_ = FALSE;
#line 494 "../src/page-view.vala"
				if (!(x <= R)) {
#line 494 "../src/page-view.vala"
					break;
#line 1844 "page-view.c"
				}
#line 496 "../src/page-view.vala"
				l = (((gdouble) x) * input_width) / output_width;
#line 497 "../src/page-view.vala"
				r = (((gdouble) (x + 1)) * input_width) / output_width;
#line 1850 "page-view.c"
				{
					gint y = 0;
#line 499 "../src/page-view.vala"
					y = T;
#line 1855 "page-view.c"
					{
						gboolean _tmp27_ = FALSE;
#line 499 "../src/page-view.vala"
						_tmp27_ = TRUE;
#line 499 "../src/page-view.vala"
						while (TRUE) {
#line 1862 "page-view.c"
							gdouble t = 0.0;
							gdouble b = 0.0;
							guchar* _tmp29_;
							gint _tmp29__length1;
#line 499 "../src/page-view.vala"
							if (!_tmp27_) {
#line 1869 "page-view.c"
								gint _tmp28_;
#line 499 "../src/page-view.vala"
								_tmp28_ = y;
#line 499 "../src/page-view.vala"
								y = _tmp28_ + 1;
#line 1875 "page-view.c"
							}
#line 499 "../src/page-view.vala"
							_tmp27_ = FALSE;
#line 499 "../src/page-view.vala"
							if (!(y <= B)) {
#line 499 "../src/page-view.vala"
								break;
#line 1883 "page-view.c"
							}
#line 501 "../src/page-view.vala"
							t = (((gdouble) y) * input_height) / output_height;
#line 502 "../src/page-view.vala"
							b = (((gdouble) (y + 1)) * input_height) / output_height;
#line 504 "../src/page-view.vala"
							_tmp29_ = output;
#line 504 "../src/page-view.vala"
							_tmp29__length1 = output_length1;
#line 504 "../src/page-view.vala"
							page_view_set_pixel (self, page, l, r, t, b, _tmp29_, (gint) _tmp29__length1, (output_rowstride * y) + (x * output_n_channels));
#line 1895 "page-view.c"
						}
					}
				}
			}
		}
	}
}

static gint
page_view_get_preview_width (PageView* self)
{
	gint result;
#line 511 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 513 "../src/page-view.vala"
	result = self->priv->width_ - ((self->priv->border_width + self->priv->ruler_width) * 2);
#line 513 "../src/page-view.vala"
	return result;
#line 1914 "page-view.c"
}

static gint
page_view_get_preview_height (PageView* self)
{
	gint result;
#line 516 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 518 "../src/page-view.vala"
	result = self->priv->height_ - ((self->priv->border_width + self->priv->ruler_width) * 2);
#line 518 "../src/page-view.vala"
	return result;
#line 1927 "page-view.c"
}

static void
page_view_update_page_view (PageView* self)
{
	gint old_scan_line = 0;
	gint scan_line = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	ScanDirection left_steps = 0;
	Page* _tmp3_;
	ScanDirection _tmp4_;
	ScanDirection _tmp5_;
	gboolean _tmp6_ = FALSE;
	Page* _tmp8_;
	ScanDirection _tmp9_;
	ScanDirection _tmp10_;
	Page* _tmp11_;
	Page* _tmp12_;
	ScanDirection _tmp13_;
	ScanDirection _tmp14_;
#line 521 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 523 "../src/page-view.vala"
	if (!self->priv->update_image) {
#line 524 "../src/page-view.vala"
		return;
#line 1956 "page-view.c"
	}
#line 526 "../src/page-view.vala"
	old_scan_line = self->priv->scan_line;
#line 527 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 527 "../src/page-view.vala"
	_tmp1_ = page_get_scan_line (_tmp0_);
#line 527 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 527 "../src/page-view.vala"
	scan_line = _tmp2_;
#line 530 "../src/page-view.vala"
	_tmp3_ = self->priv->_page;
#line 530 "../src/page-view.vala"
	_tmp4_ = page_get_scan_direction (_tmp3_);
#line 530 "../src/page-view.vala"
	_tmp5_ = _tmp4_;
#line 530 "../src/page-view.vala"
	left_steps = self->priv->scan_direction - _tmp5_;
#line 531 "../src/page-view.vala"
	if (left_steps != 0) {
#line 1978 "page-view.c"
		GdkPixbuf* _tmp7_;
#line 531 "../src/page-view.vala"
		_tmp7_ = self->priv->image;
#line 531 "../src/page-view.vala"
		_tmp6_ = _tmp7_ != NULL;
#line 1984 "page-view.c"
	} else {
#line 531 "../src/page-view.vala"
		_tmp6_ = FALSE;
#line 1988 "page-view.c"
	}
#line 531 "../src/page-view.vala"
	if (_tmp6_) {
#line 532 "../src/page-view.vala"
		_g_object_unref0 (self->priv->image);
#line 532 "../src/page-view.vala"
		self->priv->image = NULL;
#line 1996 "page-view.c"
	}
#line 533 "../src/page-view.vala"
	_tmp8_ = self->priv->_page;
#line 533 "../src/page-view.vala"
	_tmp9_ = page_get_scan_direction (_tmp8_);
#line 533 "../src/page-view.vala"
	_tmp10_ = _tmp9_;
#line 533 "../src/page-view.vala"
	self->priv->scan_direction = _tmp10_;
#line 535 "../src/page-view.vala"
	_tmp11_ = self->priv->_page;
#line 535 "../src/page-view.vala"
	_tmp12_ = self->priv->_page;
#line 535 "../src/page-view.vala"
	_tmp13_ = page_get_scan_direction (_tmp12_);
#line 535 "../src/page-view.vala"
	_tmp14_ = _tmp13_;
#line 535 "../src/page-view.vala"
	page_view_update_preview (self, _tmp11_, &self->priv->image, page_view_get_preview_width (self), page_view_get_preview_height (self), _tmp14_, old_scan_line, scan_line);
#line 541 "../src/page-view.vala"
	self->priv->update_image = FALSE;
#line 542 "../src/page-view.vala"
	self->priv->scan_line = scan_line;
#line 2020 "page-view.c"
}

static gint
page_view_page_to_screen_x (PageView* self,
                            gint x)
{
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result;
#line 545 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 547 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 547 "../src/page-view.vala"
	_tmp1_ = page_get_width (_tmp0_);
#line 547 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 547 "../src/page-view.vala"
	result = (gint) (((((gdouble) x) * page_view_get_preview_width (self)) / _tmp2_) + 0.5);
#line 547 "../src/page-view.vala"
	return result;
#line 2043 "page-view.c"
}

static gint
page_view_page_to_screen_y (PageView* self,
                            gint y)
{
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result;
#line 550 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 552 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 552 "../src/page-view.vala"
	_tmp1_ = page_get_height (_tmp0_);
#line 552 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 552 "../src/page-view.vala"
	result = (gint) (((((gdouble) y) * page_view_get_preview_height (self)) / _tmp2_) + 0.5);
#line 552 "../src/page-view.vala"
	return result;
#line 2066 "page-view.c"
}

static gint
page_view_screen_to_page_x (PageView* self,
                            gint x)
{
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result;
#line 555 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 557 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 557 "../src/page-view.vala"
	_tmp1_ = page_get_width (_tmp0_);
#line 557 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 557 "../src/page-view.vala"
	result = (gint) (((((gdouble) x) * _tmp2_) / page_view_get_preview_width (self)) + 0.5);
#line 557 "../src/page-view.vala"
	return result;
#line 2089 "page-view.c"
}

static gint
page_view_screen_to_page_y (PageView* self,
                            gint y)
{
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result;
#line 560 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 562 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 562 "../src/page-view.vala"
	_tmp1_ = page_get_height (_tmp0_);
#line 562 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 562 "../src/page-view.vala"
	result = (gint) (((((gdouble) y) * _tmp2_) / page_view_get_preview_height (self)) + 0.5);
#line 562 "../src/page-view.vala"
	return result;
#line 2112 "page-view.c"
}

static CropLocation
page_view_get_crop_location (PageView* self,
                             gint x,
                             gint y)
{
	Page* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gint cx = 0;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint cy = 0;
	Page* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint cw = 0;
	Page* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint ch = 0;
	Page* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint dx = 0;
	gint dy = 0;
	gint dw = 0;
	gint dh = 0;
	gint ix = 0;
	gint iy = 0;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	gchar* name = NULL;
	Page* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	const gchar* _tmp22_;
	gint crop_border = 0;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	CropLocation result;
#line 565 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 567 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 567 "../src/page-view.vala"
	_tmp1_ = page_get_has_crop (_tmp0_);
#line 567 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 567 "../src/page-view.vala"
	if (!_tmp2_) {
#line 568 "../src/page-view.vala"
		result = CROP_LOCATION_NONE;
#line 568 "../src/page-view.vala"
		return result;
#line 2174 "page-view.c"
	}
#line 570 "../src/page-view.vala"
	_tmp3_ = self->priv->_page;
#line 570 "../src/page-view.vala"
	_tmp4_ = page_get_crop_x (_tmp3_);
#line 570 "../src/page-view.vala"
	_tmp5_ = _tmp4_;
#line 570 "../src/page-view.vala"
	cx = _tmp5_;
#line 571 "../src/page-view.vala"
	_tmp6_ = self->priv->_page;
#line 571 "../src/page-view.vala"
	_tmp7_ = page_get_crop_y (_tmp6_);
#line 571 "../src/page-view.vala"
	_tmp8_ = _tmp7_;
#line 571 "../src/page-view.vala"
	cy = _tmp8_;
#line 572 "../src/page-view.vala"
	_tmp9_ = self->priv->_page;
#line 572 "../src/page-view.vala"
	_tmp10_ = page_get_crop_width (_tmp9_);
#line 572 "../src/page-view.vala"
	_tmp11_ = _tmp10_;
#line 572 "../src/page-view.vala"
	cw = _tmp11_;
#line 573 "../src/page-view.vala"
	_tmp12_ = self->priv->_page;
#line 573 "../src/page-view.vala"
	_tmp13_ = page_get_crop_height (_tmp12_);
#line 573 "../src/page-view.vala"
	_tmp14_ = _tmp13_;
#line 573 "../src/page-view.vala"
	ch = _tmp14_;
#line 574 "../src/page-view.vala"
	dx = (page_view_page_to_screen_x (self, cx) + self->priv->border_width) + self->priv->ruler_width;
#line 575 "../src/page-view.vala"
	dy = (page_view_page_to_screen_y (self, cy) + self->priv->border_width) + self->priv->ruler_width;
#line 576 "../src/page-view.vala"
	dw = (page_view_page_to_screen_x (self, cw) + self->priv->border_width) + self->priv->ruler_width;
#line 577 "../src/page-view.vala"
	dh = (page_view_page_to_screen_y (self, ch) + self->priv->border_width) + self->priv->ruler_width;
#line 578 "../src/page-view.vala"
	ix = x - dx;
#line 579 "../src/page-view.vala"
	iy = y - dy;
#line 581 "../src/page-view.vala"
	if (ix < 0) {
#line 581 "../src/page-view.vala"
		_tmp17_ = TRUE;
#line 2224 "page-view.c"
	} else {
#line 581 "../src/page-view.vala"
		_tmp17_ = ix > dw;
#line 2228 "page-view.c"
	}
#line 581 "../src/page-view.vala"
	if (_tmp17_) {
#line 581 "../src/page-view.vala"
		_tmp16_ = TRUE;
#line 2234 "page-view.c"
	} else {
#line 581 "../src/page-view.vala"
		_tmp16_ = iy < 0;
#line 2238 "page-view.c"
	}
#line 581 "../src/page-view.vala"
	if (_tmp16_) {
#line 581 "../src/page-view.vala"
		_tmp15_ = TRUE;
#line 2244 "page-view.c"
	} else {
#line 581 "../src/page-view.vala"
		_tmp15_ = iy > dh;
#line 2248 "page-view.c"
	}
#line 581 "../src/page-view.vala"
	if (_tmp15_) {
#line 582 "../src/page-view.vala"
		result = CROP_LOCATION_NONE;
#line 582 "../src/page-view.vala"
		return result;
#line 2256 "page-view.c"
	}
#line 585 "../src/page-view.vala"
	_tmp18_ = self->priv->_page;
#line 585 "../src/page-view.vala"
	_tmp19_ = page_get_crop_name (_tmp18_);
#line 585 "../src/page-view.vala"
	_tmp20_ = _tmp19_;
#line 585 "../src/page-view.vala"
	_tmp21_ = g_strdup (_tmp20_);
#line 585 "../src/page-view.vala"
	name = _tmp21_;
#line 586 "../src/page-view.vala"
	_tmp22_ = name;
#line 586 "../src/page-view.vala"
	if (_tmp22_ != NULL) {
#line 587 "../src/page-view.vala"
		result = CROP_LOCATION_MIDDLE;
#line 587 "../src/page-view.vala"
		_g_free0 (name);
#line 587 "../src/page-view.vala"
		return result;
#line 2278 "page-view.c"
	}
#line 590 "../src/page-view.vala"
	crop_border = 20;
#line 591 "../src/page-view.vala"
	if (dw < (crop_border * 3)) {
#line 592 "../src/page-view.vala"
		crop_border = dw / 3;
#line 2286 "page-view.c"
	}
#line 593 "../src/page-view.vala"
	if (dh < (crop_border * 3)) {
#line 594 "../src/page-view.vala"
		crop_border = dh / 3;
#line 2292 "page-view.c"
	}
#line 597 "../src/page-view.vala"
	if (ix < crop_border) {
#line 597 "../src/page-view.vala"
		_tmp23_ = iy < crop_border;
#line 2298 "page-view.c"
	} else {
#line 597 "../src/page-view.vala"
		_tmp23_ = FALSE;
#line 2302 "page-view.c"
	}
#line 597 "../src/page-view.vala"
	if (_tmp23_) {
#line 598 "../src/page-view.vala"
		result = CROP_LOCATION_TOP_LEFT;
#line 598 "../src/page-view.vala"
		_g_free0 (name);
#line 598 "../src/page-view.vala"
		return result;
#line 2312 "page-view.c"
	}
#line 600 "../src/page-view.vala"
	if (ix > (dw - crop_border)) {
#line 600 "../src/page-view.vala"
		_tmp24_ = iy < crop_border;
#line 2318 "page-view.c"
	} else {
#line 600 "../src/page-view.vala"
		_tmp24_ = FALSE;
#line 2322 "page-view.c"
	}
#line 600 "../src/page-view.vala"
	if (_tmp24_) {
#line 601 "../src/page-view.vala"
		result = CROP_LOCATION_TOP_RIGHT;
#line 601 "../src/page-view.vala"
		_g_free0 (name);
#line 601 "../src/page-view.vala"
		return result;
#line 2332 "page-view.c"
	}
#line 603 "../src/page-view.vala"
	if (ix < crop_border) {
#line 603 "../src/page-view.vala"
		_tmp25_ = iy > (dh - crop_border);
#line 2338 "page-view.c"
	} else {
#line 603 "../src/page-view.vala"
		_tmp25_ = FALSE;
#line 2342 "page-view.c"
	}
#line 603 "../src/page-view.vala"
	if (_tmp25_) {
#line 604 "../src/page-view.vala"
		result = CROP_LOCATION_BOTTOM_LEFT;
#line 604 "../src/page-view.vala"
		_g_free0 (name);
#line 604 "../src/page-view.vala"
		return result;
#line 2352 "page-view.c"
	}
#line 606 "../src/page-view.vala"
	if (ix > (dw - crop_border)) {
#line 606 "../src/page-view.vala"
		_tmp26_ = iy > (dh - crop_border);
#line 2358 "page-view.c"
	} else {
#line 606 "../src/page-view.vala"
		_tmp26_ = FALSE;
#line 2362 "page-view.c"
	}
#line 606 "../src/page-view.vala"
	if (_tmp26_) {
#line 607 "../src/page-view.vala"
		result = CROP_LOCATION_BOTTOM_RIGHT;
#line 607 "../src/page-view.vala"
		_g_free0 (name);
#line 607 "../src/page-view.vala"
		return result;
#line 2372 "page-view.c"
	}
#line 610 "../src/page-view.vala"
	if (ix < crop_border) {
#line 611 "../src/page-view.vala"
		result = CROP_LOCATION_LEFT;
#line 611 "../src/page-view.vala"
		_g_free0 (name);
#line 611 "../src/page-view.vala"
		return result;
#line 2382 "page-view.c"
	}
#line 613 "../src/page-view.vala"
	if (ix > (dw - crop_border)) {
#line 614 "../src/page-view.vala"
		result = CROP_LOCATION_RIGHT;
#line 614 "../src/page-view.vala"
		_g_free0 (name);
#line 614 "../src/page-view.vala"
		return result;
#line 2392 "page-view.c"
	}
#line 616 "../src/page-view.vala"
	if (iy < crop_border) {
#line 617 "../src/page-view.vala"
		result = CROP_LOCATION_TOP;
#line 617 "../src/page-view.vala"
		_g_free0 (name);
#line 617 "../src/page-view.vala"
		return result;
#line 2402 "page-view.c"
	}
#line 619 "../src/page-view.vala"
	if (iy > (dh - crop_border)) {
#line 620 "../src/page-view.vala"
		result = CROP_LOCATION_BOTTOM;
#line 620 "../src/page-view.vala"
		_g_free0 (name);
#line 620 "../src/page-view.vala"
		return result;
#line 2412 "page-view.c"
	}
#line 623 "../src/page-view.vala"
	result = CROP_LOCATION_MIDDLE;
#line 623 "../src/page-view.vala"
	_g_free0 (name);
#line 623 "../src/page-view.vala"
	return result;
#line 2420 "page-view.c"
}

void
page_view_button_press (PageView* self,
                        gint x,
                        gint y)
{
	CropLocation location = 0;
#line 626 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 629 "../src/page-view.vala"
	location = page_view_get_crop_location (self, x, y);
#line 630 "../src/page-view.vala"
	if (location != CROP_LOCATION_NONE) {
#line 2435 "page-view.c"
		Page* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		Page* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		Page* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		Page* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
#line 632 "../src/page-view.vala"
		self->priv->crop_location = location;
#line 633 "../src/page-view.vala"
		self->priv->selected_crop_px = (gdouble) x;
#line 634 "../src/page-view.vala"
		self->priv->selected_crop_py = (gdouble) y;
#line 635 "../src/page-view.vala"
		_tmp0_ = self->priv->_page;
#line 635 "../src/page-view.vala"
		_tmp1_ = page_get_crop_x (_tmp0_);
#line 635 "../src/page-view.vala"
		_tmp2_ = _tmp1_;
#line 635 "../src/page-view.vala"
		self->priv->selected_crop_x = _tmp2_;
#line 636 "../src/page-view.vala"
		_tmp3_ = self->priv->_page;
#line 636 "../src/page-view.vala"
		_tmp4_ = page_get_crop_y (_tmp3_);
#line 636 "../src/page-view.vala"
		_tmp5_ = _tmp4_;
#line 636 "../src/page-view.vala"
		self->priv->selected_crop_y = _tmp5_;
#line 637 "../src/page-view.vala"
		_tmp6_ = self->priv->_page;
#line 637 "../src/page-view.vala"
		_tmp7_ = page_get_crop_width (_tmp6_);
#line 637 "../src/page-view.vala"
		_tmp8_ = _tmp7_;
#line 637 "../src/page-view.vala"
		self->priv->selected_crop_w = _tmp8_;
#line 638 "../src/page-view.vala"
		_tmp9_ = self->priv->_page;
#line 638 "../src/page-view.vala"
		_tmp10_ = page_get_crop_height (_tmp9_);
#line 638 "../src/page-view.vala"
		_tmp11_ = _tmp10_;
#line 638 "../src/page-view.vala"
		self->priv->selected_crop_h = _tmp11_;
#line 2486 "page-view.c"
	}
}

void
page_view_motion (PageView* self,
                  gint x,
                  gint y)
{
	CropLocation location = 0;
	GdkCursorType cursor = 0;
	gint pw = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint ph = 0;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint cw = 0;
	Page* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint ch = 0;
	Page* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint dx = 0;
	gint dy = 0;
	gint new_x = 0;
	gint new_y = 0;
	gint new_w = 0;
	gint new_h = 0;
	gint min_size = 0;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp27_ = FALSE;
	Page* _tmp28_;
	gboolean _tmp29_ = FALSE;
#line 642 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 644 "../src/page-view.vala"
	location = page_view_get_crop_location (self, x, y);
#line 646 "../src/page-view.vala"
	switch (location) {
#line 646 "../src/page-view.vala"
		case CROP_LOCATION_MIDDLE:
#line 2546 "page-view.c"
		{
#line 649 "../src/page-view.vala"
			cursor = GDK_HAND1;
#line 650 "../src/page-view.vala"
			break;
#line 2552 "page-view.c"
		}
#line 646 "../src/page-view.vala"
		case CROP_LOCATION_TOP:
#line 2556 "page-view.c"
		{
#line 652 "../src/page-view.vala"
			cursor = GDK_TOP_SIDE;
#line 653 "../src/page-view.vala"
			break;
#line 2562 "page-view.c"
		}
#line 646 "../src/page-view.vala"
		case CROP_LOCATION_BOTTOM:
#line 2566 "page-view.c"
		{
#line 655 "../src/page-view.vala"
			cursor = GDK_BOTTOM_SIDE;
#line 656 "../src/page-view.vala"
			break;
#line 2572 "page-view.c"
		}
#line 646 "../src/page-view.vala"
		case CROP_LOCATION_LEFT:
#line 2576 "page-view.c"
		{
#line 658 "../src/page-view.vala"
			cursor = GDK_LEFT_SIDE;
#line 659 "../src/page-view.vala"
			break;
#line 2582 "page-view.c"
		}
#line 646 "../src/page-view.vala"
		case CROP_LOCATION_RIGHT:
#line 2586 "page-view.c"
		{
#line 661 "../src/page-view.vala"
			cursor = GDK_RIGHT_SIDE;
#line 662 "../src/page-view.vala"
			break;
#line 2592 "page-view.c"
		}
#line 646 "../src/page-view.vala"
		case CROP_LOCATION_TOP_LEFT:
#line 2596 "page-view.c"
		{
#line 664 "../src/page-view.vala"
			cursor = GDK_TOP_LEFT_CORNER;
#line 665 "../src/page-view.vala"
			break;
#line 2602 "page-view.c"
		}
#line 646 "../src/page-view.vala"
		case CROP_LOCATION_TOP_RIGHT:
#line 2606 "page-view.c"
		{
#line 667 "../src/page-view.vala"
			cursor = GDK_TOP_RIGHT_CORNER;
#line 668 "../src/page-view.vala"
			break;
#line 2612 "page-view.c"
		}
#line 646 "../src/page-view.vala"
		case CROP_LOCATION_BOTTOM_LEFT:
#line 2616 "page-view.c"
		{
#line 670 "../src/page-view.vala"
			cursor = GDK_BOTTOM_LEFT_CORNER;
#line 671 "../src/page-view.vala"
			break;
#line 2622 "page-view.c"
		}
#line 646 "../src/page-view.vala"
		case CROP_LOCATION_BOTTOM_RIGHT:
#line 2626 "page-view.c"
		{
#line 673 "../src/page-view.vala"
			cursor = GDK_BOTTOM_RIGHT_CORNER;
#line 674 "../src/page-view.vala"
			break;
#line 2632 "page-view.c"
		}
		default:
		{
#line 676 "../src/page-view.vala"
			cursor = GDK_ARROW;
#line 677 "../src/page-view.vala"
			break;
#line 2640 "page-view.c"
		}
	}
#line 680 "../src/page-view.vala"
	if (self->priv->crop_location == CROP_LOCATION_NONE) {
#line 682 "../src/page-view.vala"
		page_view_set_cursor (self, cursor);
#line 683 "../src/page-view.vala"
		return;
#line 2649 "page-view.c"
	}
#line 687 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 687 "../src/page-view.vala"
	_tmp1_ = page_get_width (_tmp0_);
#line 687 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 687 "../src/page-view.vala"
	pw = _tmp2_;
#line 688 "../src/page-view.vala"
	_tmp3_ = self->priv->_page;
#line 688 "../src/page-view.vala"
	_tmp4_ = page_get_height (_tmp3_);
#line 688 "../src/page-view.vala"
	_tmp5_ = _tmp4_;
#line 688 "../src/page-view.vala"
	ph = _tmp5_;
#line 689 "../src/page-view.vala"
	_tmp6_ = self->priv->_page;
#line 689 "../src/page-view.vala"
	_tmp7_ = page_get_crop_width (_tmp6_);
#line 689 "../src/page-view.vala"
	_tmp8_ = _tmp7_;
#line 689 "../src/page-view.vala"
	cw = _tmp8_;
#line 690 "../src/page-view.vala"
	_tmp9_ = self->priv->_page;
#line 690 "../src/page-view.vala"
	_tmp10_ = page_get_crop_height (_tmp9_);
#line 690 "../src/page-view.vala"
	_tmp11_ = _tmp10_;
#line 690 "../src/page-view.vala"
	ch = _tmp11_;
#line 692 "../src/page-view.vala"
	dx = page_view_screen_to_page_x (self, x - ((gint) self->priv->selected_crop_px));
#line 693 "../src/page-view.vala"
	dy = page_view_screen_to_page_y (self, y - ((gint) self->priv->selected_crop_py));
#line 695 "../src/page-view.vala"
	new_x = self->priv->selected_crop_x;
#line 696 "../src/page-view.vala"
	new_y = self->priv->selected_crop_y;
#line 697 "../src/page-view.vala"
	new_w = self->priv->selected_crop_w;
#line 698 "../src/page-view.vala"
	new_h = self->priv->selected_crop_h;
#line 701 "../src/page-view.vala"
	min_size = page_view_screen_to_page_x (self, 15);
#line 702 "../src/page-view.vala"
	if (self->priv->crop_location == CROP_LOCATION_TOP_LEFT) {
#line 702 "../src/page-view.vala"
		_tmp13_ = TRUE;
#line 2701 "page-view.c"
	} else {
#line 703 "../src/page-view.vala"
		_tmp13_ = self->priv->crop_location == CROP_LOCATION_LEFT;
#line 2705 "page-view.c"
	}
#line 702 "../src/page-view.vala"
	if (_tmp13_) {
#line 702 "../src/page-view.vala"
		_tmp12_ = TRUE;
#line 2711 "page-view.c"
	} else {
#line 704 "../src/page-view.vala"
		_tmp12_ = self->priv->crop_location == CROP_LOCATION_BOTTOM_LEFT;
#line 2715 "page-view.c"
	}
#line 702 "../src/page-view.vala"
	if (_tmp12_) {
#line 706 "../src/page-view.vala"
		if (dx > (new_w - min_size)) {
#line 707 "../src/page-view.vala"
			dx = new_w - min_size;
#line 2723 "page-view.c"
		}
#line 708 "../src/page-view.vala"
		if ((new_x + dx) < 0) {
#line 709 "../src/page-view.vala"
			dx = -new_x;
#line 2729 "page-view.c"
		}
	}
#line 711 "../src/page-view.vala"
	if (self->priv->crop_location == CROP_LOCATION_TOP_LEFT) {
#line 711 "../src/page-view.vala"
		_tmp15_ = TRUE;
#line 2736 "page-view.c"
	} else {
#line 712 "../src/page-view.vala"
		_tmp15_ = self->priv->crop_location == CROP_LOCATION_TOP;
#line 2740 "page-view.c"
	}
#line 711 "../src/page-view.vala"
	if (_tmp15_) {
#line 711 "../src/page-view.vala"
		_tmp14_ = TRUE;
#line 2746 "page-view.c"
	} else {
#line 713 "../src/page-view.vala"
		_tmp14_ = self->priv->crop_location == CROP_LOCATION_TOP_RIGHT;
#line 2750 "page-view.c"
	}
#line 711 "../src/page-view.vala"
	if (_tmp14_) {
#line 715 "../src/page-view.vala"
		if (dy > (new_h - min_size)) {
#line 716 "../src/page-view.vala"
			dy = new_h - min_size;
#line 2758 "page-view.c"
		}
#line 717 "../src/page-view.vala"
		if ((new_y + dy) < 0) {
#line 718 "../src/page-view.vala"
			dy = -new_y;
#line 2764 "page-view.c"
		}
	}
#line 721 "../src/page-view.vala"
	if (self->priv->crop_location == CROP_LOCATION_TOP_RIGHT) {
#line 721 "../src/page-view.vala"
		_tmp17_ = TRUE;
#line 2771 "page-view.c"
	} else {
#line 722 "../src/page-view.vala"
		_tmp17_ = self->priv->crop_location == CROP_LOCATION_RIGHT;
#line 2775 "page-view.c"
	}
#line 721 "../src/page-view.vala"
	if (_tmp17_) {
#line 721 "../src/page-view.vala"
		_tmp16_ = TRUE;
#line 2781 "page-view.c"
	} else {
#line 723 "../src/page-view.vala"
		_tmp16_ = self->priv->crop_location == CROP_LOCATION_BOTTOM_RIGHT;
#line 2785 "page-view.c"
	}
#line 721 "../src/page-view.vala"
	if (_tmp16_) {
#line 725 "../src/page-view.vala"
		if (dx < (min_size - new_w)) {
#line 726 "../src/page-view.vala"
			dx = min_size - new_w;
#line 2793 "page-view.c"
		}
#line 727 "../src/page-view.vala"
		if (((new_x + new_w) + dx) > pw) {
#line 728 "../src/page-view.vala"
			dx = (pw - new_x) - new_w;
#line 2799 "page-view.c"
		}
	}
#line 730 "../src/page-view.vala"
	if (self->priv->crop_location == CROP_LOCATION_BOTTOM_LEFT) {
#line 730 "../src/page-view.vala"
		_tmp19_ = TRUE;
#line 2806 "page-view.c"
	} else {
#line 731 "../src/page-view.vala"
		_tmp19_ = self->priv->crop_location == CROP_LOCATION_BOTTOM;
#line 2810 "page-view.c"
	}
#line 730 "../src/page-view.vala"
	if (_tmp19_) {
#line 730 "../src/page-view.vala"
		_tmp18_ = TRUE;
#line 2816 "page-view.c"
	} else {
#line 732 "../src/page-view.vala"
		_tmp18_ = self->priv->crop_location == CROP_LOCATION_BOTTOM_RIGHT;
#line 2820 "page-view.c"
	}
#line 730 "../src/page-view.vala"
	if (_tmp18_) {
#line 734 "../src/page-view.vala"
		if (dy < (min_size - new_h)) {
#line 735 "../src/page-view.vala"
			dy = min_size - new_h;
#line 2828 "page-view.c"
		}
#line 736 "../src/page-view.vala"
		if (((new_y + new_h) + dy) > ph) {
#line 737 "../src/page-view.vala"
			dy = (ph - new_y) - new_h;
#line 2834 "page-view.c"
		}
	}
#line 739 "../src/page-view.vala"
	if (self->priv->crop_location == CROP_LOCATION_MIDDLE) {
#line 741 "../src/page-view.vala"
		if (((new_x + dx) + new_w) > pw) {
#line 742 "../src/page-view.vala"
			dx = (pw - new_x) - new_w;
#line 2843 "page-view.c"
		}
#line 743 "../src/page-view.vala"
		if ((new_x + dx) < 0) {
#line 744 "../src/page-view.vala"
			dx = -new_x;
#line 2849 "page-view.c"
		}
#line 745 "../src/page-view.vala"
		if (((new_y + dy) + new_h) > ph) {
#line 746 "../src/page-view.vala"
			dy = (ph - new_y) - new_h;
#line 2855 "page-view.c"
		}
#line 747 "../src/page-view.vala"
		if ((new_y + dy) < 0) {
#line 748 "../src/page-view.vala"
			dy = -new_y;
#line 2861 "page-view.c"
		}
	}
#line 752 "../src/page-view.vala"
	if (self->priv->crop_location == CROP_LOCATION_MIDDLE) {
#line 754 "../src/page-view.vala"
		new_x += dx;
#line 755 "../src/page-view.vala"
		new_y += dy;
#line 2870 "page-view.c"
	}
#line 757 "../src/page-view.vala"
	if (self->priv->crop_location == CROP_LOCATION_TOP_LEFT) {
#line 757 "../src/page-view.vala"
		_tmp21_ = TRUE;
#line 2876 "page-view.c"
	} else {
#line 758 "../src/page-view.vala"
		_tmp21_ = self->priv->crop_location == CROP_LOCATION_LEFT;
#line 2880 "page-view.c"
	}
#line 757 "../src/page-view.vala"
	if (_tmp21_) {
#line 757 "../src/page-view.vala"
		_tmp20_ = TRUE;
#line 2886 "page-view.c"
	} else {
#line 759 "../src/page-view.vala"
		_tmp20_ = self->priv->crop_location == CROP_LOCATION_BOTTOM_LEFT;
#line 2890 "page-view.c"
	}
#line 757 "../src/page-view.vala"
	if (_tmp20_) {
#line 761 "../src/page-view.vala"
		new_x += dx;
#line 762 "../src/page-view.vala"
		new_w -= dx;
#line 2898 "page-view.c"
	}
#line 764 "../src/page-view.vala"
	if (self->priv->crop_location == CROP_LOCATION_TOP_LEFT) {
#line 764 "../src/page-view.vala"
		_tmp23_ = TRUE;
#line 2904 "page-view.c"
	} else {
#line 765 "../src/page-view.vala"
		_tmp23_ = self->priv->crop_location == CROP_LOCATION_TOP;
#line 2908 "page-view.c"
	}
#line 764 "../src/page-view.vala"
	if (_tmp23_) {
#line 764 "../src/page-view.vala"
		_tmp22_ = TRUE;
#line 2914 "page-view.c"
	} else {
#line 766 "../src/page-view.vala"
		_tmp22_ = self->priv->crop_location == CROP_LOCATION_TOP_RIGHT;
#line 2918 "page-view.c"
	}
#line 764 "../src/page-view.vala"
	if (_tmp22_) {
#line 768 "../src/page-view.vala"
		new_y += dy;
#line 769 "../src/page-view.vala"
		new_h -= dy;
#line 2926 "page-view.c"
	}
#line 772 "../src/page-view.vala"
	if (self->priv->crop_location == CROP_LOCATION_TOP_RIGHT) {
#line 772 "../src/page-view.vala"
		_tmp25_ = TRUE;
#line 2932 "page-view.c"
	} else {
#line 773 "../src/page-view.vala"
		_tmp25_ = self->priv->crop_location == CROP_LOCATION_RIGHT;
#line 2936 "page-view.c"
	}
#line 772 "../src/page-view.vala"
	if (_tmp25_) {
#line 772 "../src/page-view.vala"
		_tmp24_ = TRUE;
#line 2942 "page-view.c"
	} else {
#line 774 "../src/page-view.vala"
		_tmp24_ = self->priv->crop_location == CROP_LOCATION_BOTTOM_RIGHT;
#line 2946 "page-view.c"
	}
#line 772 "../src/page-view.vala"
	if (_tmp24_) {
#line 775 "../src/page-view.vala"
		new_w += dx;
#line 2952 "page-view.c"
	}
#line 776 "../src/page-view.vala"
	if (self->priv->crop_location == CROP_LOCATION_BOTTOM_LEFT) {
#line 776 "../src/page-view.vala"
		_tmp27_ = TRUE;
#line 2958 "page-view.c"
	} else {
#line 777 "../src/page-view.vala"
		_tmp27_ = self->priv->crop_location == CROP_LOCATION_BOTTOM;
#line 2962 "page-view.c"
	}
#line 776 "../src/page-view.vala"
	if (_tmp27_) {
#line 776 "../src/page-view.vala"
		_tmp26_ = TRUE;
#line 2968 "page-view.c"
	} else {
#line 778 "../src/page-view.vala"
		_tmp26_ = self->priv->crop_location == CROP_LOCATION_BOTTOM_RIGHT;
#line 2972 "page-view.c"
	}
#line 776 "../src/page-view.vala"
	if (_tmp26_) {
#line 779 "../src/page-view.vala"
		new_h += dy;
#line 2978 "page-view.c"
	}
#line 781 "../src/page-view.vala"
	_tmp28_ = self->priv->_page;
#line 781 "../src/page-view.vala"
	page_move_crop (_tmp28_, new_x, new_y);
#line 784 "../src/page-view.vala"
	if (new_w != cw) {
#line 784 "../src/page-view.vala"
		_tmp29_ = TRUE;
#line 2988 "page-view.c"
	} else {
#line 784 "../src/page-view.vala"
		_tmp29_ = new_h != ch;
#line 2992 "page-view.c"
	}
#line 784 "../src/page-view.vala"
	if (_tmp29_) {
#line 2996 "page-view.c"
		Page* _tmp30_;
#line 785 "../src/page-view.vala"
		_tmp30_ = self->priv->_page;
#line 785 "../src/page-view.vala"
		page_set_custom_crop (_tmp30_, new_w, new_h);
#line 3002 "page-view.c"
	}
}

void
page_view_button_release (PageView* self,
                          gint x,
                          gint y)
{
#line 788 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 791 "../src/page-view.vala"
	self->priv->crop_location = CROP_LOCATION_NONE;
#line 792 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 3017 "page-view.c"
}

static gboolean
page_view_animation_cb (PageView* self)
{
	gboolean result;
#line 795 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 797 "../src/page-view.vala"
	self->priv->animate_segment = (self->priv->animate_segment + 1) % self->priv->animate_n_segments;
#line 798 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 799 "../src/page-view.vala"
	result = TRUE;
#line 799 "../src/page-view.vala"
	return result;
#line 3034 "page-view.c"
}

static gboolean
_page_view_animation_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = page_view_animation_cb ((PageView*) self);
#line 815 "../src/page-view.vala"
	return result;
#line 3044 "page-view.c"
}

static void
page_view_update_animation (PageView* self)
{
	gboolean animate = FALSE;
	gboolean is_animating = FALSE;
	gboolean _tmp0_ = FALSE;
	Page* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 802 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 806 "../src/page-view.vala"
	_tmp1_ = self->priv->_page;
#line 806 "../src/page-view.vala"
	_tmp2_ = page_get_is_scanning (_tmp1_);
#line 806 "../src/page-view.vala"
	_tmp3_ = _tmp2_;
#line 806 "../src/page-view.vala"
	if (_tmp3_) {
#line 3066 "page-view.c"
		Page* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 806 "../src/page-view.vala"
		_tmp4_ = self->priv->_page;
#line 806 "../src/page-view.vala"
		_tmp5_ = page_get_has_data (_tmp4_);
#line 806 "../src/page-view.vala"
		_tmp6_ = _tmp5_;
#line 806 "../src/page-view.vala"
		_tmp0_ = !_tmp6_;
#line 3078 "page-view.c"
	} else {
#line 806 "../src/page-view.vala"
		_tmp0_ = FALSE;
#line 3082 "page-view.c"
	}
#line 806 "../src/page-view.vala"
	animate = _tmp0_;
#line 807 "../src/page-view.vala"
	is_animating = self->priv->animate_timeout != ((guint) 0);
#line 808 "../src/page-view.vala"
	if (animate == is_animating) {
#line 809 "../src/page-view.vala"
		return;
#line 3092 "page-view.c"
	}
#line 811 "../src/page-view.vala"
	if (animate) {
#line 813 "../src/page-view.vala"
		self->priv->animate_segment = 0;
#line 814 "../src/page-view.vala"
		if (self->priv->animate_timeout == ((guint) 0)) {
#line 815 "../src/page-view.vala"
			self->priv->animate_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 150, _page_view_animation_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 3102 "page-view.c"
		}
	} else {
#line 819 "../src/page-view.vala"
		if (self->priv->animate_timeout != ((guint) 0)) {
#line 820 "../src/page-view.vala"
			g_source_remove (self->priv->animate_timeout);
#line 3109 "page-view.c"
		}
#line 821 "../src/page-view.vala"
		self->priv->animate_timeout = (guint) 0;
#line 3113 "page-view.c"
	}
}

void
page_view_render (PageView* self,
                  cairo_t* context,
                  GdkRGBA* ruler_color)
{
	gint w = 0;
	gint h = 0;
	gint _tmp0_;
	gint _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkRGBA _tmp3_;
	gint ruler_tick = 0;
	gdouble line = 0.0;
	gint big_ruler_tick = 0;
	gboolean _tmp16_ = FALSE;
	Page* _tmp17_;
	gboolean _tmp18_;
	gboolean _tmp19_;
	Page* _tmp29_;
	gboolean _tmp30_;
	gboolean _tmp31_;
#line 828 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 828 "../src/page-view.vala"
	g_return_if_fail (context != NULL);
#line 828 "../src/page-view.vala"
	g_return_if_fail (ruler_color != NULL);
#line 830 "../src/page-view.vala"
	page_view_update_animation (self);
#line 831 "../src/page-view.vala"
	page_view_update_page_view (self);
#line 833 "../src/page-view.vala"
	w = page_view_get_preview_width (self);
#line 834 "../src/page-view.vala"
	h = page_view_get_preview_height (self);
#line 836 "../src/page-view.vala"
	cairo_set_line_width (context, (gdouble) 1);
#line 837 "../src/page-view.vala"
	_tmp0_ = self->priv->_x_offset;
#line 837 "../src/page-view.vala"
	_tmp1_ = self->priv->_y_offset;
#line 837 "../src/page-view.vala"
	cairo_translate (context, (gdouble) _tmp0_, (gdouble) _tmp1_);
#line 840 "../src/page-view.vala"
	cairo_translate (context, (gdouble) (self->priv->border_width + self->priv->ruler_width), (gdouble) (self->priv->border_width + self->priv->ruler_width));
#line 841 "../src/page-view.vala"
	_tmp2_ = self->priv->image;
#line 841 "../src/page-view.vala"
	gdk_cairo_set_source_pixbuf (context, _tmp2_, (gdouble) 0, (gdouble) 0);
#line 842 "../src/page-view.vala"
	cairo_paint (context);
#line 845 "../src/page-view.vala"
	_tmp3_ = *ruler_color;
#line 845 "../src/page-view.vala"
	gdk_cairo_set_source_rgba (context, &_tmp3_);
#line 846 "../src/page-view.vala"
	cairo_set_line_width (context, (gdouble) self->priv->border_width);
#line 848 "../src/page-view.vala"
	cairo_rectangle (context, (gdouble) 0, 0.0, (gdouble) w, (gdouble) h);
#line 852 "../src/page-view.vala"
	cairo_stroke (context);
#line 855 "../src/page-view.vala"
	cairo_set_line_width (context, (gdouble) 1);
#line 856 "../src/page-view.vala"
	ruler_tick = 0;
#line 857 "../src/page-view.vala"
	line = 0.0;
#line 858 "../src/page-view.vala"
	big_ruler_tick = 5;
#line 860 "../src/page-view.vala"
	while (TRUE) {
#line 3188 "page-view.c"
		Page* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		Page* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
#line 860 "../src/page-view.vala"
		_tmp4_ = self->priv->_page;
#line 860 "../src/page-view.vala"
		_tmp5_ = page_get_width (_tmp4_);
#line 860 "../src/page-view.vala"
		_tmp6_ = _tmp5_;
#line 860 "../src/page-view.vala"
		if (!(ruler_tick <= _tmp6_)) {
#line 860 "../src/page-view.vala"
			break;
#line 3205 "page-view.c"
		}
#line 862 "../src/page-view.vala"
		line = page_view_page_to_screen_x (self, ruler_tick) + 0.5;
#line 863 "../src/page-view.vala"
		if (big_ruler_tick == 5) {
#line 865 "../src/page-view.vala"
			cairo_move_to (context, line, (gdouble) 0);
#line 866 "../src/page-view.vala"
			cairo_line_to (context, line, (gdouble) (-self->priv->ruler_width));
#line 867 "../src/page-view.vala"
			cairo_move_to (context, line, (gdouble) h);
#line 868 "../src/page-view.vala"
			cairo_line_to (context, line, (gdouble) (h + self->priv->ruler_width));
#line 869 "../src/page-view.vala"
			big_ruler_tick = 0;
#line 3221 "page-view.c"
		} else {
#line 873 "../src/page-view.vala"
			cairo_move_to (context, line, (gdouble) -2);
#line 874 "../src/page-view.vala"
			cairo_line_to (context, line, (gdouble) -5);
#line 875 "../src/page-view.vala"
			cairo_move_to (context, line, (gdouble) (h + 2));
#line 876 "../src/page-view.vala"
			cairo_line_to (context, line, (gdouble) (h + 5));
#line 3231 "page-view.c"
		}
#line 878 "../src/page-view.vala"
		_tmp7_ = self->priv->_page;
#line 878 "../src/page-view.vala"
		_tmp8_ = page_get_dpi (_tmp7_);
#line 878 "../src/page-view.vala"
		_tmp9_ = _tmp8_;
#line 878 "../src/page-view.vala"
		ruler_tick = ruler_tick + (_tmp9_ / 5);
#line 879 "../src/page-view.vala"
		big_ruler_tick = big_ruler_tick + 1;
#line 3243 "page-view.c"
	}
#line 881 "../src/page-view.vala"
	cairo_stroke (context);
#line 884 "../src/page-view.vala"
	ruler_tick = 0;
#line 885 "../src/page-view.vala"
	line = 0.0;
#line 886 "../src/page-view.vala"
	big_ruler_tick = 5;
#line 887 "../src/page-view.vala"
	while (TRUE) {
#line 3255 "page-view.c"
		Page* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		Page* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
#line 887 "../src/page-view.vala"
		_tmp10_ = self->priv->_page;
#line 887 "../src/page-view.vala"
		_tmp11_ = page_get_height (_tmp10_);
#line 887 "../src/page-view.vala"
		_tmp12_ = _tmp11_;
#line 887 "../src/page-view.vala"
		if (!(ruler_tick <= _tmp12_)) {
#line 887 "../src/page-view.vala"
			break;
#line 3272 "page-view.c"
		}
#line 889 "../src/page-view.vala"
		line = page_view_page_to_screen_y (self, ruler_tick) + 0.5;
#line 891 "../src/page-view.vala"
		if (big_ruler_tick == 5) {
#line 893 "../src/page-view.vala"
			cairo_move_to (context, (gdouble) 0, line);
#line 894 "../src/page-view.vala"
			cairo_line_to (context, (gdouble) (-self->priv->ruler_width), line);
#line 896 "../src/page-view.vala"
			cairo_move_to (context, (gdouble) w, line);
#line 897 "../src/page-view.vala"
			cairo_line_to (context, (gdouble) (w + self->priv->ruler_width), line);
#line 898 "../src/page-view.vala"
			big_ruler_tick = 0;
#line 3288 "page-view.c"
		} else {
#line 902 "../src/page-view.vala"
			cairo_move_to (context, (gdouble) -2, line);
#line 903 "../src/page-view.vala"
			cairo_line_to (context, (gdouble) -5, line);
#line 905 "../src/page-view.vala"
			cairo_move_to (context, (gdouble) (w + 2), line);
#line 906 "../src/page-view.vala"
			cairo_line_to (context, (gdouble) (w + 5), line);
#line 3298 "page-view.c"
		}
#line 908 "../src/page-view.vala"
		_tmp13_ = self->priv->_page;
#line 908 "../src/page-view.vala"
		_tmp14_ = page_get_dpi (_tmp13_);
#line 908 "../src/page-view.vala"
		_tmp15_ = _tmp14_;
#line 908 "../src/page-view.vala"
		ruler_tick = ruler_tick + (_tmp15_ / 5);
#line 909 "../src/page-view.vala"
		big_ruler_tick = big_ruler_tick + 1;
#line 3310 "page-view.c"
	}
#line 911 "../src/page-view.vala"
	cairo_stroke (context);
#line 914 "../src/page-view.vala"
	_tmp17_ = self->priv->_page;
#line 914 "../src/page-view.vala"
	_tmp18_ = page_get_is_scanning (_tmp17_);
#line 914 "../src/page-view.vala"
	_tmp19_ = _tmp18_;
#line 914 "../src/page-view.vala"
	if (_tmp19_) {
#line 3322 "page-view.c"
		Page* _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
#line 914 "../src/page-view.vala"
		_tmp20_ = self->priv->_page;
#line 914 "../src/page-view.vala"
		_tmp21_ = page_get_scan_line (_tmp20_);
#line 914 "../src/page-view.vala"
		_tmp22_ = _tmp21_;
#line 914 "../src/page-view.vala"
		_tmp16_ = _tmp22_ > 0;
#line 3334 "page-view.c"
	} else {
#line 914 "../src/page-view.vala"
		_tmp16_ = FALSE;
#line 3338 "page-view.c"
	}
#line 914 "../src/page-view.vala"
	if (_tmp16_) {
#line 3342 "page-view.c"
		gint scan_line = 0;
		Page* _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		gdouble s = 0.0;
		gdouble x1 = 0.0;
		gdouble y1 = 0.0;
		gdouble x2 = 0.0;
		gdouble y2 = 0.0;
		Page* _tmp26_;
		ScanDirection _tmp27_;
		ScanDirection _tmp28_;
#line 916 "../src/page-view.vala"
		_tmp23_ = self->priv->_page;
#line 916 "../src/page-view.vala"
		_tmp24_ = page_get_scan_line (_tmp23_);
#line 916 "../src/page-view.vala"
		_tmp25_ = _tmp24_;
#line 916 "../src/page-view.vala"
		scan_line = _tmp25_;
#line 920 "../src/page-view.vala"
		_tmp26_ = self->priv->_page;
#line 920 "../src/page-view.vala"
		_tmp27_ = page_get_scan_direction (_tmp26_);
#line 920 "../src/page-view.vala"
		_tmp28_ = _tmp27_;
#line 920 "../src/page-view.vala"
		switch (_tmp28_) {
#line 920 "../src/page-view.vala"
			case SCAN_DIRECTION_TOP_TO_BOTTOM:
#line 3373 "page-view.c"
			{
#line 923 "../src/page-view.vala"
				s = (gdouble) page_view_page_to_screen_y (self, scan_line);
#line 924 "../src/page-view.vala"
				x1 = (gdouble) 0;
#line 924 "../src/page-view.vala"
				y1 = s + 0.5;
#line 925 "../src/page-view.vala"
				x2 = (gdouble) w;
#line 925 "../src/page-view.vala"
				y2 = s + 0.5;
#line 926 "../src/page-view.vala"
				break;
#line 3387 "page-view.c"
			}
#line 920 "../src/page-view.vala"
			case SCAN_DIRECTION_BOTTOM_TO_TOP:
#line 3391 "page-view.c"
			{
#line 928 "../src/page-view.vala"
				s = (gdouble) page_view_page_to_screen_y (self, scan_line);
#line 929 "../src/page-view.vala"
				x1 = (gdouble) 0;
#line 929 "../src/page-view.vala"
				y1 = (h - s) + 0.5;
#line 930 "../src/page-view.vala"
				x2 = (gdouble) w;
#line 930 "../src/page-view.vala"
				y2 = (h - s) + 0.5;
#line 931 "../src/page-view.vala"
				break;
#line 3405 "page-view.c"
			}
#line 920 "../src/page-view.vala"
			case SCAN_DIRECTION_LEFT_TO_RIGHT:
#line 3409 "page-view.c"
			{
#line 933 "../src/page-view.vala"
				s = (gdouble) page_view_page_to_screen_x (self, scan_line);
#line 934 "../src/page-view.vala"
				x1 = s + 0.5;
#line 934 "../src/page-view.vala"
				y1 = (gdouble) 0;
#line 935 "../src/page-view.vala"
				x2 = s + 0.5;
#line 935 "../src/page-view.vala"
				y2 = (gdouble) h;
#line 936 "../src/page-view.vala"
				break;
#line 3423 "page-view.c"
			}
#line 920 "../src/page-view.vala"
			case SCAN_DIRECTION_RIGHT_TO_LEFT:
#line 3427 "page-view.c"
			{
#line 938 "../src/page-view.vala"
				s = (gdouble) page_view_page_to_screen_x (self, scan_line);
#line 939 "../src/page-view.vala"
				x1 = (w - s) + 0.5;
#line 939 "../src/page-view.vala"
				y1 = (gdouble) 0;
#line 940 "../src/page-view.vala"
				x2 = (w - s) + 0.5;
#line 940 "../src/page-view.vala"
				y2 = (gdouble) h;
#line 941 "../src/page-view.vala"
				break;
#line 3441 "page-view.c"
			}
			default:
			{
#line 943 "../src/page-view.vala"
				y2 = (gdouble) 0;
#line 943 "../src/page-view.vala"
				x2 = y2;
#line 943 "../src/page-view.vala"
				y1 = x2;
#line 943 "../src/page-view.vala"
				x1 = y1;
#line 944 "../src/page-view.vala"
				break;
#line 3455 "page-view.c"
			}
		}
#line 947 "../src/page-view.vala"
		cairo_move_to (context, x1, y1);
#line 948 "../src/page-view.vala"
		cairo_line_to (context, x2, y2);
#line 949 "../src/page-view.vala"
		cairo_set_source_rgb (context, 1.0, 0.0, 0.0);
#line 950 "../src/page-view.vala"
		cairo_stroke (context);
#line 3466 "page-view.c"
	}
#line 954 "../src/page-view.vala"
	_tmp29_ = self->priv->_page;
#line 954 "../src/page-view.vala"
	_tmp30_ = page_get_has_crop (_tmp29_);
#line 954 "../src/page-view.vala"
	_tmp31_ = _tmp30_;
#line 954 "../src/page-view.vala"
	if (_tmp31_) {
#line 3476 "page-view.c"
		gint x = 0;
		Page* _tmp32_;
		gint _tmp33_;
		gint _tmp34_;
		gint y = 0;
		Page* _tmp35_;
		gint _tmp36_;
		gint _tmp37_;
		gint crop_width = 0;
		Page* _tmp38_;
		gint _tmp39_;
		gint _tmp40_;
		gint crop_height = 0;
		Page* _tmp41_;
		gint _tmp42_;
		gint _tmp43_;
		gint dx = 0;
		gint dy = 0;
		gint dw = 0;
		gint dh = 0;
#line 956 "../src/page-view.vala"
		_tmp32_ = self->priv->_page;
#line 956 "../src/page-view.vala"
		_tmp33_ = page_get_crop_x (_tmp32_);
#line 956 "../src/page-view.vala"
		_tmp34_ = _tmp33_;
#line 956 "../src/page-view.vala"
		x = _tmp34_;
#line 957 "../src/page-view.vala"
		_tmp35_ = self->priv->_page;
#line 957 "../src/page-view.vala"
		_tmp36_ = page_get_crop_y (_tmp35_);
#line 957 "../src/page-view.vala"
		_tmp37_ = _tmp36_;
#line 957 "../src/page-view.vala"
		y = _tmp37_;
#line 958 "../src/page-view.vala"
		_tmp38_ = self->priv->_page;
#line 958 "../src/page-view.vala"
		_tmp39_ = page_get_crop_width (_tmp38_);
#line 958 "../src/page-view.vala"
		_tmp40_ = _tmp39_;
#line 958 "../src/page-view.vala"
		crop_width = _tmp40_;
#line 959 "../src/page-view.vala"
		_tmp41_ = self->priv->_page;
#line 959 "../src/page-view.vala"
		_tmp42_ = page_get_crop_height (_tmp41_);
#line 959 "../src/page-view.vala"
		_tmp43_ = _tmp42_;
#line 959 "../src/page-view.vala"
		crop_height = _tmp43_;
#line 961 "../src/page-view.vala"
		dx = page_view_page_to_screen_x (self, x);
#line 962 "../src/page-view.vala"
		dy = page_view_page_to_screen_y (self, y);
#line 963 "../src/page-view.vala"
		dw = page_view_page_to_screen_x (self, crop_width);
#line 964 "../src/page-view.vala"
		dh = page_view_page_to_screen_y (self, crop_height);
#line 967 "../src/page-view.vala"
		cairo_rectangle (context, (gdouble) 0, (gdouble) 0, (gdouble) w, (gdouble) h);
#line 968 "../src/page-view.vala"
		cairo_new_sub_path (context);
#line 969 "../src/page-view.vala"
		cairo_rectangle (context, (gdouble) dx, (gdouble) dy, (gdouble) dw, (gdouble) dh);
#line 970 "../src/page-view.vala"
		cairo_set_fill_rule (context, CAIRO_FILL_RULE_EVEN_ODD);
#line 971 "../src/page-view.vala"
		cairo_set_source_rgba (context, 0.25, 0.25, 0.25, 0.2);
#line 972 "../src/page-view.vala"
		cairo_fill (context);
#line 975 "../src/page-view.vala"
		cairo_set_source_rgb (context, 1.0, 1.0, 1.0);
#line 976 "../src/page-view.vala"
		cairo_move_to (context, (gdouble) (-self->priv->border_width), dy - 1.5);
#line 977 "../src/page-view.vala"
		cairo_line_to (context, (gdouble) (self->priv->border_width + w), dy - 1.5);
#line 978 "../src/page-view.vala"
		cairo_move_to (context, (gdouble) (-self->priv->border_width), (dy + dh) + 1.5);
#line 979 "../src/page-view.vala"
		cairo_line_to (context, (gdouble) (self->priv->border_width + w), (dy + dh) + 1.5);
#line 980 "../src/page-view.vala"
		cairo_stroke (context);
#line 982 "../src/page-view.vala"
		cairo_move_to (context, dx - 1.5, (gdouble) (-self->priv->border_width));
#line 983 "../src/page-view.vala"
		cairo_line_to (context, dx - 1.5, (gdouble) (self->priv->border_width + h));
#line 984 "../src/page-view.vala"
		cairo_move_to (context, (dx + dw) + 1.5, (gdouble) (-self->priv->border_width));
#line 985 "../src/page-view.vala"
		cairo_line_to (context, (dx + dw) + 1.5, (gdouble) (self->priv->border_width + h));
#line 986 "../src/page-view.vala"
		cairo_stroke (context);
#line 988 "../src/page-view.vala"
		cairo_rectangle (context, dx - 0.5, dy - 0.5, (gdouble) (dw + 1), (gdouble) (dh + 1));
#line 989 "../src/page-view.vala"
		cairo_set_source_rgb (context, 0.0, 0.0, 0.0);
#line 990 "../src/page-view.vala"
		cairo_stroke (context);
#line 3577 "page-view.c"
	}
}

static void
page_view_page_pixels_changed_cb (PageView* self,
                                  Page* p)
{
#line 1036 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 1036 "../src/page-view.vala"
	g_return_if_fail (p != NULL);
#line 1039 "../src/page-view.vala"
	self->priv->update_image = TRUE;
#line 1040 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 3593 "page-view.c"
}

static void
page_view_page_size_changed_cb (PageView* self,
                                Page* p)
{
#line 1043 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 1043 "../src/page-view.vala"
	g_return_if_fail (p != NULL);
#line 1046 "../src/page-view.vala"
	self->priv->update_image = TRUE;
#line 1047 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
#line 1048 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 3610 "page-view.c"
}

static void
page_view_page_overlay_changed_cb (PageView* self,
                                   Page* p)
{
#line 1051 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 1051 "../src/page-view.vala"
	g_return_if_fail (p != NULL);
#line 1053 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 3623 "page-view.c"
}

static void
page_view_scan_direction_changed_cb (PageView* self,
                                     Page* p)
{
#line 1056 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 1056 "../src/page-view.vala"
	g_return_if_fail (p != NULL);
#line 1059 "../src/page-view.vala"
	self->priv->update_image = TRUE;
#line 1060 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
#line 1061 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 3640 "page-view.c"
}

Page*
page_view_get_page (PageView* self)
{
	Page* result;
	Page* _tmp0_;
#line 29 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 29 "../src/page-view.vala"
	result = _tmp0_;
#line 29 "../src/page-view.vala"
	return result;
#line 3656 "page-view.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 29 "../src/page-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 3664 "page-view.c"
}

static void
page_view_set_page (PageView* self,
                    Page* value)
{
	Page* old_value;
#line 29 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/page-view.vala"
	old_value = page_view_get_page (self);
#line 29 "../src/page-view.vala"
	if (old_value != value) {
#line 3678 "page-view.c"
		Page* _tmp0_;
#line 29 "../src/page-view.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 29 "../src/page-view.vala"
		_g_object_unref0 (self->priv->_page);
#line 29 "../src/page-view.vala"
		self->priv->_page = _tmp0_;
#line 29 "../src/page-view.vala"
		g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_PAGE_PROPERTY]);
#line 3688 "page-view.c"
	}
}

gboolean
page_view_get_selected (PageView* self)
{
	gboolean result;
#line 38 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 38 "../src/page-view.vala"
	result = self->priv->selected_;
#line 38 "../src/page-view.vala"
	return result;
#line 3702 "page-view.c"
}

void
page_view_set_selected (PageView* self,
                        gboolean value)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp11_;
	gboolean _tmp12_;
#line 39 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/page-view.vala"
	_tmp2_ = page_view_get_selected (self);
#line 41 "../src/page-view.vala"
	_tmp3_ = _tmp2_;
#line 41 "../src/page-view.vala"
	if (_tmp3_) {
#line 3723 "page-view.c"
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 41 "../src/page-view.vala"
		_tmp4_ = page_view_get_selected (self);
#line 41 "../src/page-view.vala"
		_tmp5_ = _tmp4_;
#line 41 "../src/page-view.vala"
		_tmp1_ = _tmp5_;
#line 3732 "page-view.c"
	} else {
#line 41 "../src/page-view.vala"
		_tmp1_ = FALSE;
#line 3736 "page-view.c"
	}
#line 41 "../src/page-view.vala"
	if (_tmp1_) {
#line 41 "../src/page-view.vala"
		_tmp0_ = TRUE;
#line 3742 "page-view.c"
	} else {
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 41 "../src/page-view.vala"
		_tmp7_ = page_view_get_selected (self);
#line 41 "../src/page-view.vala"
		_tmp8_ = _tmp7_;
#line 41 "../src/page-view.vala"
		if (!_tmp8_) {
#line 3753 "page-view.c"
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 41 "../src/page-view.vala"
			_tmp9_ = page_view_get_selected (self);
#line 41 "../src/page-view.vala"
			_tmp10_ = _tmp9_;
#line 41 "../src/page-view.vala"
			_tmp6_ = !_tmp10_;
#line 3762 "page-view.c"
		} else {
#line 41 "../src/page-view.vala"
			_tmp6_ = FALSE;
#line 3766 "page-view.c"
		}
#line 41 "../src/page-view.vala"
		_tmp0_ = _tmp6_;
#line 3770 "page-view.c"
	}
#line 41 "../src/page-view.vala"
	if (_tmp0_) {
#line 42 "../src/page-view.vala"
		return;
#line 3776 "page-view.c"
	}
#line 43 "../src/page-view.vala"
	_tmp11_ = page_view_get_selected (self);
#line 43 "../src/page-view.vala"
	_tmp12_ = _tmp11_;
#line 43 "../src/page-view.vala"
	page_view_set_selected (self, _tmp12_);
#line 44 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 39 "../src/page-view.vala"
	g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_SELECTED_PROPERTY]);
#line 3788 "page-view.c"
}

gint
page_view_get_x_offset (PageView* self)
{
	gint result;
#line 66 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 66 "../src/page-view.vala"
	result = self->priv->_x_offset;
#line 66 "../src/page-view.vala"
	return result;
#line 3801 "page-view.c"
}

void
page_view_set_x_offset (PageView* self,
                        gint value)
{
	gint old_value;
#line 66 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/page-view.vala"
	old_value = page_view_get_x_offset (self);
#line 66 "../src/page-view.vala"
	if (old_value != value) {
#line 66 "../src/page-view.vala"
		self->priv->_x_offset = value;
#line 66 "../src/page-view.vala"
		g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_X_OFFSET_PROPERTY]);
#line 3819 "page-view.c"
	}
}

gint
page_view_get_y_offset (PageView* self)
{
	gint result;
#line 67 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 67 "../src/page-view.vala"
	result = self->priv->_y_offset;
#line 67 "../src/page-view.vala"
	return result;
#line 3833 "page-view.c"
}

void
page_view_set_y_offset (PageView* self,
                        gint value)
{
	gint old_value;
#line 67 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 67 "../src/page-view.vala"
	old_value = page_view_get_y_offset (self);
#line 67 "../src/page-view.vala"
	if (old_value != value) {
#line 67 "../src/page-view.vala"
		self->priv->_y_offset = value;
#line 67 "../src/page-view.vala"
		g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_Y_OFFSET_PROPERTY]);
#line 3851 "page-view.c"
	}
}

GdkCursorType
page_view_get_cursor (PageView* self)
{
	GdkCursorType result;
#line 78 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 78 "../src/page-view.vala"
	result = self->priv->_cursor;
#line 78 "../src/page-view.vala"
	return result;
#line 3865 "page-view.c"
}

static void
page_view_set_cursor (PageView* self,
                      GdkCursorType value)
{
	GdkCursorType old_value;
#line 78 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 78 "../src/page-view.vala"
	old_value = page_view_get_cursor (self);
#line 78 "../src/page-view.vala"
	if (old_value != value) {
#line 78 "../src/page-view.vala"
		self->priv->_cursor = value;
#line 78 "../src/page-view.vala"
		g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_CURSOR_PROPERTY]);
#line 3883 "page-view.c"
	}
}

gint
page_view_get_width (PageView* self)
{
	gint result;
#line 996 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 996 "../src/page-view.vala"
	result = self->priv->width_;
#line 996 "../src/page-view.vala"
	return result;
#line 3897 "page-view.c"
}

void
page_view_set_width (PageView* self,
                     gint value)
{
	gint h = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gboolean _tmp6_ = FALSE;
#line 997 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 1000 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 1000 "../src/page-view.vala"
	_tmp1_ = page_get_height (_tmp0_);
#line 1000 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 1000 "../src/page-view.vala"
	_tmp3_ = self->priv->_page;
#line 1000 "../src/page-view.vala"
	_tmp4_ = page_get_width (_tmp3_);
#line 1000 "../src/page-view.vala"
	_tmp5_ = _tmp4_;
#line 1000 "../src/page-view.vala"
	h = (gint) ((((gdouble) value) * _tmp2_) / _tmp5_);
#line 1001 "../src/page-view.vala"
	if (self->priv->width_ == value) {
#line 1001 "../src/page-view.vala"
		_tmp6_ = self->priv->height_ == h;
#line 3932 "page-view.c"
	} else {
#line 1001 "../src/page-view.vala"
		_tmp6_ = FALSE;
#line 3936 "page-view.c"
	}
#line 1001 "../src/page-view.vala"
	if (_tmp6_) {
#line 1002 "../src/page-view.vala"
		return;
#line 3942 "page-view.c"
	}
#line 1004 "../src/page-view.vala"
	self->priv->width_ = value;
#line 1005 "../src/page-view.vala"
	self->priv->height_ = h;
#line 1008 "../src/page-view.vala"
	self->priv->update_image = TRUE;
#line 1010 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
#line 1011 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 997 "../src/page-view.vala"
	g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_WIDTH_PROPERTY]);
#line 3956 "page-view.c"
}

gint
page_view_get_height (PageView* self)
{
	gint result;
#line 1017 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1017 "../src/page-view.vala"
	result = self->priv->height_;
#line 1017 "../src/page-view.vala"
	return result;
#line 3969 "page-view.c"
}

void
page_view_set_height (PageView* self,
                      gint value)
{
	gint w = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gboolean _tmp6_ = FALSE;
#line 1018 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 1021 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 1021 "../src/page-view.vala"
	_tmp1_ = page_get_width (_tmp0_);
#line 1021 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 1021 "../src/page-view.vala"
	_tmp3_ = self->priv->_page;
#line 1021 "../src/page-view.vala"
	_tmp4_ = page_get_height (_tmp3_);
#line 1021 "../src/page-view.vala"
	_tmp5_ = _tmp4_;
#line 1021 "../src/page-view.vala"
	w = (gint) ((((gdouble) value) * _tmp2_) / _tmp5_);
#line 1022 "../src/page-view.vala"
	if (self->priv->width_ == w) {
#line 1022 "../src/page-view.vala"
		_tmp6_ = self->priv->height_ == value;
#line 4004 "page-view.c"
	} else {
#line 1022 "../src/page-view.vala"
		_tmp6_ = FALSE;
#line 4008 "page-view.c"
	}
#line 1022 "../src/page-view.vala"
	if (_tmp6_) {
#line 1023 "../src/page-view.vala"
		return;
#line 4014 "page-view.c"
	}
#line 1025 "../src/page-view.vala"
	self->priv->width_ = w;
#line 1026 "../src/page-view.vala"
	self->priv->height_ = value;
#line 1029 "../src/page-view.vala"
	self->priv->update_image = TRUE;
#line 1031 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
#line 1032 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 1018 "../src/page-view.vala"
	g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_HEIGHT_PROPERTY]);
#line 4028 "page-view.c"
}

static void
page_view_class_init (PageViewClass * klass,
                      gpointer klass_data)
{
#line 26 "../src/page-view.vala"
	page_view_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/page-view.vala"
	g_type_class_adjust_private_offset (klass, &PageView_private_offset);
#line 26 "../src/page-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_page_view_get_property;
#line 26 "../src/page-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_page_view_set_property;
#line 26 "../src/page-view.vala"
	G_OBJECT_CLASS (klass)->finalize = page_view_finalize;
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_PAGE_PROPERTY, page_view_properties[PAGE_VIEW_PAGE_PROPERTY] = g_param_spec_object ("page", "page", "page", TYPE_PAGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_SELECTED_PROPERTY, page_view_properties[PAGE_VIEW_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_X_OFFSET_PROPERTY, page_view_properties[PAGE_VIEW_X_OFFSET_PROPERTY] = g_param_spec_int ("x-offset", "x-offset", "x-offset", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_Y_OFFSET_PROPERTY, page_view_properties[PAGE_VIEW_Y_OFFSET_PROPERTY] = g_param_spec_int ("y-offset", "y-offset", "y-offset", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_CURSOR_PROPERTY, page_view_properties[PAGE_VIEW_CURSOR_PROPERTY] = g_param_spec_enum ("cursor", "cursor", "cursor", gdk_cursor_type_get_type (), GDK_ARROW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_WIDTH_PROPERTY, page_view_properties[PAGE_VIEW_WIDTH_PROPERTY] = g_param_spec_int ("width", "width", "width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_HEIGHT_PROPERTY, page_view_properties[PAGE_VIEW_HEIGHT_PROPERTY] = g_param_spec_int ("height", "height", "height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/page-view.vala"
	page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL] = g_signal_new ("size-changed", TYPE_PAGE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 26 "../src/page-view.vala"
	page_view_signals[PAGE_VIEW_CHANGED_SIGNAL] = g_signal_new ("changed", TYPE_PAGE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4063 "page-view.c"
}

static void
page_view_instance_init (PageView * self,
                         gpointer klass)
{
#line 26 "../src/page-view.vala"
	self->priv = page_view_get_instance_private (self);
#line 32 "../src/page-view.vala"
	self->priv->image = NULL;
#line 35 "../src/page-view.vala"
	self->priv->selected_ = FALSE;
#line 48 "../src/page-view.vala"
	self->priv->ruler_width = 8;
#line 50 "../src/page-view.vala"
	self->priv->border_width = 2;
#line 53 "../src/page-view.vala"
	self->priv->update_image = TRUE;
#line 78 "../src/page-view.vala"
	self->priv->_cursor = GDK_ARROW;
#line 80 "../src/page-view.vala"
	self->priv->animate_n_segments = 7;
#line 4086 "page-view.c"
}

static void
page_view_finalize (GObject * obj)
{
	PageView * self;
	Page* _tmp0_;
	guint _tmp1_;
	Page* _tmp2_;
	guint _tmp3_;
	Page* _tmp4_;
	guint _tmp5_;
	Page* _tmp6_;
	guint _tmp7_;
	Page* _tmp8_;
	guint _tmp9_;
#line 26 "../src/page-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAGE_VIEW, PageView);
#line 99 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 99 "../src/page-view.vala"
	g_signal_parse_name ("pixels-changed", TYPE_PAGE, &_tmp1_, NULL, FALSE);
#line 99 "../src/page-view.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _page_view_page_pixels_changed_cb_page_pixels_changed, self);
#line 100 "../src/page-view.vala"
	_tmp2_ = self->priv->_page;
#line 100 "../src/page-view.vala"
	g_signal_parse_name ("size-changed", TYPE_PAGE, &_tmp3_, NULL, FALSE);
#line 100 "../src/page-view.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _page_view_page_size_changed_cb_page_size_changed, self);
#line 101 "../src/page-view.vala"
	_tmp4_ = self->priv->_page;
#line 101 "../src/page-view.vala"
	g_signal_parse_name ("crop-changed", TYPE_PAGE, &_tmp5_, NULL, FALSE);
#line 101 "../src/page-view.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _page_view_page_overlay_changed_cb_page_crop_changed, self);
#line 102 "../src/page-view.vala"
	_tmp6_ = self->priv->_page;
#line 102 "../src/page-view.vala"
	g_signal_parse_name ("scan-line-changed", TYPE_PAGE, &_tmp7_, NULL, FALSE);
#line 102 "../src/page-view.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _page_view_page_overlay_changed_cb_page_scan_line_changed, self);
#line 103 "../src/page-view.vala"
	_tmp8_ = self->priv->_page;
#line 103 "../src/page-view.vala"
	g_signal_parse_name ("scan-direction-changed", TYPE_PAGE, &_tmp9_, NULL, FALSE);
#line 103 "../src/page-view.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _page_view_scan_direction_changed_cb_page_scan_direction_changed, self);
#line 29 "../src/page-view.vala"
	_g_object_unref0 (self->priv->_page);
#line 32 "../src/page-view.vala"
	_g_object_unref0 (self->priv->image);
#line 26 "../src/page-view.vala"
	G_OBJECT_CLASS (page_view_parent_class)->finalize (obj);
#line 4141 "page-view.c"
}

static GType
page_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PageViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) page_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PageView), 0, (GInstanceInitFunc) page_view_instance_init, NULL };
	GType page_view_type_id;
	page_view_type_id = g_type_register_static (G_TYPE_OBJECT, "PageView", &g_define_type_info, 0);
	PageView_private_offset = g_type_add_instance_private (page_view_type_id, sizeof (PageViewPrivate));
	return page_view_type_id;
}

GType
page_view_get_type (void)
{
	static volatile gsize page_view_type_id__once = 0;
	if (g_once_init_enter (&page_view_type_id__once)) {
		GType page_view_type_id;
		page_view_type_id = page_view_get_type_once ();
		g_once_init_leave (&page_view_type_id__once, page_view_type_id);
	}
	return page_view_type_id__once;
}

static void
_vala_page_view_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	PageView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PAGE_VIEW, PageView);
#line 26 "../src/page-view.vala"
	switch (property_id) {
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_PAGE_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_object (value, page_view_get_page (self));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_SELECTED_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_boolean (value, page_view_get_selected (self));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_X_OFFSET_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_int (value, page_view_get_x_offset (self));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_Y_OFFSET_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_int (value, page_view_get_y_offset (self));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_CURSOR_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_enum (value, page_view_get_cursor (self));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_WIDTH_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_int (value, page_view_get_width (self));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_HEIGHT_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_int (value, page_view_get_height (self));
#line 26 "../src/page-view.vala"
		break;
#line 4218 "page-view.c"
		default:
#line 26 "../src/page-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/page-view.vala"
		break;
#line 4224 "page-view.c"
	}
}

static void
_vala_page_view_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	PageView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PAGE_VIEW, PageView);
#line 26 "../src/page-view.vala"
	switch (property_id) {
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_PAGE_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_page (self, g_value_get_object (value));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_SELECTED_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_selected (self, g_value_get_boolean (value));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_X_OFFSET_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_x_offset (self, g_value_get_int (value));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_Y_OFFSET_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_y_offset (self, g_value_get_int (value));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_CURSOR_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_cursor (self, g_value_get_enum (value));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_WIDTH_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_width (self, g_value_get_int (value));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_HEIGHT_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_height (self, g_value_get_int (value));
#line 26 "../src/page-view.vala"
		break;
#line 4280 "page-view.c"
		default:
#line 26 "../src/page-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/page-view.vala"
		break;
#line 4286 "page-view.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

