/* preferences-dialog.c generated by valac 0.56.14, the Vala compiler
 * generated from preferences-dialog.vala, do not modify */

/*
 * Copyright (C) 2009-2017 Canonical Ltd.
 * Author: Robert Ancell <robert.ancell@canonical.com>,
 *         Eduard Gotwig <g@ox.io>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <handy.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#define DEFAULT_TEXT_DPI 150
#define DEFAULT_PHOTO_DPI 300
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_PREFERENCES_DIALOG (preferences_dialog_get_type ())
#define PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFERENCES_DIALOG, PreferencesDialog))
#define PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFERENCES_DIALOG, PreferencesDialogClass))
#define IS_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFERENCES_DIALOG))
#define IS_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFERENCES_DIALOG))
#define PREFERENCES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFERENCES_DIALOG, PreferencesDialogClass))

typedef struct _PreferencesDialog PreferencesDialog;
typedef struct _PreferencesDialogClass PreferencesDialogClass;
typedef struct _PreferencesDialogPrivate PreferencesDialogPrivate;
enum  {
	PREFERENCES_DIALOG_0_PROPERTY,
	PREFERENCES_DIALOG_NUM_PROPERTIES
};
static GParamSpec* preferences_dialog_properties[PREFERENCES_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block7Data Block7Data;
typedef enum  {
	SCAN_SIDE_FRONT,
	SCAN_SIDE_BACK,
	SCAN_SIDE_BOTH
} ScanSide;

#define TYPE_SCAN_SIDE (scan_side_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

struct _PreferencesDialog {
	HdyPreferencesWindow parent_instance;
	PreferencesDialogPrivate * priv;
};

struct _PreferencesDialogClass {
	HdyPreferencesWindowClass parent_class;
};

struct _PreferencesDialogPrivate {
	GSettings* settings;
	GtkComboBox* text_dpi_combo;
	GtkComboBox* photo_dpi_combo;
	GtkComboBox* paper_size_combo;
	GtkScale* brightness_scale;
	GtkScale* contrast_scale;
	GtkRadioButton* page_delay_0s_button;
	GtkRadioButton* page_delay_3s_button;
	GtkRadioButton* page_delay_6s_button;
	GtkRadioButton* page_delay_10s_button;
	GtkRadioButton* page_delay_15s_button;
	GtkListStore* text_dpi_model;
	GtkListStore* photo_dpi_model;
	GtkRadioButton* front_side_button;
	GtkRadioButton* back_side_button;
	GtkRadioButton* both_side_button;
	GtkListStore* paper_size_model;
	GtkAdjustment* brightness_adjustment;
	GtkAdjustment* contrast_adjustment;
	GtkSwitch* postproc_enable_switch;
	GtkEntry* postproc_script_entry;
	GtkEntry* postproc_args_entry;
	GtkSwitch* postproc_keep_original_switch;
};

struct _Block7Data {
	int _ref_count_;
	PreferencesDialog* self;
	GSettings* settings;
};

static gint PreferencesDialog_private_offset;
static gpointer preferences_dialog_parent_class = NULL;

VALA_EXTERN GType preferences_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PreferencesDialog, g_object_unref)
VALA_EXTERN PreferencesDialog* preferences_dialog_new (GSettings* settings);
VALA_EXTERN PreferencesDialog* preferences_dialog_construct (GType object_type,
                                                 GSettings* settings);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void preferences_dialog_set_dpi_combo (PreferencesDialog* self,
                                       GtkComboBox* combo,
                                       gint default_dpi,
                                       gint current_dpi);
static void __lambda4_ (Block7Data* _data7_);
VALA_EXTERN gint preferences_dialog_get_text_dpi (PreferencesDialog* self);
static void ___lambda4__gtk_combo_box_changed (GtkComboBox* _sender,
                                        gpointer self);
static void __lambda5_ (Block7Data* _data7_);
VALA_EXTERN gint preferences_dialog_get_photo_dpi (PreferencesDialog* self);
static void ___lambda5__gtk_combo_box_changed (GtkComboBox* _sender,
                                        gpointer self);
VALA_EXTERN GType scan_side_get_type (void) G_GNUC_CONST ;
static void preferences_dialog_set_page_side (PreferencesDialog* self,
                                       ScanSide page_side);
static void __lambda6_ (Block7Data* _data7_,
                 GtkToggleButton* button);
static void ___lambda6__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                            gpointer self);
static void __lambda7_ (Block7Data* _data7_,
                 GtkToggleButton* button);
static void ___lambda7__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                            gpointer self);
static void __lambda8_ (Block7Data* _data7_,
                 GtkToggleButton* button);
static void ___lambda8__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                            gpointer self);
static void __lambda9_ (Block7Data* _data7_);
VALA_EXTERN gint preferences_dialog_get_brightness (PreferencesDialog* self);
static void ___lambda9__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                               gpointer self);
static void __lambda10_ (Block7Data* _data7_);
VALA_EXTERN gint preferences_dialog_get_contrast (PreferencesDialog* self);
static void ___lambda10__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                gpointer self);
VALA_EXTERN void preferences_dialog_set_paper_size (PreferencesDialog* self,
                                        gint width,
                                        gint height);
static void __lambda11_ (Block7Data* _data7_);
VALA_EXTERN gboolean preferences_dialog_get_paper_size (PreferencesDialog* self,
                                            gint* width,
                                            gint* height);
static void ___lambda11__gtk_combo_box_changed (GtkComboBox* _sender,
                                         gpointer self);
VALA_EXTERN void preferences_dialog_set_page_delay (PreferencesDialog* self,
                                        gint page_delay);
static void __lambda12_ (Block7Data* _data7_,
                  GtkToggleButton* button);
static void ___lambda12__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
static void __lambda13_ (Block7Data* _data7_,
                  GtkToggleButton* button);
static void ___lambda13__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
static void __lambda14_ (Block7Data* _data7_,
                  GtkToggleButton* button);
static void ___lambda14__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
static void __lambda15_ (Block7Data* _data7_,
                  GtkToggleButton* button);
static void ___lambda15__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
static void __lambda16_ (Block7Data* _data7_,
                  GtkToggleButton* button);
static void ___lambda16__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                             gpointer self);
static void preferences_dialog_toggle_postproc_visibility (PreferencesDialog* self,
                                                    gboolean enabled);
static gboolean __lambda17_ (Block7Data* _data7_,
                      gboolean is_active);
static gboolean ___lambda17__gtk_switch_state_set (GtkSwitch* _sender,
                                            gboolean state,
                                            gpointer self);
static void __lambda18_ (Block7Data* _data7_);
static void ___lambda18__gtk_editable_changed (GtkEditable* _sender,
                                        gpointer self);
static void __lambda19_ (Block7Data* _data7_);
static void ___lambda19__gtk_editable_changed (GtkEditable* _sender,
                                        gpointer self);
static gboolean __lambda20_ (Block7Data* _data7_,
                      gboolean is_active);
static gboolean ___lambda20__gtk_switch_state_set (GtkSwitch* _sender,
                                            gboolean state,
                                            gpointer self);
VALA_EXTERN ScanSide preferences_dialog_get_page_side (PreferencesDialog* self);
VALA_EXTERN void preferences_dialog_set_brightness (PreferencesDialog* self,
                                        gint brightness);
VALA_EXTERN void preferences_dialog_set_contrast (PreferencesDialog* self,
                                      gint contrast);
VALA_EXTERN gint preferences_dialog_get_page_delay (PreferencesDialog* self);
static void preferences_dialog_finalize (GObject * obj);
static GType preferences_dialog_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
preferences_dialog_get_instance_private (PreferencesDialog* self)
{
	return G_STRUCT_MEMBER_P (self, PreferencesDialog_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 63 "../src/preferences-dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 229 "preferences-dialog.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 63 "../src/preferences-dialog.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 63 "../src/preferences-dialog.vala"
	return _data7_;
#line 239 "preferences-dialog.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 63 "../src/preferences-dialog.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 249 "preferences-dialog.c"
		PreferencesDialog* self;
#line 63 "../src/preferences-dialog.vala"
		self = _data7_->self;
#line 63 "../src/preferences-dialog.vala"
		_g_object_unref0 (_data7_->settings);
#line 63 "../src/preferences-dialog.vala"
		_g_object_unref0 (self);
#line 63 "../src/preferences-dialog.vala"
		g_slice_free (Block7Data, _data7_);
#line 259 "preferences-dialog.c"
	}
}

static void
__lambda4_ (Block7Data* _data7_)
{
	PreferencesDialog* self;
#line 91 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 91 "../src/preferences-dialog.vala"
	g_settings_set_int (_data7_->settings, "text-dpi", preferences_dialog_get_text_dpi (self));
#line 271 "preferences-dialog.c"
}

static void
___lambda4__gtk_combo_box_changed (GtkComboBox* _sender,
                                   gpointer self)
{
#line 91 "../src/preferences-dialog.vala"
	__lambda4_ (self);
#line 280 "preferences-dialog.c"
}

static void
__lambda5_ (Block7Data* _data7_)
{
	PreferencesDialog* self;
#line 96 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 96 "../src/preferences-dialog.vala"
	g_settings_set_int (_data7_->settings, "photo-dpi", preferences_dialog_get_photo_dpi (self));
#line 291 "preferences-dialog.c"
}

static void
___lambda5__gtk_combo_box_changed (GtkComboBox* _sender,
                                   gpointer self)
{
#line 96 "../src/preferences-dialog.vala"
	__lambda5_ (self);
#line 300 "preferences-dialog.c"
}

static void
__lambda6_ (Block7Data* _data7_,
            GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 99 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 99 "../src/preferences-dialog.vala"
	g_return_if_fail (button != NULL);
#line 99 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_toggle_button_get_active (button);
#line 99 "../src/preferences-dialog.vala"
	_tmp1_ = _tmp0_;
#line 99 "../src/preferences-dialog.vala"
	if (_tmp1_) {
#line 99 "../src/preferences-dialog.vala"
		g_settings_set_enum (_data7_->settings, "page-side", (gint) SCAN_SIDE_FRONT);
#line 322 "preferences-dialog.c"
	}
}

static void
___lambda6__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                       gpointer self)
{
#line 99 "../src/preferences-dialog.vala"
	__lambda6_ (self, _sender);
#line 332 "preferences-dialog.c"
}

static void
__lambda7_ (Block7Data* _data7_,
            GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 100 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 100 "../src/preferences-dialog.vala"
	g_return_if_fail (button != NULL);
#line 100 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_toggle_button_get_active (button);
#line 100 "../src/preferences-dialog.vala"
	_tmp1_ = _tmp0_;
#line 100 "../src/preferences-dialog.vala"
	if (_tmp1_) {
#line 100 "../src/preferences-dialog.vala"
		g_settings_set_enum (_data7_->settings, "page-side", (gint) SCAN_SIDE_BACK);
#line 354 "preferences-dialog.c"
	}
}

static void
___lambda7__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                       gpointer self)
{
#line 100 "../src/preferences-dialog.vala"
	__lambda7_ (self, _sender);
#line 364 "preferences-dialog.c"
}

static void
__lambda8_ (Block7Data* _data7_,
            GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 101 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 101 "../src/preferences-dialog.vala"
	g_return_if_fail (button != NULL);
#line 101 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_toggle_button_get_active (button);
#line 101 "../src/preferences-dialog.vala"
	_tmp1_ = _tmp0_;
#line 101 "../src/preferences-dialog.vala"
	if (_tmp1_) {
#line 101 "../src/preferences-dialog.vala"
		g_settings_set_enum (_data7_->settings, "page-side", (gint) SCAN_SIDE_BOTH);
#line 386 "preferences-dialog.c"
	}
}

static void
___lambda8__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                       gpointer self)
{
#line 101 "../src/preferences-dialog.vala"
	__lambda8_ (self, _sender);
#line 396 "preferences-dialog.c"
}

static void
__lambda9_ (Block7Data* _data7_)
{
	PreferencesDialog* self;
#line 115 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 115 "../src/preferences-dialog.vala"
	g_settings_set_int (_data7_->settings, "brightness", preferences_dialog_get_brightness (self));
#line 407 "preferences-dialog.c"
}

static void
___lambda9__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                          gpointer self)
{
#line 115 "../src/preferences-dialog.vala"
	__lambda9_ (self);
#line 416 "preferences-dialog.c"
}

static void
__lambda10_ (Block7Data* _data7_)
{
	PreferencesDialog* self;
#line 125 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 125 "../src/preferences-dialog.vala"
	g_settings_set_int (_data7_->settings, "contrast", preferences_dialog_get_contrast (self));
#line 427 "preferences-dialog.c"
}

static void
___lambda10__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                           gpointer self)
{
#line 125 "../src/preferences-dialog.vala"
	__lambda10_ (self);
#line 436 "preferences-dialog.c"
}

static void
__lambda11_ (Block7Data* _data7_)
{
	PreferencesDialog* self;
	gint w = 0;
	gint h = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
#line 130 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 133 "../src/preferences-dialog.vala"
	preferences_dialog_get_paper_size (self, &_tmp0_, &_tmp1_);
#line 133 "../src/preferences-dialog.vala"
	w = _tmp0_;
#line 133 "../src/preferences-dialog.vala"
	h = _tmp1_;
#line 134 "../src/preferences-dialog.vala"
	g_settings_set_int (_data7_->settings, "paper-width", w);
#line 135 "../src/preferences-dialog.vala"
	g_settings_set_int (_data7_->settings, "paper-height", h);
#line 459 "preferences-dialog.c"
}

static void
___lambda11__gtk_combo_box_changed (GtkComboBox* _sender,
                                    gpointer self)
{
#line 130 "../src/preferences-dialog.vala"
	__lambda11_ (self);
#line 468 "preferences-dialog.c"
}

static void
__lambda12_ (Block7Data* _data7_,
             GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 139 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 139 "../src/preferences-dialog.vala"
	g_return_if_fail (button != NULL);
#line 139 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_toggle_button_get_active (button);
#line 139 "../src/preferences-dialog.vala"
	_tmp1_ = _tmp0_;
#line 139 "../src/preferences-dialog.vala"
	if (_tmp1_) {
#line 139 "../src/preferences-dialog.vala"
		g_settings_set_int (_data7_->settings, "page-delay", 0);
#line 490 "preferences-dialog.c"
	}
}

static void
___lambda12__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
#line 139 "../src/preferences-dialog.vala"
	__lambda12_ (self, _sender);
#line 500 "preferences-dialog.c"
}

static void
__lambda13_ (Block7Data* _data7_,
             GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 140 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 140 "../src/preferences-dialog.vala"
	g_return_if_fail (button != NULL);
#line 140 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_toggle_button_get_active (button);
#line 140 "../src/preferences-dialog.vala"
	_tmp1_ = _tmp0_;
#line 140 "../src/preferences-dialog.vala"
	if (_tmp1_) {
#line 140 "../src/preferences-dialog.vala"
		g_settings_set_int (_data7_->settings, "page-delay", 3000);
#line 522 "preferences-dialog.c"
	}
}

static void
___lambda13__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
#line 140 "../src/preferences-dialog.vala"
	__lambda13_ (self, _sender);
#line 532 "preferences-dialog.c"
}

static void
__lambda14_ (Block7Data* _data7_,
             GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 141 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 141 "../src/preferences-dialog.vala"
	g_return_if_fail (button != NULL);
#line 141 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_toggle_button_get_active (button);
#line 141 "../src/preferences-dialog.vala"
	_tmp1_ = _tmp0_;
#line 141 "../src/preferences-dialog.vala"
	if (_tmp1_) {
#line 141 "../src/preferences-dialog.vala"
		g_settings_set_int (_data7_->settings, "page-delay", 6000);
#line 554 "preferences-dialog.c"
	}
}

static void
___lambda14__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
#line 141 "../src/preferences-dialog.vala"
	__lambda14_ (self, _sender);
#line 564 "preferences-dialog.c"
}

static void
__lambda15_ (Block7Data* _data7_,
             GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 142 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 142 "../src/preferences-dialog.vala"
	g_return_if_fail (button != NULL);
#line 142 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_toggle_button_get_active (button);
#line 142 "../src/preferences-dialog.vala"
	_tmp1_ = _tmp0_;
#line 142 "../src/preferences-dialog.vala"
	if (_tmp1_) {
#line 142 "../src/preferences-dialog.vala"
		g_settings_set_int (_data7_->settings, "page-delay", 10000);
#line 586 "preferences-dialog.c"
	}
}

static void
___lambda15__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
#line 142 "../src/preferences-dialog.vala"
	__lambda15_ (self, _sender);
#line 596 "preferences-dialog.c"
}

static void
__lambda16_ (Block7Data* _data7_,
             GtkToggleButton* button)
{
	PreferencesDialog* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 143 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 143 "../src/preferences-dialog.vala"
	g_return_if_fail (button != NULL);
#line 143 "../src/preferences-dialog.vala"
	_tmp0_ = gtk_toggle_button_get_active (button);
#line 143 "../src/preferences-dialog.vala"
	_tmp1_ = _tmp0_;
#line 143 "../src/preferences-dialog.vala"
	if (_tmp1_) {
#line 143 "../src/preferences-dialog.vala"
		g_settings_set_int (_data7_->settings, "page-delay", 15000);
#line 618 "preferences-dialog.c"
	}
}

static void
___lambda16__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                        gpointer self)
{
#line 143 "../src/preferences-dialog.vala"
	__lambda16_ (self, _sender);
#line 628 "preferences-dialog.c"
}

static gboolean
__lambda17_ (Block7Data* _data7_,
             gboolean is_active)
{
	PreferencesDialog* self;
	gboolean result;
#line 149 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 149 "../src/preferences-dialog.vala"
	preferences_dialog_toggle_postproc_visibility (self, is_active);
#line 150 "../src/preferences-dialog.vala"
	g_settings_set_boolean (_data7_->settings, "postproc-enabled", is_active);
#line 151 "../src/preferences-dialog.vala"
	result = TRUE;
#line 151 "../src/preferences-dialog.vala"
	return result;
#line 647 "preferences-dialog.c"
}

static gboolean
___lambda17__gtk_switch_state_set (GtkSwitch* _sender,
                                   gboolean state,
                                   gpointer self)
{
	gboolean result;
	result = __lambda17_ (self, state);
#line 149 "../src/preferences-dialog.vala"
	return result;
#line 659 "preferences-dialog.c"
}

static void
__lambda18_ (Block7Data* _data7_)
{
	PreferencesDialog* self;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
#line 155 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 155 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->postproc_script_entry;
#line 155 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 155 "../src/preferences-dialog.vala"
	g_settings_set_string (_data7_->settings, "postproc-script", _tmp1_);
#line 676 "preferences-dialog.c"
}

static void
___lambda18__gtk_editable_changed (GtkEditable* _sender,
                                   gpointer self)
{
#line 155 "../src/preferences-dialog.vala"
	__lambda18_ (self);
#line 685 "preferences-dialog.c"
}

static void
__lambda19_ (Block7Data* _data7_)
{
	PreferencesDialog* self;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
#line 159 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 159 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->postproc_args_entry;
#line 159 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_entry_get_text (_tmp0_);
#line 159 "../src/preferences-dialog.vala"
	g_settings_set_string (_data7_->settings, "postproc-arguments", _tmp1_);
#line 702 "preferences-dialog.c"
}

static void
___lambda19__gtk_editable_changed (GtkEditable* _sender,
                                   gpointer self)
{
#line 159 "../src/preferences-dialog.vala"
	__lambda19_ (self);
#line 711 "preferences-dialog.c"
}

static gboolean
__lambda20_ (Block7Data* _data7_,
             gboolean is_active)
{
	PreferencesDialog* self;
	gboolean result;
#line 163 "../src/preferences-dialog.vala"
	self = _data7_->self;
#line 163 "../src/preferences-dialog.vala"
	g_settings_set_boolean (_data7_->settings, "postproc-keep-original", is_active);
#line 164 "../src/preferences-dialog.vala"
	result = TRUE;
#line 164 "../src/preferences-dialog.vala"
	return result;
#line 728 "preferences-dialog.c"
}

static gboolean
___lambda20__gtk_switch_state_set (GtkSwitch* _sender,
                                   gboolean state,
                                   gpointer self)
{
	gboolean result;
	result = __lambda20_ (self, state);
#line 163 "../src/preferences-dialog.vala"
	return result;
#line 740 "preferences-dialog.c"
}

PreferencesDialog*
preferences_dialog_construct (GType object_type,
                              GSettings* settings)
{
	PreferencesDialog * self = NULL;
	Block7Data* _data7_;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GtkTreeIter iter = {0};
	GtkListStore* _tmp2_;
	GtkTreeIter _tmp3_ = {0};
	GtkListStore* _tmp4_;
	GtkTreeIter _tmp5_;
	GtkListStore* _tmp6_;
	GtkTreeIter _tmp7_ = {0};
	GtkListStore* _tmp8_;
	GtkTreeIter _tmp9_;
	GtkListStore* _tmp10_;
	GtkTreeIter _tmp11_ = {0};
	GtkListStore* _tmp12_;
	GtkTreeIter _tmp13_;
	GtkListStore* _tmp14_;
	GtkTreeIter _tmp15_ = {0};
	GtkListStore* _tmp16_;
	GtkTreeIter _tmp17_;
	GtkListStore* _tmp18_;
	GtkTreeIter _tmp19_ = {0};
	GtkListStore* _tmp20_;
	GtkTreeIter _tmp21_;
	GtkListStore* _tmp22_;
	GtkTreeIter _tmp23_ = {0};
	GtkListStore* _tmp24_;
	GtkTreeIter _tmp25_;
	GtkListStore* _tmp26_;
	GtkTreeIter _tmp27_ = {0};
	GtkListStore* _tmp28_;
	GtkTreeIter _tmp29_;
	GtkListStore* _tmp30_;
	GtkTreeIter _tmp31_ = {0};
	GtkListStore* _tmp32_;
	GtkTreeIter _tmp33_;
	gint dpi = 0;
	GtkComboBox* _tmp34_;
	GtkComboBox* _tmp35_;
	GtkComboBox* _tmp36_;
	GtkComboBox* _tmp37_;
	GtkRadioButton* _tmp38_;
	GtkRadioButton* _tmp39_;
	GtkRadioButton* _tmp40_;
	GtkCellRendererText* renderer = NULL;
	GtkCellRendererText* _tmp41_;
	GtkComboBox* _tmp42_;
	GtkComboBox* _tmp43_;
	gdouble lower = 0.0;
	GtkAdjustment* _tmp44_;
	gdouble _tmp45_;
	gdouble _tmp46_;
	gchar* darker_label = NULL;
	gchar* _tmp47_;
	gdouble upper = 0.0;
	GtkAdjustment* _tmp48_;
	gdouble _tmp49_;
	gdouble _tmp50_;
	gchar* lighter_label = NULL;
	gchar* _tmp51_;
	GtkScale* _tmp52_;
	GtkScale* _tmp53_;
	GtkScale* _tmp54_;
	GtkAdjustment* _tmp55_;
	GtkAdjustment* _tmp56_;
	GtkAdjustment* _tmp57_;
	gdouble _tmp58_;
	gdouble _tmp59_;
	gchar* less_label = NULL;
	gchar* _tmp60_;
	GtkAdjustment* _tmp61_;
	gdouble _tmp62_;
	gdouble _tmp63_;
	gchar* more_label = NULL;
	gchar* _tmp64_;
	GtkScale* _tmp65_;
	GtkScale* _tmp66_;
	GtkScale* _tmp67_;
	GtkAdjustment* _tmp68_;
	GtkAdjustment* _tmp69_;
	gint paper_width = 0;
	gint paper_height = 0;
	GtkComboBox* _tmp70_;
	GtkRadioButton* _tmp71_;
	GtkRadioButton* _tmp72_;
	GtkRadioButton* _tmp73_;
	GtkRadioButton* _tmp74_;
	GtkRadioButton* _tmp75_;
	gboolean postproc_enabled = FALSE;
	GtkSwitch* _tmp76_;
	GtkSwitch* _tmp77_;
	gchar* postproc_script = NULL;
	gchar* _tmp78_;
	GtkEntry* _tmp79_;
	GtkEntry* _tmp80_;
	gchar* postproc_arguments = NULL;
	gchar* _tmp81_;
	GtkEntry* _tmp82_;
	GtkEntry* _tmp83_;
	gboolean postproc_keep_original = FALSE;
	GtkSwitch* _tmp84_;
	GtkSwitch* _tmp85_;
#line 63 "../src/preferences-dialog.vala"
	g_return_val_if_fail (settings != NULL, NULL);
#line 63 "../src/preferences-dialog.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 63 "../src/preferences-dialog.vala"
	_data7_->_ref_count_ = 1;
#line 63 "../src/preferences-dialog.vala"
	_tmp0_ = _g_object_ref0 (settings);
#line 63 "../src/preferences-dialog.vala"
	_g_object_unref0 (_data7_->settings);
#line 63 "../src/preferences-dialog.vala"
	_data7_->settings = _tmp0_;
#line 63 "../src/preferences-dialog.vala"
	self = (PreferencesDialog*) g_object_new (object_type, NULL);
#line 63 "../src/preferences-dialog.vala"
	_data7_->self = g_object_ref (self);
#line 65 "../src/preferences-dialog.vala"
	_tmp1_ = _g_object_ref0 (_data7_->settings);
#line 65 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->settings);
#line 65 "../src/preferences-dialog.vala"
	self->priv->settings = _tmp1_;
#line 68 "../src/preferences-dialog.vala"
	_tmp2_ = self->priv->paper_size_model;
#line 68 "../src/preferences-dialog.vala"
	gtk_list_store_append (_tmp2_, &_tmp3_);
#line 68 "../src/preferences-dialog.vala"
	iter = _tmp3_;
#line 69 "../src/preferences-dialog.vala"
	_tmp4_ = self->priv->paper_size_model;
#line 69 "../src/preferences-dialog.vala"
	_tmp5_ = iter;
#line 69 "../src/preferences-dialog.vala"
	gtk_list_store_set (_tmp4_, &_tmp5_, 0, 0, 1, 0, 2, _ ("Automatic"), -1, -1);
#line 72 "../src/preferences-dialog.vala"
	_tmp6_ = self->priv->paper_size_model;
#line 72 "../src/preferences-dialog.vala"
	gtk_list_store_append (_tmp6_, &_tmp7_);
#line 72 "../src/preferences-dialog.vala"
	iter = _tmp7_;
#line 73 "../src/preferences-dialog.vala"
	_tmp8_ = self->priv->paper_size_model;
#line 73 "../src/preferences-dialog.vala"
	_tmp9_ = iter;
#line 73 "../src/preferences-dialog.vala"
	gtk_list_store_set (_tmp8_, &_tmp9_, 0, 1050, 1, 1480, 2, "A6", -1, -1);
#line 74 "../src/preferences-dialog.vala"
	_tmp10_ = self->priv->paper_size_model;
#line 74 "../src/preferences-dialog.vala"
	gtk_list_store_append (_tmp10_, &_tmp11_);
#line 74 "../src/preferences-dialog.vala"
	iter = _tmp11_;
#line 75 "../src/preferences-dialog.vala"
	_tmp12_ = self->priv->paper_size_model;
#line 75 "../src/preferences-dialog.vala"
	_tmp13_ = iter;
#line 75 "../src/preferences-dialog.vala"
	gtk_list_store_set (_tmp12_, &_tmp13_, 0, 1480, 1, 2100, 2, "A5", -1, -1);
#line 76 "../src/preferences-dialog.vala"
	_tmp14_ = self->priv->paper_size_model;
#line 76 "../src/preferences-dialog.vala"
	gtk_list_store_append (_tmp14_, &_tmp15_);
#line 76 "../src/preferences-dialog.vala"
	iter = _tmp15_;
#line 77 "../src/preferences-dialog.vala"
	_tmp16_ = self->priv->paper_size_model;
#line 77 "../src/preferences-dialog.vala"
	_tmp17_ = iter;
#line 77 "../src/preferences-dialog.vala"
	gtk_list_store_set (_tmp16_, &_tmp17_, 0, 2100, 1, 2970, 2, "A4", -1, -1);
#line 78 "../src/preferences-dialog.vala"
	_tmp18_ = self->priv->paper_size_model;
#line 78 "../src/preferences-dialog.vala"
	gtk_list_store_append (_tmp18_, &_tmp19_);
#line 78 "../src/preferences-dialog.vala"
	iter = _tmp19_;
#line 79 "../src/preferences-dialog.vala"
	_tmp20_ = self->priv->paper_size_model;
#line 79 "../src/preferences-dialog.vala"
	_tmp21_ = iter;
#line 79 "../src/preferences-dialog.vala"
	gtk_list_store_set (_tmp20_, &_tmp21_, 0, 2970, 1, 4200, 2, "A3", -1, -1);
#line 80 "../src/preferences-dialog.vala"
	_tmp22_ = self->priv->paper_size_model;
#line 80 "../src/preferences-dialog.vala"
	gtk_list_store_append (_tmp22_, &_tmp23_);
#line 80 "../src/preferences-dialog.vala"
	iter = _tmp23_;
#line 81 "../src/preferences-dialog.vala"
	_tmp24_ = self->priv->paper_size_model;
#line 81 "../src/preferences-dialog.vala"
	_tmp25_ = iter;
#line 81 "../src/preferences-dialog.vala"
	gtk_list_store_set (_tmp24_, &_tmp25_, 0, 2159, 1, 2794, 2, "Letter", -1, -1);
#line 82 "../src/preferences-dialog.vala"
	_tmp26_ = self->priv->paper_size_model;
#line 82 "../src/preferences-dialog.vala"
	gtk_list_store_append (_tmp26_, &_tmp27_);
#line 82 "../src/preferences-dialog.vala"
	iter = _tmp27_;
#line 83 "../src/preferences-dialog.vala"
	_tmp28_ = self->priv->paper_size_model;
#line 83 "../src/preferences-dialog.vala"
	_tmp29_ = iter;
#line 83 "../src/preferences-dialog.vala"
	gtk_list_store_set (_tmp28_, &_tmp29_, 0, 2159, 1, 3556, 2, "Legal", -1, -1);
#line 84 "../src/preferences-dialog.vala"
	_tmp30_ = self->priv->paper_size_model;
#line 84 "../src/preferences-dialog.vala"
	gtk_list_store_append (_tmp30_, &_tmp31_);
#line 84 "../src/preferences-dialog.vala"
	iter = _tmp31_;
#line 85 "../src/preferences-dialog.vala"
	_tmp32_ = self->priv->paper_size_model;
#line 85 "../src/preferences-dialog.vala"
	_tmp33_ = iter;
#line 85 "../src/preferences-dialog.vala"
	gtk_list_store_set (_tmp32_, &_tmp33_, 0, 1016, 1, 1524, 2, "4×6", -1, -1);
#line 87 "../src/preferences-dialog.vala"
	dpi = g_settings_get_int (_data7_->settings, "text-dpi");
#line 88 "../src/preferences-dialog.vala"
	if (dpi <= 0) {
#line 89 "../src/preferences-dialog.vala"
		dpi = DEFAULT_TEXT_DPI;
#line 974 "preferences-dialog.c"
	}
#line 90 "../src/preferences-dialog.vala"
	_tmp34_ = self->priv->text_dpi_combo;
#line 90 "../src/preferences-dialog.vala"
	preferences_dialog_set_dpi_combo (self, _tmp34_, DEFAULT_TEXT_DPI, dpi);
#line 91 "../src/preferences-dialog.vala"
	_tmp35_ = self->priv->text_dpi_combo;
#line 91 "../src/preferences-dialog.vala"
	g_signal_connect_data (_tmp35_, "changed", (GCallback) ___lambda4__gtk_combo_box_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 92 "../src/preferences-dialog.vala"
	dpi = g_settings_get_int (_data7_->settings, "photo-dpi");
#line 93 "../src/preferences-dialog.vala"
	if (dpi <= 0) {
#line 94 "../src/preferences-dialog.vala"
		dpi = DEFAULT_PHOTO_DPI;
#line 990 "preferences-dialog.c"
	}
#line 95 "../src/preferences-dialog.vala"
	_tmp36_ = self->priv->photo_dpi_combo;
#line 95 "../src/preferences-dialog.vala"
	preferences_dialog_set_dpi_combo (self, _tmp36_, DEFAULT_PHOTO_DPI, dpi);
#line 96 "../src/preferences-dialog.vala"
	_tmp37_ = self->priv->photo_dpi_combo;
#line 96 "../src/preferences-dialog.vala"
	g_signal_connect_data (_tmp37_, "changed", (GCallback) ___lambda5__gtk_combo_box_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 98 "../src/preferences-dialog.vala"
	preferences_dialog_set_page_side (self, (ScanSide) g_settings_get_enum (_data7_->settings, "page-side"));
#line 99 "../src/preferences-dialog.vala"
	_tmp38_ = self->priv->front_side_button;
#line 99 "../src/preferences-dialog.vala"
	g_signal_connect_data ((GtkToggleButton*) _tmp38_, "toggled", (GCallback) ___lambda6__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 100 "../src/preferences-dialog.vala"
	_tmp39_ = self->priv->back_side_button;
#line 100 "../src/preferences-dialog.vala"
	g_signal_connect_data ((GtkToggleButton*) _tmp39_, "toggled", (GCallback) ___lambda7__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 101 "../src/preferences-dialog.vala"
	_tmp40_ = self->priv->both_side_button;
#line 101 "../src/preferences-dialog.vala"
	g_signal_connect_data ((GtkToggleButton*) _tmp40_, "toggled", (GCallback) ___lambda8__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 103 "../src/preferences-dialog.vala"
	_tmp41_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 103 "../src/preferences-dialog.vala"
	g_object_ref_sink (_tmp41_);
#line 103 "../src/preferences-dialog.vala"
	renderer = _tmp41_;
#line 104 "../src/preferences-dialog.vala"
	_tmp42_ = self->priv->paper_size_combo;
#line 104 "../src/preferences-dialog.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp42_, (GtkCellRenderer*) renderer, TRUE);
#line 105 "../src/preferences-dialog.vala"
	_tmp43_ = self->priv->paper_size_combo;
#line 105 "../src/preferences-dialog.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp43_, (GtkCellRenderer*) renderer, "text", 2);
#line 107 "../src/preferences-dialog.vala"
	_tmp44_ = self->priv->brightness_adjustment;
#line 107 "../src/preferences-dialog.vala"
	_tmp45_ = gtk_adjustment_get_lower (_tmp44_);
#line 107 "../src/preferences-dialog.vala"
	_tmp46_ = _tmp45_;
#line 107 "../src/preferences-dialog.vala"
	lower = _tmp46_;
#line 108 "../src/preferences-dialog.vala"
	_tmp47_ = g_strdup_printf ("<small>%s</small>", _ ("Darker"));
#line 108 "../src/preferences-dialog.vala"
	darker_label = _tmp47_;
#line 109 "../src/preferences-dialog.vala"
	_tmp48_ = self->priv->brightness_adjustment;
#line 109 "../src/preferences-dialog.vala"
	_tmp49_ = gtk_adjustment_get_upper (_tmp48_);
#line 109 "../src/preferences-dialog.vala"
	_tmp50_ = _tmp49_;
#line 109 "../src/preferences-dialog.vala"
	upper = _tmp50_;
#line 110 "../src/preferences-dialog.vala"
	_tmp51_ = g_strdup_printf ("<small>%s</small>", _ ("Lighter"));
#line 110 "../src/preferences-dialog.vala"
	lighter_label = _tmp51_;
#line 111 "../src/preferences-dialog.vala"
	_tmp52_ = self->priv->brightness_scale;
#line 111 "../src/preferences-dialog.vala"
	gtk_scale_add_mark (_tmp52_, lower, GTK_POS_BOTTOM, darker_label);
#line 112 "../src/preferences-dialog.vala"
	_tmp53_ = self->priv->brightness_scale;
#line 112 "../src/preferences-dialog.vala"
	gtk_scale_add_mark (_tmp53_, (gdouble) 0, GTK_POS_BOTTOM, NULL);
#line 113 "../src/preferences-dialog.vala"
	_tmp54_ = self->priv->brightness_scale;
#line 113 "../src/preferences-dialog.vala"
	gtk_scale_add_mark (_tmp54_, upper, GTK_POS_BOTTOM, lighter_label);
#line 114 "../src/preferences-dialog.vala"
	_tmp55_ = self->priv->brightness_adjustment;
#line 114 "../src/preferences-dialog.vala"
	gtk_adjustment_set_value (_tmp55_, (gdouble) g_settings_get_int (_data7_->settings, "brightness"));
#line 115 "../src/preferences-dialog.vala"
	_tmp56_ = self->priv->brightness_adjustment;
#line 115 "../src/preferences-dialog.vala"
	g_signal_connect_data (_tmp56_, "value-changed", (GCallback) ___lambda9__gtk_adjustment_value_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 117 "../src/preferences-dialog.vala"
	_tmp57_ = self->priv->contrast_adjustment;
#line 117 "../src/preferences-dialog.vala"
	_tmp58_ = gtk_adjustment_get_lower (_tmp57_);
#line 117 "../src/preferences-dialog.vala"
	_tmp59_ = _tmp58_;
#line 117 "../src/preferences-dialog.vala"
	lower = _tmp59_;
#line 118 "../src/preferences-dialog.vala"
	_tmp60_ = g_strdup_printf ("<small>%s</small>", _ ("Less"));
#line 118 "../src/preferences-dialog.vala"
	less_label = _tmp60_;
#line 119 "../src/preferences-dialog.vala"
	_tmp61_ = self->priv->contrast_adjustment;
#line 119 "../src/preferences-dialog.vala"
	_tmp62_ = gtk_adjustment_get_upper (_tmp61_);
#line 119 "../src/preferences-dialog.vala"
	_tmp63_ = _tmp62_;
#line 119 "../src/preferences-dialog.vala"
	upper = _tmp63_;
#line 120 "../src/preferences-dialog.vala"
	_tmp64_ = g_strdup_printf ("<small>%s</small>", _ ("More"));
#line 120 "../src/preferences-dialog.vala"
	more_label = _tmp64_;
#line 121 "../src/preferences-dialog.vala"
	_tmp65_ = self->priv->contrast_scale;
#line 121 "../src/preferences-dialog.vala"
	gtk_scale_add_mark (_tmp65_, lower, GTK_POS_BOTTOM, less_label);
#line 122 "../src/preferences-dialog.vala"
	_tmp66_ = self->priv->contrast_scale;
#line 122 "../src/preferences-dialog.vala"
	gtk_scale_add_mark (_tmp66_, (gdouble) 0, GTK_POS_BOTTOM, NULL);
#line 123 "../src/preferences-dialog.vala"
	_tmp67_ = self->priv->contrast_scale;
#line 123 "../src/preferences-dialog.vala"
	gtk_scale_add_mark (_tmp67_, upper, GTK_POS_BOTTOM, more_label);
#line 124 "../src/preferences-dialog.vala"
	_tmp68_ = self->priv->contrast_adjustment;
#line 124 "../src/preferences-dialog.vala"
	gtk_adjustment_set_value (_tmp68_, (gdouble) g_settings_get_int (_data7_->settings, "contrast"));
#line 125 "../src/preferences-dialog.vala"
	_tmp69_ = self->priv->contrast_adjustment;
#line 125 "../src/preferences-dialog.vala"
	g_signal_connect_data (_tmp69_, "value-changed", (GCallback) ___lambda10__gtk_adjustment_value_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 127 "../src/preferences-dialog.vala"
	paper_width = g_settings_get_int (_data7_->settings, "paper-width");
#line 128 "../src/preferences-dialog.vala"
	paper_height = g_settings_get_int (_data7_->settings, "paper-height");
#line 129 "../src/preferences-dialog.vala"
	preferences_dialog_set_paper_size (self, paper_width, paper_height);
#line 130 "../src/preferences-dialog.vala"
	_tmp70_ = self->priv->paper_size_combo;
#line 130 "../src/preferences-dialog.vala"
	g_signal_connect_data (_tmp70_, "changed", (GCallback) ___lambda11__gtk_combo_box_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 138 "../src/preferences-dialog.vala"
	preferences_dialog_set_page_delay (self, g_settings_get_int (_data7_->settings, "page-delay"));
#line 139 "../src/preferences-dialog.vala"
	_tmp71_ = self->priv->page_delay_0s_button;
#line 139 "../src/preferences-dialog.vala"
	g_signal_connect_data ((GtkToggleButton*) _tmp71_, "toggled", (GCallback) ___lambda12__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 140 "../src/preferences-dialog.vala"
	_tmp72_ = self->priv->page_delay_3s_button;
#line 140 "../src/preferences-dialog.vala"
	g_signal_connect_data ((GtkToggleButton*) _tmp72_, "toggled", (GCallback) ___lambda13__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 141 "../src/preferences-dialog.vala"
	_tmp73_ = self->priv->page_delay_6s_button;
#line 141 "../src/preferences-dialog.vala"
	g_signal_connect_data ((GtkToggleButton*) _tmp73_, "toggled", (GCallback) ___lambda14__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 142 "../src/preferences-dialog.vala"
	_tmp74_ = self->priv->page_delay_10s_button;
#line 142 "../src/preferences-dialog.vala"
	g_signal_connect_data ((GtkToggleButton*) _tmp74_, "toggled", (GCallback) ___lambda15__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 143 "../src/preferences-dialog.vala"
	_tmp75_ = self->priv->page_delay_15s_button;
#line 143 "../src/preferences-dialog.vala"
	g_signal_connect_data ((GtkToggleButton*) _tmp75_, "toggled", (GCallback) ___lambda16__gtk_toggle_button_toggled, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 146 "../src/preferences-dialog.vala"
	postproc_enabled = g_settings_get_boolean (_data7_->settings, "postproc-enabled");
#line 147 "../src/preferences-dialog.vala"
	_tmp76_ = self->priv->postproc_enable_switch;
#line 147 "../src/preferences-dialog.vala"
	gtk_switch_set_state (_tmp76_, postproc_enabled);
#line 148 "../src/preferences-dialog.vala"
	preferences_dialog_toggle_postproc_visibility (self, postproc_enabled);
#line 149 "../src/preferences-dialog.vala"
	_tmp77_ = self->priv->postproc_enable_switch;
#line 149 "../src/preferences-dialog.vala"
	g_signal_connect_data (_tmp77_, "state-set", (GCallback) ___lambda17__gtk_switch_state_set, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 153 "../src/preferences-dialog.vala"
	_tmp78_ = g_settings_get_string (_data7_->settings, "postproc-script");
#line 153 "../src/preferences-dialog.vala"
	postproc_script = _tmp78_;
#line 154 "../src/preferences-dialog.vala"
	_tmp79_ = self->priv->postproc_script_entry;
#line 154 "../src/preferences-dialog.vala"
	gtk_entry_set_text (_tmp79_, postproc_script);
#line 155 "../src/preferences-dialog.vala"
	_tmp80_ = self->priv->postproc_script_entry;
#line 155 "../src/preferences-dialog.vala"
	g_signal_connect_data ((GtkEditable*) _tmp80_, "changed", (GCallback) ___lambda18__gtk_editable_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 157 "../src/preferences-dialog.vala"
	_tmp81_ = g_settings_get_string (_data7_->settings, "postproc-arguments");
#line 157 "../src/preferences-dialog.vala"
	postproc_arguments = _tmp81_;
#line 158 "../src/preferences-dialog.vala"
	_tmp82_ = self->priv->postproc_args_entry;
#line 158 "../src/preferences-dialog.vala"
	gtk_entry_set_text (_tmp82_, postproc_arguments);
#line 159 "../src/preferences-dialog.vala"
	_tmp83_ = self->priv->postproc_args_entry;
#line 159 "../src/preferences-dialog.vala"
	g_signal_connect_data ((GtkEditable*) _tmp83_, "changed", (GCallback) ___lambda19__gtk_editable_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 161 "../src/preferences-dialog.vala"
	postproc_keep_original = g_settings_get_boolean (_data7_->settings, "postproc-keep-original");
#line 162 "../src/preferences-dialog.vala"
	_tmp84_ = self->priv->postproc_keep_original_switch;
#line 162 "../src/preferences-dialog.vala"
	gtk_switch_set_state (_tmp84_, postproc_keep_original);
#line 163 "../src/preferences-dialog.vala"
	_tmp85_ = self->priv->postproc_keep_original_switch;
#line 163 "../src/preferences-dialog.vala"
	g_signal_connect_data (_tmp85_, "state-set", (GCallback) ___lambda20__gtk_switch_state_set, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 63 "../src/preferences-dialog.vala"
	_g_free0 (postproc_arguments);
#line 63 "../src/preferences-dialog.vala"
	_g_free0 (postproc_script);
#line 63 "../src/preferences-dialog.vala"
	_g_free0 (more_label);
#line 63 "../src/preferences-dialog.vala"
	_g_free0 (less_label);
#line 63 "../src/preferences-dialog.vala"
	_g_free0 (lighter_label);
#line 63 "../src/preferences-dialog.vala"
	_g_free0 (darker_label);
#line 63 "../src/preferences-dialog.vala"
	_g_object_unref0 (renderer);
#line 63 "../src/preferences-dialog.vala"
	block7_data_unref (_data7_);
#line 63 "../src/preferences-dialog.vala"
	_data7_ = NULL;
#line 63 "../src/preferences-dialog.vala"
	return self;
#line 1214 "preferences-dialog.c"
}

PreferencesDialog*
preferences_dialog_new (GSettings* settings)
{
#line 63 "../src/preferences-dialog.vala"
	return preferences_dialog_construct (TYPE_PREFERENCES_DIALOG, settings);
#line 1222 "preferences-dialog.c"
}

static void
preferences_dialog_toggle_postproc_visibility (PreferencesDialog* self,
                                               gboolean enabled)
{
	GtkEntry* _tmp0_;
	GtkContainer* _tmp1_;
	GtkContainer* _tmp2_;
	GtkContainer* _tmp3_;
	GtkContainer* _tmp4_;
	GtkEntry* _tmp5_;
	GtkContainer* _tmp6_;
	GtkContainer* _tmp7_;
	GtkContainer* _tmp8_;
	GtkContainer* _tmp9_;
	GtkSwitch* _tmp10_;
	GtkContainer* _tmp11_;
	GtkContainer* _tmp12_;
	GtkContainer* _tmp13_;
	GtkContainer* _tmp14_;
#line 167 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 168 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->postproc_script_entry;
#line 168 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_widget_get_parent ((GtkWidget*) _tmp0_);
#line 168 "../src/preferences-dialog.vala"
	_tmp2_ = gtk_widget_get_parent ((GtkWidget*) _tmp1_);
#line 168 "../src/preferences-dialog.vala"
	_tmp3_ = gtk_widget_get_parent ((GtkWidget*) _tmp2_);
#line 168 "../src/preferences-dialog.vala"
	_tmp4_ = gtk_widget_get_parent ((GtkWidget*) _tmp3_);
#line 168 "../src/preferences-dialog.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp4_, enabled);
#line 169 "../src/preferences-dialog.vala"
	_tmp5_ = self->priv->postproc_args_entry;
#line 169 "../src/preferences-dialog.vala"
	_tmp6_ = gtk_widget_get_parent ((GtkWidget*) _tmp5_);
#line 169 "../src/preferences-dialog.vala"
	_tmp7_ = gtk_widget_get_parent ((GtkWidget*) _tmp6_);
#line 169 "../src/preferences-dialog.vala"
	_tmp8_ = gtk_widget_get_parent ((GtkWidget*) _tmp7_);
#line 169 "../src/preferences-dialog.vala"
	_tmp9_ = gtk_widget_get_parent ((GtkWidget*) _tmp8_);
#line 169 "../src/preferences-dialog.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp9_, enabled);
#line 170 "../src/preferences-dialog.vala"
	_tmp10_ = self->priv->postproc_keep_original_switch;
#line 170 "../src/preferences-dialog.vala"
	_tmp11_ = gtk_widget_get_parent ((GtkWidget*) _tmp10_);
#line 170 "../src/preferences-dialog.vala"
	_tmp12_ = gtk_widget_get_parent ((GtkWidget*) _tmp11_);
#line 170 "../src/preferences-dialog.vala"
	_tmp13_ = gtk_widget_get_parent ((GtkWidget*) _tmp12_);
#line 170 "../src/preferences-dialog.vala"
	_tmp14_ = gtk_widget_get_parent ((GtkWidget*) _tmp13_);
#line 170 "../src/preferences-dialog.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp14_, enabled);
#line 1282 "preferences-dialog.c"
}

static void
preferences_dialog_set_page_side (PreferencesDialog* self,
                                  ScanSide page_side)
{
#line 173 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 175 "../src/preferences-dialog.vala"
	switch (page_side) {
#line 175 "../src/preferences-dialog.vala"
		case SCAN_SIDE_FRONT:
#line 1295 "preferences-dialog.c"
		{
			GtkRadioButton* _tmp0_;
#line 178 "../src/preferences-dialog.vala"
			_tmp0_ = self->priv->front_side_button;
#line 178 "../src/preferences-dialog.vala"
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, TRUE);
#line 179 "../src/preferences-dialog.vala"
			break;
#line 1304 "preferences-dialog.c"
		}
#line 175 "../src/preferences-dialog.vala"
		case SCAN_SIDE_BACK:
#line 1308 "preferences-dialog.c"
		{
			GtkRadioButton* _tmp1_;
#line 181 "../src/preferences-dialog.vala"
			_tmp1_ = self->priv->back_side_button;
#line 181 "../src/preferences-dialog.vala"
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp1_, TRUE);
#line 182 "../src/preferences-dialog.vala"
			break;
#line 1317 "preferences-dialog.c"
		}
		default:
#line 175 "../src/preferences-dialog.vala"
		case SCAN_SIDE_BOTH:
#line 1322 "preferences-dialog.c"
		{
			GtkRadioButton* _tmp2_;
#line 185 "../src/preferences-dialog.vala"
			_tmp2_ = self->priv->both_side_button;
#line 185 "../src/preferences-dialog.vala"
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp2_, TRUE);
#line 186 "../src/preferences-dialog.vala"
			break;
#line 1331 "preferences-dialog.c"
		}
	}
}

ScanSide
preferences_dialog_get_page_side (PreferencesDialog* self)
{
	GtkRadioButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	ScanSide result;
#line 190 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 192 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->front_side_button;
#line 192 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
#line 192 "../src/preferences-dialog.vala"
	_tmp2_ = _tmp1_;
#line 192 "../src/preferences-dialog.vala"
	if (_tmp2_) {
#line 193 "../src/preferences-dialog.vala"
		result = SCAN_SIDE_FRONT;
#line 193 "../src/preferences-dialog.vala"
		return result;
#line 1357 "preferences-dialog.c"
	} else {
		GtkRadioButton* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 194 "../src/preferences-dialog.vala"
		_tmp3_ = self->priv->back_side_button;
#line 194 "../src/preferences-dialog.vala"
		_tmp4_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp3_);
#line 194 "../src/preferences-dialog.vala"
		_tmp5_ = _tmp4_;
#line 194 "../src/preferences-dialog.vala"
		if (_tmp5_) {
#line 195 "../src/preferences-dialog.vala"
			result = SCAN_SIDE_BACK;
#line 195 "../src/preferences-dialog.vala"
			return result;
#line 1374 "preferences-dialog.c"
		} else {
#line 197 "../src/preferences-dialog.vala"
			result = SCAN_SIDE_BOTH;
#line 197 "../src/preferences-dialog.vala"
			return result;
#line 1380 "preferences-dialog.c"
		}
	}
}

void
preferences_dialog_set_paper_size (PreferencesDialog* self,
                                   gint width,
                                   gint height)
{
	GtkTreeIter iter = {0};
	gboolean have_iter = FALSE;
#line 200 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 1394 "preferences-dialog.c"
	{
		GtkListStore* _tmp0_;
		GtkTreeIter _tmp1_ = {0};
		gboolean _tmp2_;
		gboolean _tmp3_ = FALSE;
#line 205 "../src/preferences-dialog.vala"
		_tmp0_ = self->priv->paper_size_model;
#line 205 "../src/preferences-dialog.vala"
		_tmp2_ = gtk_tree_model_get_iter_first ((GtkTreeModel*) _tmp0_, &_tmp1_);
#line 205 "../src/preferences-dialog.vala"
		iter = _tmp1_;
#line 205 "../src/preferences-dialog.vala"
		have_iter = _tmp2_;
#line 205 "../src/preferences-dialog.vala"
		_tmp3_ = TRUE;
#line 205 "../src/preferences-dialog.vala"
		while (TRUE) {
#line 1412 "preferences-dialog.c"
			gint w = 0;
			gint h = 0;
			GtkListStore* _tmp6_;
			GtkTreeIter _tmp7_;
			gint _tmp8_ = 0;
			gint _tmp9_ = 0;
			gboolean _tmp10_ = FALSE;
#line 205 "../src/preferences-dialog.vala"
			if (!_tmp3_) {
#line 1422 "preferences-dialog.c"
				GtkListStore* _tmp4_;
				gboolean _tmp5_;
#line 207 "../src/preferences-dialog.vala"
				_tmp4_ = self->priv->paper_size_model;
#line 207 "../src/preferences-dialog.vala"
				_tmp5_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp4_, &iter);
#line 207 "../src/preferences-dialog.vala"
				have_iter = _tmp5_;
#line 1431 "preferences-dialog.c"
			}
#line 205 "../src/preferences-dialog.vala"
			_tmp3_ = FALSE;
#line 206 "../src/preferences-dialog.vala"
			if (!have_iter) {
#line 206 "../src/preferences-dialog.vala"
				break;
#line 1439 "preferences-dialog.c"
			}
#line 210 "../src/preferences-dialog.vala"
			_tmp6_ = self->priv->paper_size_model;
#line 210 "../src/preferences-dialog.vala"
			_tmp7_ = iter;
#line 210 "../src/preferences-dialog.vala"
			gtk_tree_model_get ((GtkTreeModel*) _tmp6_, &_tmp7_, 0, &_tmp8_, 1, &_tmp9_, -1, -1);
#line 210 "../src/preferences-dialog.vala"
			w = _tmp8_;
#line 210 "../src/preferences-dialog.vala"
			h = _tmp9_;
#line 211 "../src/preferences-dialog.vala"
			if (w == width) {
#line 211 "../src/preferences-dialog.vala"
				_tmp10_ = h == height;
#line 1455 "preferences-dialog.c"
			} else {
#line 211 "../src/preferences-dialog.vala"
				_tmp10_ = FALSE;
#line 1459 "preferences-dialog.c"
			}
#line 211 "../src/preferences-dialog.vala"
			if (_tmp10_) {
#line 212 "../src/preferences-dialog.vala"
				break;
#line 1465 "preferences-dialog.c"
			}
		}
	}
#line 215 "../src/preferences-dialog.vala"
	if (!have_iter) {
#line 1471 "preferences-dialog.c"
		GtkListStore* _tmp11_;
		GtkTreeIter _tmp12_ = {0};
		gboolean _tmp13_;
#line 216 "../src/preferences-dialog.vala"
		_tmp11_ = self->priv->paper_size_model;
#line 216 "../src/preferences-dialog.vala"
		_tmp13_ = gtk_tree_model_get_iter_first ((GtkTreeModel*) _tmp11_, &_tmp12_);
#line 216 "../src/preferences-dialog.vala"
		iter = _tmp12_;
#line 216 "../src/preferences-dialog.vala"
		have_iter = _tmp13_;
#line 1483 "preferences-dialog.c"
	}
#line 217 "../src/preferences-dialog.vala"
	if (have_iter) {
#line 1487 "preferences-dialog.c"
		GtkComboBox* _tmp14_;
		GtkTreeIter _tmp15_;
#line 218 "../src/preferences-dialog.vala"
		_tmp14_ = self->priv->paper_size_combo;
#line 218 "../src/preferences-dialog.vala"
		_tmp15_ = iter;
#line 218 "../src/preferences-dialog.vala"
		gtk_combo_box_set_active_iter (_tmp14_, &_tmp15_);
#line 1496 "preferences-dialog.c"
	}
}

gint
preferences_dialog_get_text_dpi (PreferencesDialog* self)
{
	GtkTreeIter iter = {0};
	gint dpi = 0;
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	gint result;
#line 221 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 224 "../src/preferences-dialog.vala"
	dpi = DEFAULT_TEXT_DPI;
#line 226 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->text_dpi_combo;
#line 226 "../src/preferences-dialog.vala"
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
#line 226 "../src/preferences-dialog.vala"
	iter = _tmp1_;
#line 226 "../src/preferences-dialog.vala"
	if (_tmp2_) {
#line 1521 "preferences-dialog.c"
		GtkListStore* _tmp3_;
		GtkTreeIter _tmp4_;
		gint _tmp5_ = 0;
#line 227 "../src/preferences-dialog.vala"
		_tmp3_ = self->priv->text_dpi_model;
#line 227 "../src/preferences-dialog.vala"
		_tmp4_ = iter;
#line 227 "../src/preferences-dialog.vala"
		gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, 0, &_tmp5_, -1, -1);
#line 227 "../src/preferences-dialog.vala"
		dpi = _tmp5_;
#line 1533 "preferences-dialog.c"
	}
#line 229 "../src/preferences-dialog.vala"
	result = dpi;
#line 229 "../src/preferences-dialog.vala"
	return result;
#line 1539 "preferences-dialog.c"
}

gint
preferences_dialog_get_photo_dpi (PreferencesDialog* self)
{
	GtkTreeIter iter = {0};
	gint dpi = 0;
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	gint result;
#line 232 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 235 "../src/preferences-dialog.vala"
	dpi = DEFAULT_PHOTO_DPI;
#line 237 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->photo_dpi_combo;
#line 237 "../src/preferences-dialog.vala"
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
#line 237 "../src/preferences-dialog.vala"
	iter = _tmp1_;
#line 237 "../src/preferences-dialog.vala"
	if (_tmp2_) {
#line 1563 "preferences-dialog.c"
		GtkListStore* _tmp3_;
		GtkTreeIter _tmp4_;
		gint _tmp5_ = 0;
#line 238 "../src/preferences-dialog.vala"
		_tmp3_ = self->priv->photo_dpi_model;
#line 238 "../src/preferences-dialog.vala"
		_tmp4_ = iter;
#line 238 "../src/preferences-dialog.vala"
		gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, 0, &_tmp5_, -1, -1);
#line 238 "../src/preferences-dialog.vala"
		dpi = _tmp5_;
#line 1575 "preferences-dialog.c"
	}
#line 240 "../src/preferences-dialog.vala"
	result = dpi;
#line 240 "../src/preferences-dialog.vala"
	return result;
#line 1581 "preferences-dialog.c"
}

gboolean
preferences_dialog_get_paper_size (PreferencesDialog* self,
                                   gint* width,
                                   gint* height)
{
	gint _vala_width = 0;
	gint _vala_height = 0;
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	gboolean result;
#line 243 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 247 "../src/preferences-dialog.vala"
	_vala_height = 0;
#line 247 "../src/preferences-dialog.vala"
	_vala_width = _vala_height;
#line 248 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->paper_size_combo;
#line 248 "../src/preferences-dialog.vala"
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
#line 248 "../src/preferences-dialog.vala"
	iter = _tmp1_;
#line 248 "../src/preferences-dialog.vala"
	if (_tmp2_) {
#line 1610 "preferences-dialog.c"
		GtkListStore* _tmp3_;
		GtkTreeIter _tmp4_;
#line 250 "../src/preferences-dialog.vala"
		_tmp3_ = self->priv->paper_size_model;
#line 250 "../src/preferences-dialog.vala"
		_tmp4_ = iter;
#line 250 "../src/preferences-dialog.vala"
		gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, 0, &_vala_width, 1, &_vala_height, -1, -1);
#line 251 "../src/preferences-dialog.vala"
		result = TRUE;
#line 251 "../src/preferences-dialog.vala"
		if (width) {
#line 251 "../src/preferences-dialog.vala"
			*width = _vala_width;
#line 1625 "preferences-dialog.c"
		}
#line 251 "../src/preferences-dialog.vala"
		if (height) {
#line 251 "../src/preferences-dialog.vala"
			*height = _vala_height;
#line 1631 "preferences-dialog.c"
		}
#line 251 "../src/preferences-dialog.vala"
		return result;
#line 1635 "preferences-dialog.c"
	}
#line 254 "../src/preferences-dialog.vala"
	result = FALSE;
#line 254 "../src/preferences-dialog.vala"
	if (width) {
#line 254 "../src/preferences-dialog.vala"
		*width = _vala_width;
#line 1643 "preferences-dialog.c"
	}
#line 254 "../src/preferences-dialog.vala"
	if (height) {
#line 254 "../src/preferences-dialog.vala"
		*height = _vala_height;
#line 1649 "preferences-dialog.c"
	}
#line 254 "../src/preferences-dialog.vala"
	return result;
#line 1653 "preferences-dialog.c"
}

gint
preferences_dialog_get_brightness (PreferencesDialog* self)
{
	GtkAdjustment* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gint result;
#line 257 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 259 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->brightness_adjustment;
#line 259 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_adjustment_get_value (_tmp0_);
#line 259 "../src/preferences-dialog.vala"
	_tmp2_ = _tmp1_;
#line 259 "../src/preferences-dialog.vala"
	result = (gint) _tmp2_;
#line 259 "../src/preferences-dialog.vala"
	return result;
#line 1675 "preferences-dialog.c"
}

void
preferences_dialog_set_brightness (PreferencesDialog* self,
                                   gint brightness)
{
	GtkAdjustment* _tmp0_;
#line 262 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 264 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->brightness_adjustment;
#line 264 "../src/preferences-dialog.vala"
	gtk_adjustment_set_value (_tmp0_, (gdouble) brightness);
#line 1689 "preferences-dialog.c"
}

gint
preferences_dialog_get_contrast (PreferencesDialog* self)
{
	GtkAdjustment* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gint result;
#line 267 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 269 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->contrast_adjustment;
#line 269 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_adjustment_get_value (_tmp0_);
#line 269 "../src/preferences-dialog.vala"
	_tmp2_ = _tmp1_;
#line 269 "../src/preferences-dialog.vala"
	result = (gint) _tmp2_;
#line 269 "../src/preferences-dialog.vala"
	return result;
#line 1711 "preferences-dialog.c"
}

void
preferences_dialog_set_contrast (PreferencesDialog* self,
                                 gint contrast)
{
	GtkAdjustment* _tmp0_;
#line 272 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 274 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->contrast_adjustment;
#line 274 "../src/preferences-dialog.vala"
	gtk_adjustment_set_value (_tmp0_, (gdouble) contrast);
#line 1725 "preferences-dialog.c"
}

gint
preferences_dialog_get_page_delay (PreferencesDialog* self)
{
	GtkRadioButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gint result;
#line 277 "../src/preferences-dialog.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 279 "../src/preferences-dialog.vala"
	_tmp0_ = self->priv->page_delay_15s_button;
#line 279 "../src/preferences-dialog.vala"
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
#line 279 "../src/preferences-dialog.vala"
	_tmp2_ = _tmp1_;
#line 279 "../src/preferences-dialog.vala"
	if (_tmp2_) {
#line 280 "../src/preferences-dialog.vala"
		result = 15000;
#line 280 "../src/preferences-dialog.vala"
		return result;
#line 1749 "preferences-dialog.c"
	} else {
		GtkRadioButton* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 281 "../src/preferences-dialog.vala"
		_tmp3_ = self->priv->page_delay_10s_button;
#line 281 "../src/preferences-dialog.vala"
		_tmp4_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp3_);
#line 281 "../src/preferences-dialog.vala"
		_tmp5_ = _tmp4_;
#line 281 "../src/preferences-dialog.vala"
		if (_tmp5_) {
#line 282 "../src/preferences-dialog.vala"
			result = 10000;
#line 282 "../src/preferences-dialog.vala"
			return result;
#line 1766 "preferences-dialog.c"
		} else {
			GtkRadioButton* _tmp6_;
			gboolean _tmp7_;
			gboolean _tmp8_;
#line 283 "../src/preferences-dialog.vala"
			_tmp6_ = self->priv->page_delay_6s_button;
#line 283 "../src/preferences-dialog.vala"
			_tmp7_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp6_);
#line 283 "../src/preferences-dialog.vala"
			_tmp8_ = _tmp7_;
#line 283 "../src/preferences-dialog.vala"
			if (_tmp8_) {
#line 284 "../src/preferences-dialog.vala"
				result = 6000;
#line 284 "../src/preferences-dialog.vala"
				return result;
#line 1783 "preferences-dialog.c"
			} else {
				GtkRadioButton* _tmp9_;
				gboolean _tmp10_;
				gboolean _tmp11_;
#line 285 "../src/preferences-dialog.vala"
				_tmp9_ = self->priv->page_delay_3s_button;
#line 285 "../src/preferences-dialog.vala"
				_tmp10_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp9_);
#line 285 "../src/preferences-dialog.vala"
				_tmp11_ = _tmp10_;
#line 285 "../src/preferences-dialog.vala"
				if (_tmp11_) {
#line 286 "../src/preferences-dialog.vala"
					result = 3000;
#line 286 "../src/preferences-dialog.vala"
					return result;
#line 1800 "preferences-dialog.c"
				} else {
#line 288 "../src/preferences-dialog.vala"
					result = 0;
#line 288 "../src/preferences-dialog.vala"
					return result;
#line 1806 "preferences-dialog.c"
				}
			}
		}
	}
}

void
preferences_dialog_set_page_delay (PreferencesDialog* self,
                                   gint page_delay)
{
#line 291 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 293 "../src/preferences-dialog.vala"
	if (page_delay >= 15000) {
#line 1821 "preferences-dialog.c"
		GtkRadioButton* _tmp0_;
#line 294 "../src/preferences-dialog.vala"
		_tmp0_ = self->priv->page_delay_15s_button;
#line 294 "../src/preferences-dialog.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, TRUE);
#line 1827 "preferences-dialog.c"
	} else {
#line 295 "../src/preferences-dialog.vala"
		if (page_delay >= 10000) {
#line 1831 "preferences-dialog.c"
			GtkRadioButton* _tmp1_;
#line 296 "../src/preferences-dialog.vala"
			_tmp1_ = self->priv->page_delay_10s_button;
#line 296 "../src/preferences-dialog.vala"
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp1_, TRUE);
#line 1837 "preferences-dialog.c"
		} else {
#line 297 "../src/preferences-dialog.vala"
			if (page_delay >= 6000) {
#line 1841 "preferences-dialog.c"
				GtkRadioButton* _tmp2_;
#line 298 "../src/preferences-dialog.vala"
				_tmp2_ = self->priv->page_delay_6s_button;
#line 298 "../src/preferences-dialog.vala"
				gtk_toggle_button_set_active ((GtkToggleButton*) _tmp2_, TRUE);
#line 1847 "preferences-dialog.c"
			} else {
#line 299 "../src/preferences-dialog.vala"
				if (page_delay >= 3000) {
#line 1851 "preferences-dialog.c"
					GtkRadioButton* _tmp3_;
#line 300 "../src/preferences-dialog.vala"
					_tmp3_ = self->priv->page_delay_3s_button;
#line 300 "../src/preferences-dialog.vala"
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp3_, TRUE);
#line 1857 "preferences-dialog.c"
				} else {
					GtkRadioButton* _tmp4_;
#line 302 "../src/preferences-dialog.vala"
					_tmp4_ = self->priv->page_delay_0s_button;
#line 302 "../src/preferences-dialog.vala"
					gtk_toggle_button_set_active ((GtkToggleButton*) _tmp4_, TRUE);
#line 1864 "preferences-dialog.c"
				}
			}
		}
	}
}

static void
preferences_dialog_set_dpi_combo (PreferencesDialog* self,
                                  GtkComboBox* combo,
                                  gint default_dpi,
                                  gint current_dpi)
{
	GtkCellRendererText* renderer = NULL;
	GtkCellRendererText* _tmp0_;
	GtkCellRendererText* _tmp1_;
	GtkCellRendererText* _tmp2_;
	GtkListStore* model = NULL;
	GtkTreeModel* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkListStore* _tmp5_;
	gint* scan_resolutions = NULL;
	gint* _tmp6_;
	gint scan_resolutions_length1;
	gint _scan_resolutions_size_;
	gint* _tmp7_;
	gint _tmp7__length1;
#line 305 "../src/preferences-dialog.vala"
	g_return_if_fail (self != NULL);
#line 305 "../src/preferences-dialog.vala"
	g_return_if_fail (combo != NULL);
#line 307 "../src/preferences-dialog.vala"
	_tmp0_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 307 "../src/preferences-dialog.vala"
	g_object_ref_sink (_tmp0_);
#line 307 "../src/preferences-dialog.vala"
	renderer = _tmp0_;
#line 308 "../src/preferences-dialog.vala"
	_tmp1_ = renderer;
#line 308 "../src/preferences-dialog.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) combo, (GtkCellRenderer*) _tmp1_, TRUE);
#line 309 "../src/preferences-dialog.vala"
	_tmp2_ = renderer;
#line 309 "../src/preferences-dialog.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) combo, (GtkCellRenderer*) _tmp2_, "text", 1);
#line 311 "../src/preferences-dialog.vala"
	_tmp3_ = gtk_combo_box_get_model (combo);
#line 311 "../src/preferences-dialog.vala"
	_tmp4_ = _tmp3_;
#line 311 "../src/preferences-dialog.vala"
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, gtk_list_store_get_type ()) ? ((GtkListStore*) _tmp4_) : NULL);
#line 311 "../src/preferences-dialog.vala"
	model = _tmp5_;
#line 312 "../src/preferences-dialog.vala"
	_tmp6_ = g_new0 (gint, 7);
#line 312 "../src/preferences-dialog.vala"
	_tmp6_[0] = 75;
#line 312 "../src/preferences-dialog.vala"
	_tmp6_[1] = 150;
#line 312 "../src/preferences-dialog.vala"
	_tmp6_[2] = 200;
#line 312 "../src/preferences-dialog.vala"
	_tmp6_[3] = 300;
#line 312 "../src/preferences-dialog.vala"
	_tmp6_[4] = 600;
#line 312 "../src/preferences-dialog.vala"
	_tmp6_[5] = 1200;
#line 312 "../src/preferences-dialog.vala"
	_tmp6_[6] = 2400;
#line 312 "../src/preferences-dialog.vala"
	scan_resolutions = _tmp6_;
#line 312 "../src/preferences-dialog.vala"
	scan_resolutions_length1 = 7;
#line 312 "../src/preferences-dialog.vala"
	_scan_resolutions_size_ = scan_resolutions_length1;
#line 313 "../src/preferences-dialog.vala"
	_tmp7_ = scan_resolutions;
#line 313 "../src/preferences-dialog.vala"
	_tmp7__length1 = scan_resolutions_length1;
#line 1943 "preferences-dialog.c"
	{
		gint* dpi_collection = NULL;
		gint dpi_collection_length1 = 0;
		gint _dpi_collection_size_ = 0;
		gint dpi_it = 0;
#line 313 "../src/preferences-dialog.vala"
		dpi_collection = _tmp7_;
#line 313 "../src/preferences-dialog.vala"
		dpi_collection_length1 = _tmp7__length1;
#line 313 "../src/preferences-dialog.vala"
		for (dpi_it = 0; dpi_it < dpi_collection_length1; dpi_it = dpi_it + 1) {
#line 1955 "preferences-dialog.c"
			gint dpi = 0;
#line 313 "../src/preferences-dialog.vala"
			dpi = dpi_collection[dpi_it];
#line 1959 "preferences-dialog.c"
			{
				gchar* label = NULL;
				GtkTreeIter iter = {0};
				GtkListStore* _tmp12_;
				GtkTreeIter _tmp13_ = {0};
				GtkListStore* _tmp14_;
				GtkTreeIter _tmp15_;
				const gchar* _tmp16_;
#line 316 "../src/preferences-dialog.vala"
				if (dpi == default_dpi) {
#line 1970 "preferences-dialog.c"
					gchar* _tmp8_;
#line 318 "../src/preferences-dialog.vala"
					_tmp8_ = g_strdup_printf (_ ("%d dpi (default)"), dpi);
#line 318 "../src/preferences-dialog.vala"
					_g_free0 (label);
#line 318 "../src/preferences-dialog.vala"
					label = _tmp8_;
#line 1978 "preferences-dialog.c"
				} else {
#line 319 "../src/preferences-dialog.vala"
					if (dpi == 75) {
#line 1982 "preferences-dialog.c"
						gchar* _tmp9_;
#line 321 "../src/preferences-dialog.vala"
						_tmp9_ = g_strdup_printf (_ ("%d dpi (draft)"), dpi);
#line 321 "../src/preferences-dialog.vala"
						_g_free0 (label);
#line 321 "../src/preferences-dialog.vala"
						label = _tmp9_;
#line 1990 "preferences-dialog.c"
					} else {
#line 322 "../src/preferences-dialog.vala"
						if (dpi == 1200) {
#line 1994 "preferences-dialog.c"
							gchar* _tmp10_;
#line 324 "../src/preferences-dialog.vala"
							_tmp10_ = g_strdup_printf (_ ("%d dpi (high resolution)"), dpi);
#line 324 "../src/preferences-dialog.vala"
							_g_free0 (label);
#line 324 "../src/preferences-dialog.vala"
							label = _tmp10_;
#line 2002 "preferences-dialog.c"
						} else {
							gchar* _tmp11_;
#line 327 "../src/preferences-dialog.vala"
							_tmp11_ = g_strdup_printf (_ ("%d dpi"), dpi);
#line 327 "../src/preferences-dialog.vala"
							_g_free0 (label);
#line 327 "../src/preferences-dialog.vala"
							label = _tmp11_;
#line 2011 "preferences-dialog.c"
						}
					}
				}
#line 330 "../src/preferences-dialog.vala"
				_tmp12_ = model;
#line 330 "../src/preferences-dialog.vala"
				gtk_list_store_append (_tmp12_, &_tmp13_);
#line 330 "../src/preferences-dialog.vala"
				iter = _tmp13_;
#line 331 "../src/preferences-dialog.vala"
				_tmp14_ = model;
#line 331 "../src/preferences-dialog.vala"
				_tmp15_ = iter;
#line 331 "../src/preferences-dialog.vala"
				_tmp16_ = label;
#line 331 "../src/preferences-dialog.vala"
				gtk_list_store_set (_tmp14_, &_tmp15_, 0, dpi, 1, _tmp16_, -1, -1);
#line 333 "../src/preferences-dialog.vala"
				if (dpi == current_dpi) {
#line 2031 "preferences-dialog.c"
					GtkTreeIter _tmp17_;
#line 334 "../src/preferences-dialog.vala"
					_tmp17_ = iter;
#line 334 "../src/preferences-dialog.vala"
					gtk_combo_box_set_active_iter (combo, &_tmp17_);
#line 2037 "preferences-dialog.c"
				}
#line 313 "../src/preferences-dialog.vala"
				_g_free0 (label);
#line 2041 "preferences-dialog.c"
			}
		}
	}
#line 305 "../src/preferences-dialog.vala"
	scan_resolutions = (g_free (scan_resolutions), NULL);
#line 305 "../src/preferences-dialog.vala"
	_g_object_unref0 (model);
#line 305 "../src/preferences-dialog.vala"
	_g_object_unref0 (renderer);
#line 2051 "preferences-dialog.c"
}

static void
preferences_dialog_class_init (PreferencesDialogClass * klass,
                               gpointer klass_data)
{
#line 14 "../src/preferences-dialog.vala"
	preferences_dialog_parent_class = g_type_class_peek_parent (klass);
#line 14 "../src/preferences-dialog.vala"
	g_type_class_adjust_private_offset (klass, &PreferencesDialog_private_offset);
#line 14 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = preferences_dialog_finalize;
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/SimpleScan/ui/preferences-dialog.ui");
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "text_dpi_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, text_dpi_combo));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "photo_dpi_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, photo_dpi_combo));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "paper_size_combo", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, paper_size_combo));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "brightness_scale", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, brightness_scale));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "contrast_scale", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, contrast_scale));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_0s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_0s_button));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_3s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_3s_button));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_6s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_6s_button));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_10s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_10s_button));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "page_delay_15s_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, page_delay_15s_button));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "text_dpi_model", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, text_dpi_model));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "photo_dpi_model", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, photo_dpi_model));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "front_side_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, front_side_button));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "back_side_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, back_side_button));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "both_side_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, both_side_button));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "paper_size_model", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, paper_size_model));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "brightness_adjustment", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, brightness_adjustment));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "contrast_adjustment", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, contrast_adjustment));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "postproc_enable_switch", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, postproc_enable_switch));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "postproc_script_entry", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, postproc_script_entry));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "postproc_args_entry", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, postproc_args_entry));
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "postproc_keep_original_switch", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, postproc_keep_original_switch));
#line 2110 "preferences-dialog.c"
}

static void
preferences_dialog_instance_init (PreferencesDialog * self,
                                  gpointer klass)
{
#line 14 "../src/preferences-dialog.vala"
	self->priv = preferences_dialog_get_instance_private (self);
#line 14 "../src/preferences-dialog.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2121 "preferences-dialog.c"
}

static void
preferences_dialog_finalize (GObject * obj)
{
	PreferencesDialog * self;
#line 14 "../src/preferences-dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREFERENCES_DIALOG, PreferencesDialog);
#line 16 "../src/preferences-dialog.vala"
	_g_object_unref0 (self->priv->settings);
#line 14 "../src/preferences-dialog.vala"
	G_OBJECT_CLASS (preferences_dialog_parent_class)->finalize (obj);
#line 2134 "preferences-dialog.c"
}

static GType
preferences_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PreferencesDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) preferences_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PreferencesDialog), 0, (GInstanceInitFunc) preferences_dialog_instance_init, NULL };
	GType preferences_dialog_type_id;
	preferences_dialog_type_id = g_type_register_static (hdy_preferences_window_get_type (), "PreferencesDialog", &g_define_type_info, 0);
	PreferencesDialog_private_offset = g_type_add_instance_private (preferences_dialog_type_id, sizeof (PreferencesDialogPrivate));
	return preferences_dialog_type_id;
}

GType
preferences_dialog_get_type (void)
{
	static volatile gsize preferences_dialog_type_id__once = 0;
	if (g_once_init_enter (&preferences_dialog_type_id__once)) {
		GType preferences_dialog_type_id;
		preferences_dialog_type_id = preferences_dialog_get_type_once ();
		g_once_init_leave (&preferences_dialog_type_id__once, preferences_dialog_type_id);
	}
	return preferences_dialog_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

